/*
 * The Apache Software License, Version 1.1
 *
 *
 * Copyright (c) 1999-2004 The Apache Software Foundation.  All rights 
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *	  notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *	  notice, this list of conditions and the following disclaimer in
 *	  the documentation and/or other materials provided with the
 *	  distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *	  if any, must include the following acknowledgment:  
 *		 "This product includes software developed by the
 *		  Apache Software Foundation (http://www.apache.org/)."
 *	  Alternately, this acknowledgment may appear in the software itself,
 *	  if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Xalan" and "Apache Software Foundation" must
 *	  not be used to endorse or promote products derived from this
 *	  software without prior written permission. For written 
 *	  permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *	  nor may "Apache" appear in their name, without prior written
 *	  permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.	IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation and was
 * originally based on software copyright (c) 1999, International
 * Business Machines, Inc., http://www.ibm.com.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 */
#if !defined(XERCESWRAPPERTYPES_HEADER_GUARD_1357924680)
#define XERCESWRAPPERTYPES_HEADER_GUARD_1357924680



#include <xalanc/XercesParserLiaison/XercesParserLiaisonDefinitions.hpp>



XALAN_DECLARE_XERCES_CLASS(DOMAttr)
XALAN_DECLARE_XERCES_CLASS(DOMCharacterData)
XALAN_DECLARE_XERCES_CLASS(DOMComment)
XALAN_DECLARE_XERCES_CLASS(DOMCDATASection)
XALAN_DECLARE_XERCES_CLASS(DOMDocument)
XALAN_DECLARE_XERCES_CLASS(DOMDocumentFragment)
XALAN_DECLARE_XERCES_CLASS(DOMImplementation)
XALAN_DECLARE_XERCES_CLASS(DOMElement)
XALAN_DECLARE_XERCES_CLASS(DOMEntity)
XALAN_DECLARE_XERCES_CLASS(DOMEntityReference)
XALAN_DECLARE_XERCES_CLASS(DOMNode)
XALAN_DECLARE_XERCES_CLASS(DOMText)
XALAN_DECLARE_XERCES_CLASS(DOMNamedNodeMap)
XALAN_DECLARE_XERCES_CLASS(DOMNodeList)
XALAN_DECLARE_XERCES_CLASS(DOMNotation)
XALAN_DECLARE_XERCES_CLASS(DOMProcessingInstruction)
XALAN_DECLARE_XERCES_CLASS(DOMText)
XALAN_DECLARE_XERCES_CLASS(DOMDocumentType)
XALAN_DECLARE_XERCES_CLASS(DOMException)



XALAN_CPP_NAMESPACE_BEGIN



typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMAttr				DOMAttrType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMCharacterData	DOMCharacterDataType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMComment			DOMCommentType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMCDATASection		DOMCDATASectionType;
// These next two have an extra '_' because they collide without it...
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMDocumentType		DOMDocumentType_Type;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument			DOMDocument_Type;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMDocumentFragment	DOMDocumentFragmentType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMImplementation	DOMImplementationType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMElement			DOMElementType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMEntity			DOMEntityType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMEntityReference	DOMEntityReferenceType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMNode				DOMNodeType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMText				DOMTextType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMNamedNodeMap		DOMNamedNodeMapType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMNodeList			DOMNodeListType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMNotation			DOMNotationType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMProcessingInstruction	DOMProcessingInstructionType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMText				DOMTextType;
typedef XERCES_CPP_NAMESPACE_QUALIFIER DOMException			DOMExceptionType;
typedef XMLSize_t											XMLSizeType;



XALAN_CPP_NAMESPACE_END



#endif	// !defined(XERCESWRAPPERTYPES_HEADER_GUARD_1357924680)
