# This makefile has been automatically generated from the OpenSSL distribution.
# This single makefile will build the complete OpenSSL distribution and
# by default leave the 'intertesting' output files in .\out and the stuff
# that needs deleting in .\tmp.
# The file was generated by running 'make makefile.one', which
# does a 'make files', which writes all the environment variables from all
# the makefiles to the file call MINFO.  This file is used by
# util\mk1mf.pl to generate makefile.one.
# The 'makefile per directory' system suites me when developing this
# library and also so I can 'distribute' indervidual library sections.
# The one monster makefile better suits building in non-unix
# environments.

INSTALLTOP=\usr\local\ssl

# Set your compiler options
PLATFORM=VC-W31-32
CC=cl
CFLAG=/ALw /Gx- /Gt256 /Gf /G2 /f- /Ocgnotb2 /W3 /WX -DL_ENDIAN /nologo -DOPENSSL_SYSNAME_WIN16 -DOPENSSL_NO_KRB5    
APP_CFLAG=/Gw /FPi87
LIB_CFLAG=/Gw -D_WINDLL -D_DLL
SHLIB_CFLAG=
APP_EX_OBJ=
SHLIB_EX_OBJ=
# add extra libraries to this define, for solaris -lsocket -lnsl would
# be added
EX_LIBS=oldnames llibcewq libw winsock   

# The OpenSSL directory
SRC_D=.

LINK=link
LFLAGS= /FARCALL /NOLOGO /NOD /SEG:1024 /ONERROR:NOEXE /NOE /PACKC:60000 /PACKD:60000 /STACK:20000 /ALIGN:256

BN_ASM_OBJ=crypto\bn\asm\x86w32.obj
BN_ASM_SRC=crypto\bn\asm\x86w32.asm
BNCO_ASM_OBJ=
BNCO_ASM_SRC=
DES_ENC_OBJ=
DES_ENC_SRC=
BF_ENC_OBJ=
BF_ENC_SRC=
CAST_ENC_OBJ=
CAST_ENC_SRC=
RC4_ENC_OBJ=
RC4_ENC_SRC=
RC5_ENC_OBJ=
RC5_ENC_SRC=
MD5_ASM_OBJ=
MD5_ASM_SRC=
SHA1_ASM_OBJ=
SHA1_ASM_SRC=
RMD160_ASM_OBJ=
RMD160_ASM_SRC=

# The output directory for everything intersting
OUT_D=out16dll
# The output directory for all the temporary muck
TMP_D=tmp16dll
# The output directory for the header files
INC_D=inc16
INCO_D=inc16\openssl

CP=copy
RM=del
RANLIB=
MKDIR=-mkdir
MKLIB=lib /PAGESIZE:1024
MLFLAGS= /FARCALL /NOLOGO /NOD /SEG:1024 /ONERROR:NOEXE /NOE /PACKC:60000 /PACKD:60000
ASM=ml /Cp /c /Cx

######################################################
# You should not need to touch anything below this point
######################################################

E_EXE=openssl
SSL=ssleay16
CRYPTO=libeay16

# BIN_D  - Binary output directory
# TEST_D - Binary test file output directory
# LIB_D  - library output directory
# Note: if you change these point to different directories then uncomment out
# the lines around the 'NB' comment below.
# 
BIN_D=$(OUT_D)
TEST_D=$(OUT_D)
LIB_D=$(OUT_D)

# INCL_D - local library directory
# OBJ_D  - temp object file directory
OBJ_D=$(TMP_D)
INCL_D=$(TMP_D)

O_SSL=     $(LIB_D)\$(SSL).dll
O_CRYPTO=  $(LIB_D)\$(CRYPTO).dll
SO_SSL=    $(SSL)
SO_CRYPTO= $(CRYPTO)
L_SSL=     $(LIB_D)\$(SSL).lib
L_CRYPTO=  $(LIB_D)\$(CRYPTO).lib

L_LIBS= $(L_SSL) $(L_CRYPTO)

######################################################
# Don't touch anything below this point
######################################################

INC=-I$(INC_D) -I$(INCL_D)
APP_CFLAGS=$(INC) $(CFLAG) $(APP_CFLAG)
LIB_CFLAGS=$(INC) $(CFLAG) $(LIB_CFLAG)
SHLIB_CFLAGS=$(INC) $(CFLAG) $(LIB_CFLAG) $(SHLIB_CFLAG)
LIBS_DEP=$(O_CRYPTO) $(O_SSL)

#############################################
HEADER=$(INCL_D)\e_os.h \
	$(INCL_D)\cryptlib.h $(INCL_D)\buildinf.h $(INCL_D)\md32_common.h \
	$(INCL_D)\o_time.h $(INCL_D)\o_str.h $(INCL_D)\md4_locl.h \
	$(INCL_D)\md5_locl.h $(INCL_D)\sha_locl.h $(INCL_D)\rmd_locl.h \
	$(INCL_D)\rmdconst.h $(INCL_D)\des_locl.h $(INCL_D)\rpc_des.h \
	$(INCL_D)\spr.h $(INCL_D)\des_ver.h $(INCL_D)\rc2_locl.h \
	$(INCL_D)\rc4_locl.h $(INCL_D)\rc5_locl.h $(INCL_D)\idea_lcl.h \
	$(INCL_D)\bf_pi.h $(INCL_D)\bf_locl.h $(INCL_D)\cast_s.h \
	$(INCL_D)\cast_lcl.h $(INCL_D)\aes_locl.h $(INCL_D)\bn_lcl.h \
	$(INCL_D)\bn_prime.h $(INCL_D)\ec_lcl.h $(INCL_D)\bss_file.c \
	$(INCL_D)\obj_dat.h $(INCL_D)\conf_def.h $(INCL_D)\ui_locl.h \
	$(INCL_D)\fips_err.h $(INCL_D)\fips_aes_locl.h $(INCL_D)\fips_des_locl.h \
	$(INCL_D)\fips_sha_locl.h $(INCL_D)\fips_md32_common.h $(INCL_D)\ssl_locl.h \
	$(INCL_D)\kssl_lcl.h $(INCL_D)\apps.h $(INCL_D)\progs.h \
	$(INCL_D)\s_apps.h $(INCL_D)\testdsa.h $(INCL_D)\testrsa.h

EXHEADER=$(INCO_D)\e_os2.h \
	$(INCO_D)\crypto.h $(INCO_D)\tmdiff.h $(INCO_D)\opensslv.h \
	$(INCO_D)\opensslconf.h $(INCO_D)\ebcdic.h $(INCO_D)\symhacks.h \
	$(INCO_D)\ossl_typ.h $(INCO_D)\md2.h $(INCO_D)\md4.h \
	$(INCO_D)\md5.h $(INCO_D)\sha.h $(INCO_D)\mdc2.h \
	$(INCO_D)\hmac.h $(INCO_D)\ripemd.h $(INCO_D)\des.h \
	$(INCO_D)\des_old.h $(INCO_D)\rc2.h $(INCO_D)\rc4.h \
	$(INCO_D)\rc5.h $(INCO_D)\idea.h $(INCO_D)\blowfish.h \
	$(INCO_D)\cast.h $(INCO_D)\aes.h $(INCO_D)\bn.h \
	$(INCO_D)\rsa.h $(INCO_D)\dsa.h $(INCO_D)\dso.h \
	$(INCO_D)\dh.h $(INCO_D)\ec.h $(INCO_D)\buffer.h \
	$(INCO_D)\bio.h $(INCO_D)\stack.h $(INCO_D)\safestack.h \
	$(INCO_D)\lhash.h $(INCO_D)\rand.h $(INCO_D)\err.h \
	$(INCO_D)\objects.h $(INCO_D)\obj_mac.h $(INCO_D)\evp.h \
	$(INCO_D)\asn1.h $(INCO_D)\asn1_mac.h $(INCO_D)\asn1t.h \
	$(INCO_D)\pem.h $(INCO_D)\pem2.h $(INCO_D)\x509.h \
	$(INCO_D)\x509_vfy.h $(INCO_D)\x509v3.h $(INCO_D)\conf.h \
	$(INCO_D)\conf_api.h $(INCO_D)\txt_db.h $(INCO_D)\pkcs7.h \
	$(INCO_D)\pkcs12.h $(INCO_D)\comp.h $(INCO_D)\engine.h \
	$(INCO_D)\ocsp.h $(INCO_D)\ui.h $(INCO_D)\ui_compat.h \
	$(INCO_D)\krb5_asn.h $(INCO_D)\fips.h $(INCO_D)\fips_rand.h \
	$(INCO_D)\fips_sha.h $(INCO_D)\ssl.h $(INCO_D)\ssl2.h \
	$(INCO_D)\ssl3.h $(INCO_D)\ssl23.h $(INCO_D)\tls1.h \
	$(INCO_D)\kssl.h

T_OBJ=$(OBJ_D)\md2test.obj \
	$(OBJ_D)\md4test.obj $(OBJ_D)\md5test.obj $(OBJ_D)\shatest.obj \
	$(OBJ_D)\sha1test.obj $(OBJ_D)\mdc2test.obj $(OBJ_D)\hmactest.obj \
	$(OBJ_D)\rmdtest.obj $(OBJ_D)\destest.obj $(OBJ_D)\rc2test.obj \
	$(OBJ_D)\rc4test.obj $(OBJ_D)\rc5test.obj $(OBJ_D)\ideatest.obj \
	$(OBJ_D)\bftest.obj $(OBJ_D)\casttest.obj $(OBJ_D)\bntest.obj \
	$(OBJ_D)\exptest.obj $(OBJ_D)\rsa_test.obj $(OBJ_D)\dsatest.obj \
	$(OBJ_D)\dhtest.obj $(OBJ_D)\ectest.obj $(OBJ_D)\randtest.obj \
	$(OBJ_D)\evp_test.obj $(OBJ_D)\enginetest.obj $(OBJ_D)\fips_test_suite.obj \
	$(OBJ_D)\fips_aesavs.obj $(OBJ_D)\fips_desmovs.obj $(OBJ_D)\fips_dsatest.obj \
	$(OBJ_D)\fips_dssvs.obj $(OBJ_D)\fips_hmactest.obj $(OBJ_D)\fips_randtest.obj \
	$(OBJ_D)\fips_rngvs.obj $(OBJ_D)\fips_rsavtest.obj $(OBJ_D)\fips_rsastest.obj \
	$(OBJ_D)\fips_rsagtest.obj $(OBJ_D)\fips_shatest.obj $(OBJ_D)\ssltest.obj

E_OBJ=$(OBJ_D)\verify.obj \
	$(OBJ_D)\asn1pars.obj $(OBJ_D)\req.obj $(OBJ_D)\dgst.obj \
	$(OBJ_D)\dh.obj $(OBJ_D)\dhparam.obj $(OBJ_D)\enc.obj \
	$(OBJ_D)\passwd.obj $(OBJ_D)\gendh.obj $(OBJ_D)\errstr.obj \
	$(OBJ_D)\ca.obj $(OBJ_D)\pkcs7.obj $(OBJ_D)\crl2p7.obj \
	$(OBJ_D)\crl.obj $(OBJ_D)\rsa.obj $(OBJ_D)\rsautl.obj \
	$(OBJ_D)\dsa.obj $(OBJ_D)\dsaparam.obj $(OBJ_D)\x509.obj \
	$(OBJ_D)\genrsa.obj $(OBJ_D)\gendsa.obj $(OBJ_D)\s_server.obj \
	$(OBJ_D)\s_client.obj $(OBJ_D)\speed.obj $(OBJ_D)\s_time.obj \
	$(OBJ_D)\apps.obj $(OBJ_D)\s_cb.obj $(OBJ_D)\s_socket.obj \
	$(OBJ_D)\app_rand.obj $(OBJ_D)\version.obj $(OBJ_D)\sess_id.obj \
	$(OBJ_D)\ciphers.obj $(OBJ_D)\nseq.obj $(OBJ_D)\pkcs12.obj \
	$(OBJ_D)\pkcs8.obj $(OBJ_D)\spkac.obj $(OBJ_D)\smime.obj \
	$(OBJ_D)\rand.obj $(OBJ_D)\engine.obj $(OBJ_D)\ocsp.obj \
	$(OBJ_D)\prime.obj $(OBJ_D)\openssl.obj

SSLOBJ=$(OBJ_D)\s2_meth.obj \
	$(OBJ_D)\s2_srvr.obj $(OBJ_D)\s2_clnt.obj $(OBJ_D)\s2_lib.obj \
	$(OBJ_D)\s2_enc.obj $(OBJ_D)\s2_pkt.obj $(OBJ_D)\s3_meth.obj \
	$(OBJ_D)\s3_srvr.obj $(OBJ_D)\s3_clnt.obj $(OBJ_D)\s3_lib.obj \
	$(OBJ_D)\s3_enc.obj $(OBJ_D)\s3_pkt.obj $(OBJ_D)\s3_both.obj \
	$(OBJ_D)\s23_meth.obj $(OBJ_D)\s23_srvr.obj $(OBJ_D)\s23_clnt.obj \
	$(OBJ_D)\s23_lib.obj $(OBJ_D)\s23_pkt.obj $(OBJ_D)\t1_meth.obj \
	$(OBJ_D)\t1_srvr.obj $(OBJ_D)\t1_clnt.obj $(OBJ_D)\t1_lib.obj \
	$(OBJ_D)\t1_enc.obj $(OBJ_D)\ssl_lib.obj $(OBJ_D)\ssl_err2.obj \
	$(OBJ_D)\ssl_cert.obj $(OBJ_D)\ssl_sess.obj $(OBJ_D)\ssl_ciph.obj \
	$(OBJ_D)\ssl_stat.obj $(OBJ_D)\ssl_rsa.obj $(OBJ_D)\ssl_asn1.obj \
	$(OBJ_D)\ssl_txt.obj $(OBJ_D)\ssl_algs.obj $(OBJ_D)\bio_ssl.obj \
	$(OBJ_D)\ssl_err.obj $(OBJ_D)\kssl.obj

CRYPTOOBJ=$(OBJ_D)\cryptlib.obj \
	$(OBJ_D)\mem.obj $(OBJ_D)\mem_clr.obj $(OBJ_D)\mem_dbg.obj \
	$(OBJ_D)\cversion.obj $(OBJ_D)\ex_data.obj $(OBJ_D)\tmdiff.obj \
	$(OBJ_D)\cpt_err.obj $(OBJ_D)\ebcdic.obj $(OBJ_D)\uid.obj \
	$(OBJ_D)\o_time.obj $(OBJ_D)\o_str.obj $(OBJ_D)\md2_dgst.obj \
	$(OBJ_D)\md2_one.obj $(OBJ_D)\md4_dgst.obj $(OBJ_D)\md4_one.obj \
	$(OBJ_D)\md5_dgst.obj $(OBJ_D)\md5_one.obj $(OBJ_D)\sha_dgst.obj \
	$(OBJ_D)\sha1dgst.obj $(OBJ_D)\sha_one.obj $(OBJ_D)\sha1_one.obj \
	$(OBJ_D)\mdc2dgst.obj $(OBJ_D)\mdc2_one.obj $(OBJ_D)\hmac.obj \
	$(OBJ_D)\rmd_dgst.obj $(OBJ_D)\rmd_one.obj $(OBJ_D)\set_key.obj \
	$(OBJ_D)\ecb_enc.obj $(OBJ_D)\cbc_enc.obj $(OBJ_D)\ecb3_enc.obj \
	$(OBJ_D)\cfb64enc.obj $(OBJ_D)\cfb64ede.obj $(OBJ_D)\cfb_enc.obj \
	$(OBJ_D)\ofb64ede.obj $(OBJ_D)\enc_read.obj $(OBJ_D)\enc_writ.obj \
	$(OBJ_D)\ofb64enc.obj $(OBJ_D)\ofb_enc.obj $(OBJ_D)\str2key.obj \
	$(OBJ_D)\pcbc_enc.obj $(OBJ_D)\qud_cksm.obj $(OBJ_D)\rand_key.obj \
	$(OBJ_D)\des_enc.obj $(OBJ_D)\fcrypt_b.obj $(OBJ_D)\fcrypt.obj \
	$(OBJ_D)\xcbc_enc.obj $(OBJ_D)\rpc_enc.obj $(OBJ_D)\cbc_cksm.obj \
	$(OBJ_D)\ede_cbcm_enc.obj $(OBJ_D)\des_old.obj $(OBJ_D)\des_old2.obj \
	$(OBJ_D)\read2pwd.obj $(OBJ_D)\rc2_ecb.obj $(OBJ_D)\rc2_skey.obj \
	$(OBJ_D)\rc2_cbc.obj $(OBJ_D)\rc2cfb64.obj $(OBJ_D)\rc2ofb64.obj \
	$(OBJ_D)\rc4_skey.obj $(OBJ_D)\rc4_enc.obj $(OBJ_D)\rc5_skey.obj \
	$(OBJ_D)\rc5_ecb.obj $(OBJ_D)\rc5_enc.obj $(OBJ_D)\rc5cfb64.obj \
	$(OBJ_D)\rc5ofb64.obj $(OBJ_D)\i_cbc.obj $(OBJ_D)\i_cfb64.obj \
	$(OBJ_D)\i_ofb64.obj $(OBJ_D)\i_ecb.obj $(OBJ_D)\i_skey.obj \
	$(OBJ_D)\bf_skey.obj $(OBJ_D)\bf_ecb.obj $(OBJ_D)\bf_enc.obj \
	$(OBJ_D)\bf_cfb64.obj $(OBJ_D)\bf_ofb64.obj $(OBJ_D)\c_skey.obj \
	$(OBJ_D)\c_ecb.obj $(OBJ_D)\c_enc.obj $(OBJ_D)\c_cfb64.obj \
	$(OBJ_D)\c_ofb64.obj $(OBJ_D)\aes_core.obj $(OBJ_D)\aes_misc.obj \
	$(OBJ_D)\aes_ecb.obj $(OBJ_D)\aes_cbc.obj $(OBJ_D)\aes_cfb.obj \
	$(OBJ_D)\aes_ofb.obj $(OBJ_D)\aes_ctr.obj $(OBJ_D)\bn_add.obj \
	$(OBJ_D)\bn_div.obj $(OBJ_D)\bn_exp.obj $(OBJ_D)\bn_lib.obj \
	$(OBJ_D)\bn_ctx.obj $(OBJ_D)\bn_mul.obj $(OBJ_D)\bn_mod.obj \
	$(OBJ_D)\bn_print.obj $(OBJ_D)\bn_rand.obj $(OBJ_D)\bn_shift.obj \
	$(OBJ_D)\bn_word.obj $(OBJ_D)\bn_blind.obj $(OBJ_D)\bn_kron.obj \
	$(OBJ_D)\bn_sqrt.obj $(OBJ_D)\bn_gcd.obj $(OBJ_D)\bn_prime.obj \
	$(OBJ_D)\bn_err.obj $(OBJ_D)\bn_sqr.obj $(BN_ASM_OBJ) \
	$(OBJ_D)\bn_recp.obj $(OBJ_D)\bn_mont.obj $(OBJ_D)\bn_mpi.obj \
	$(OBJ_D)\bn_exp2.obj $(OBJ_D)\bn_x931p.obj $(OBJ_D)\rsa_eay.obj \
	$(OBJ_D)\rsa_gen.obj $(OBJ_D)\rsa_lib.obj $(OBJ_D)\rsa_sign.obj \
	$(OBJ_D)\rsa_saos.obj $(OBJ_D)\rsa_err.obj $(OBJ_D)\rsa_pk1.obj \
	$(OBJ_D)\rsa_ssl.obj $(OBJ_D)\rsa_none.obj $(OBJ_D)\rsa_oaep.obj \
	$(OBJ_D)\rsa_chk.obj $(OBJ_D)\rsa_null.obj $(OBJ_D)\rsa_pss.obj \
	$(OBJ_D)\rsa_x931.obj $(OBJ_D)\rsa_asn1.obj $(OBJ_D)\dsa_gen.obj \
	$(OBJ_D)\dsa_key.obj $(OBJ_D)\dsa_lib.obj $(OBJ_D)\dsa_asn1.obj \
	$(OBJ_D)\dsa_vrf.obj $(OBJ_D)\dsa_sign.obj $(OBJ_D)\dsa_err.obj \
	$(OBJ_D)\dsa_ossl.obj $(OBJ_D)\dso_dl.obj $(OBJ_D)\dso_dlfcn.obj \
	$(OBJ_D)\dso_err.obj $(OBJ_D)\dso_lib.obj $(OBJ_D)\dso_null.obj \
	$(OBJ_D)\dso_openssl.obj $(OBJ_D)\dso_win32.obj $(OBJ_D)\dso_vms.obj \
	$(OBJ_D)\dh_asn1.obj $(OBJ_D)\dh_gen.obj $(OBJ_D)\dh_key.obj \
	$(OBJ_D)\dh_lib.obj $(OBJ_D)\dh_check.obj $(OBJ_D)\dh_err.obj \
	$(OBJ_D)\ec_lib.obj $(OBJ_D)\ecp_smpl.obj $(OBJ_D)\ecp_mont.obj \
	$(OBJ_D)\ecp_recp.obj $(OBJ_D)\ecp_nist.obj $(OBJ_D)\ec_cvt.obj \
	$(OBJ_D)\ec_mult.obj $(OBJ_D)\ec_err.obj $(OBJ_D)\buffer.obj \
	$(OBJ_D)\buf_err.obj $(OBJ_D)\bio_lib.obj $(OBJ_D)\bio_cb.obj \
	$(OBJ_D)\bio_err.obj $(OBJ_D)\bss_mem.obj $(OBJ_D)\bss_null.obj \
	$(OBJ_D)\bss_fd.obj $(OBJ_D)\bss_file.obj $(OBJ_D)\bss_sock.obj \
	$(OBJ_D)\bss_conn.obj $(OBJ_D)\bf_null.obj $(OBJ_D)\bf_buff.obj \
	$(OBJ_D)\b_print.obj $(OBJ_D)\b_dump.obj $(OBJ_D)\b_sock.obj \
	$(OBJ_D)\bss_acpt.obj $(OBJ_D)\bf_nbio.obj $(OBJ_D)\bss_log.obj \
	$(OBJ_D)\bss_bio.obj $(OBJ_D)\stack.obj $(OBJ_D)\lhash.obj \
	$(OBJ_D)\lh_stats.obj $(OBJ_D)\md_rand.obj $(OBJ_D)\randfile.obj \
	$(OBJ_D)\rand_lib.obj $(OBJ_D)\rand_err.obj $(OBJ_D)\rand_egd.obj \
	$(OBJ_D)\rand_win.obj $(OBJ_D)\rand_unix.obj $(OBJ_D)\rand_os2.obj \
	$(OBJ_D)\err.obj $(OBJ_D)\err_all.obj $(OBJ_D)\err_prn.obj \
	$(OBJ_D)\o_names.obj $(OBJ_D)\obj_dat.obj $(OBJ_D)\obj_lib.obj \
	$(OBJ_D)\obj_err.obj $(OBJ_D)\encode.obj $(OBJ_D)\digest.obj \
	$(OBJ_D)\evp_enc.obj $(OBJ_D)\evp_key.obj $(OBJ_D)\evp_acnf.obj \
	$(OBJ_D)\e_des.obj $(OBJ_D)\e_bf.obj $(OBJ_D)\e_idea.obj \
	$(OBJ_D)\e_des3.obj $(OBJ_D)\e_rc4.obj $(OBJ_D)\e_aes.obj \
	$(OBJ_D)\names.obj $(OBJ_D)\e_xcbc_d.obj $(OBJ_D)\e_rc2.obj \
	$(OBJ_D)\e_cast.obj $(OBJ_D)\e_rc5.obj $(OBJ_D)\m_null.obj \
	$(OBJ_D)\m_md2.obj $(OBJ_D)\m_md4.obj $(OBJ_D)\m_md5.obj \
	$(OBJ_D)\m_sha.obj $(OBJ_D)\m_sha1.obj $(OBJ_D)\m_dss.obj \
	$(OBJ_D)\m_dss1.obj $(OBJ_D)\m_mdc2.obj $(OBJ_D)\m_ripemd.obj \
	$(OBJ_D)\p_open.obj $(OBJ_D)\p_seal.obj $(OBJ_D)\p_sign.obj \
	$(OBJ_D)\p_verify.obj $(OBJ_D)\p_lib.obj $(OBJ_D)\p_enc.obj \
	$(OBJ_D)\p_dec.obj $(OBJ_D)\bio_md.obj $(OBJ_D)\bio_b64.obj \
	$(OBJ_D)\bio_enc.obj $(OBJ_D)\evp_err.obj $(OBJ_D)\e_null.obj \
	$(OBJ_D)\c_all.obj $(OBJ_D)\c_allc.obj $(OBJ_D)\c_alld.obj \
	$(OBJ_D)\evp_lib.obj $(OBJ_D)\bio_ok.obj $(OBJ_D)\evp_pkey.obj \
	$(OBJ_D)\evp_pbe.obj $(OBJ_D)\p5_crpt.obj $(OBJ_D)\p5_crpt2.obj \
	$(OBJ_D)\e_old.obj $(OBJ_D)\a_object.obj $(OBJ_D)\a_bitstr.obj \
	$(OBJ_D)\a_utctm.obj $(OBJ_D)\a_gentm.obj $(OBJ_D)\a_time.obj \
	$(OBJ_D)\a_int.obj $(OBJ_D)\a_octet.obj $(OBJ_D)\a_print.obj \
	$(OBJ_D)\a_type.obj $(OBJ_D)\a_set.obj $(OBJ_D)\a_dup.obj \
	$(OBJ_D)\a_d2i_fp.obj $(OBJ_D)\a_i2d_fp.obj $(OBJ_D)\a_enum.obj \
	$(OBJ_D)\a_utf8.obj $(OBJ_D)\a_sign.obj $(OBJ_D)\a_digest.obj \
	$(OBJ_D)\a_verify.obj $(OBJ_D)\a_mbstr.obj $(OBJ_D)\a_strex.obj \
	$(OBJ_D)\x_algor.obj $(OBJ_D)\x_val.obj $(OBJ_D)\x_pubkey.obj \
	$(OBJ_D)\x_sig.obj $(OBJ_D)\x_req.obj $(OBJ_D)\x_attrib.obj \
	$(OBJ_D)\x_bignum.obj $(OBJ_D)\x_long.obj $(OBJ_D)\x_name.obj \
	$(OBJ_D)\x_x509.obj $(OBJ_D)\x_x509a.obj $(OBJ_D)\x_crl.obj \
	$(OBJ_D)\x_info.obj $(OBJ_D)\x_spki.obj $(OBJ_D)\nsseq.obj \
	$(OBJ_D)\d2i_pu.obj $(OBJ_D)\d2i_pr.obj $(OBJ_D)\i2d_pu.obj \
	$(OBJ_D)\i2d_pr.obj $(OBJ_D)\t_req.obj $(OBJ_D)\t_x509.obj \
	$(OBJ_D)\t_x509a.obj $(OBJ_D)\t_crl.obj $(OBJ_D)\t_pkey.obj \
	$(OBJ_D)\t_spki.obj $(OBJ_D)\t_bitst.obj $(OBJ_D)\tasn_new.obj \
	$(OBJ_D)\tasn_fre.obj $(OBJ_D)\tasn_enc.obj $(OBJ_D)\tasn_dec.obj \
	$(OBJ_D)\tasn_utl.obj $(OBJ_D)\tasn_typ.obj $(OBJ_D)\f_int.obj \
	$(OBJ_D)\f_string.obj $(OBJ_D)\n_pkey.obj $(OBJ_D)\f_enum.obj \
	$(OBJ_D)\a_hdr.obj $(OBJ_D)\x_pkey.obj $(OBJ_D)\a_bool.obj \
	$(OBJ_D)\x_exten.obj $(OBJ_D)\asn1_par.obj $(OBJ_D)\asn1_lib.obj \
	$(OBJ_D)\asn1_err.obj $(OBJ_D)\a_meth.obj $(OBJ_D)\a_bytes.obj \
	$(OBJ_D)\a_strnid.obj $(OBJ_D)\evp_asn1.obj $(OBJ_D)\asn_pack.obj \
	$(OBJ_D)\p5_pbe.obj $(OBJ_D)\p5_pbev2.obj $(OBJ_D)\p8_pkey.obj \
	$(OBJ_D)\asn_moid.obj $(OBJ_D)\pem_sign.obj $(OBJ_D)\pem_seal.obj \
	$(OBJ_D)\pem_info.obj $(OBJ_D)\pem_lib.obj $(OBJ_D)\pem_all.obj \
	$(OBJ_D)\pem_err.obj $(OBJ_D)\pem_x509.obj $(OBJ_D)\pem_xaux.obj \
	$(OBJ_D)\pem_oth.obj $(OBJ_D)\pem_pk8.obj $(OBJ_D)\pem_pkey.obj \
	$(OBJ_D)\x509_def.obj $(OBJ_D)\x509_d2.obj $(OBJ_D)\x509_r2x.obj \
	$(OBJ_D)\x509_cmp.obj $(OBJ_D)\x509_obj.obj $(OBJ_D)\x509_req.obj \
	$(OBJ_D)\x509spki.obj $(OBJ_D)\x509_vfy.obj $(OBJ_D)\x509_set.obj \
	$(OBJ_D)\x509cset.obj $(OBJ_D)\x509rset.obj $(OBJ_D)\x509_err.obj \
	$(OBJ_D)\x509name.obj $(OBJ_D)\x509_v3.obj $(OBJ_D)\x509_ext.obj \
	$(OBJ_D)\x509_att.obj $(OBJ_D)\x509type.obj $(OBJ_D)\x509_lu.obj \
	$(OBJ_D)\x_all.obj $(OBJ_D)\x509_txt.obj $(OBJ_D)\x509_trs.obj \
	$(OBJ_D)\by_file.obj $(OBJ_D)\by_dir.obj $(OBJ_D)\v3_bcons.obj \
	$(OBJ_D)\v3_bitst.obj $(OBJ_D)\v3_conf.obj $(OBJ_D)\v3_extku.obj \
	$(OBJ_D)\v3_ia5.obj $(OBJ_D)\v3_lib.obj $(OBJ_D)\v3_prn.obj \
	$(OBJ_D)\v3_utl.obj $(OBJ_D)\v3err.obj $(OBJ_D)\v3_genn.obj \
	$(OBJ_D)\v3_alt.obj $(OBJ_D)\v3_skey.obj $(OBJ_D)\v3_akey.obj \
	$(OBJ_D)\v3_pku.obj $(OBJ_D)\v3_int.obj $(OBJ_D)\v3_enum.obj \
	$(OBJ_D)\v3_sxnet.obj $(OBJ_D)\v3_cpols.obj $(OBJ_D)\v3_crld.obj \
	$(OBJ_D)\v3_purp.obj $(OBJ_D)\v3_info.obj $(OBJ_D)\v3_ocsp.obj \
	$(OBJ_D)\v3_akeya.obj $(OBJ_D)\v3_pcia.obj $(OBJ_D)\v3_pci.obj \
	$(OBJ_D)\conf_err.obj $(OBJ_D)\conf_lib.obj $(OBJ_D)\conf_api.obj \
	$(OBJ_D)\conf_def.obj $(OBJ_D)\conf_mod.obj $(OBJ_D)\conf_mall.obj \
	$(OBJ_D)\conf_sap.obj $(OBJ_D)\txt_db.obj $(OBJ_D)\pk7_asn1.obj \
	$(OBJ_D)\pk7_lib.obj $(OBJ_D)\pkcs7err.obj $(OBJ_D)\pk7_doit.obj \
	$(OBJ_D)\pk7_smime.obj $(OBJ_D)\pk7_attr.obj $(OBJ_D)\pk7_mime.obj \
	$(OBJ_D)\p12_add.obj $(OBJ_D)\p12_asn.obj $(OBJ_D)\p12_attr.obj \
	$(OBJ_D)\p12_crpt.obj $(OBJ_D)\p12_crt.obj $(OBJ_D)\p12_decr.obj \
	$(OBJ_D)\p12_init.obj $(OBJ_D)\p12_key.obj $(OBJ_D)\p12_kiss.obj \
	$(OBJ_D)\p12_mutl.obj $(OBJ_D)\p12_utl.obj $(OBJ_D)\p12_npas.obj \
	$(OBJ_D)\pk12err.obj $(OBJ_D)\p12_p8d.obj $(OBJ_D)\p12_p8e.obj \
	$(OBJ_D)\comp_lib.obj $(OBJ_D)\comp_err.obj $(OBJ_D)\c_rle.obj \
	$(OBJ_D)\c_zlib.obj $(OBJ_D)\eng_err.obj $(OBJ_D)\eng_lib.obj \
	$(OBJ_D)\eng_list.obj $(OBJ_D)\eng_init.obj $(OBJ_D)\eng_ctrl.obj \
	$(OBJ_D)\eng_table.obj $(OBJ_D)\eng_pkey.obj $(OBJ_D)\eng_fat.obj \
	$(OBJ_D)\eng_all.obj $(OBJ_D)\tb_rsa.obj $(OBJ_D)\tb_dsa.obj \
	$(OBJ_D)\tb_dh.obj $(OBJ_D)\tb_rand.obj $(OBJ_D)\tb_cipher.obj \
	$(OBJ_D)\tb_digest.obj $(OBJ_D)\eng_openssl.obj $(OBJ_D)\eng_dyn.obj \
	$(OBJ_D)\eng_cnf.obj $(OBJ_D)\hw_atalla.obj $(OBJ_D)\hw_cswift.obj \
	$(OBJ_D)\hw_ncipher.obj $(OBJ_D)\hw_nuron.obj $(OBJ_D)\hw_ubsec.obj \
	$(OBJ_D)\hw_cryptodev.obj $(OBJ_D)\hw_aep.obj $(OBJ_D)\hw_sureware.obj \
	$(OBJ_D)\hw_4758_cca.obj $(OBJ_D)\ocsp_asn.obj $(OBJ_D)\ocsp_ext.obj \
	$(OBJ_D)\ocsp_ht.obj $(OBJ_D)\ocsp_lib.obj $(OBJ_D)\ocsp_cl.obj \
	$(OBJ_D)\ocsp_srv.obj $(OBJ_D)\ocsp_prn.obj $(OBJ_D)\ocsp_vfy.obj \
	$(OBJ_D)\ocsp_err.obj $(OBJ_D)\ui_err.obj $(OBJ_D)\ui_lib.obj \
	$(OBJ_D)\ui_openssl.obj $(OBJ_D)\ui_util.obj $(OBJ_D)\ui_compat.obj \
	$(OBJ_D)\krb5_asn.obj $(OBJ_D)\fips.obj $(OBJ_D)\fips_err_wrapper.obj \
	$(OBJ_D)\fips_aes_core.obj $(OBJ_D)\fips_aes_selftest.obj $(OBJ_D)\fips_des_enc.obj \
	$(OBJ_D)\fips_des_selftest.obj $(OBJ_D)\fips_set_key.obj $(OBJ_D)\fips_dsa_ossl.obj \
	$(OBJ_D)\fips_dsa_gen.obj $(OBJ_D)\fips_dsa_selftest.obj $(OBJ_D)\fips_dh_check.obj \
	$(OBJ_D)\fips_dh_gen.obj $(OBJ_D)\fips_dh_key.obj $(OBJ_D)\fips_hmac.obj \
	$(OBJ_D)\fips_hmac_selftest.obj $(OBJ_D)\fips_rand.obj $(OBJ_D)\fips_rand_selftest.obj \
	$(OBJ_D)\fips_rsa_eay.obj $(OBJ_D)\fips_rsa_gen.obj $(OBJ_D)\fips_rsa_selftest.obj \
	$(OBJ_D)\fips_rsa_x931g.obj $(OBJ_D)\fips_sha1dgst.obj $(OBJ_D)\fips_sha1_selftest.obj \
	$(OBJ_D)\fips_sha256.obj $(OBJ_D)\fips_sha512.obj

T_EXE=$(TEST_D)\md2test.exe \
	$(TEST_D)\md4test.exe $(TEST_D)\md5test.exe $(TEST_D)\shatest.exe \
	$(TEST_D)\sha1test.exe $(TEST_D)\mdc2test.exe $(TEST_D)\hmactest.exe \
	$(TEST_D)\rmdtest.exe $(TEST_D)\destest.exe $(TEST_D)\rc2test.exe \
	$(TEST_D)\rc4test.exe $(TEST_D)\rc5test.exe $(TEST_D)\ideatest.exe \
	$(TEST_D)\bftest.exe $(TEST_D)\casttest.exe $(TEST_D)\bntest.exe \
	$(TEST_D)\exptest.exe $(TEST_D)\rsa_test.exe $(TEST_D)\dsatest.exe \
	$(TEST_D)\dhtest.exe $(TEST_D)\ectest.exe $(TEST_D)\randtest.exe \
	$(TEST_D)\evp_test.exe $(TEST_D)\enginetest.exe $(TEST_D)\fips_test_suite.exe \
	$(TEST_D)\fips_aesavs.exe $(TEST_D)\fips_desmovs.exe $(TEST_D)\fips_dsatest.exe \
	$(TEST_D)\fips_dssvs.exe $(TEST_D)\fips_hmactest.exe $(TEST_D)\fips_randtest.exe \
	$(TEST_D)\fips_rngvs.exe $(TEST_D)\fips_rsavtest.exe $(TEST_D)\fips_rsastest.exe \
	$(TEST_D)\fips_rsagtest.exe $(TEST_D)\fips_shatest.exe $(TEST_D)\ssltest.exe

###################################################################
all: banner $(TMP_D) $(BIN_D) $(TEST_D) $(LIB_D) $(INCO_D) headers lib exe

banner:
	@echo Make sure you have run 'perl Configure VC-W31-32' in the
	@echo top level directory, if you don't have perl, you will
	@echo need to probably edit crypto/bn/bn.h, check the
	@echo documentation for details.


$(TMP_D):
	$(MKDIR) $(TMP_D)
# NB: uncomment out these lines if BIN_D, TEST_D and LIB_D are different
#$(BIN_D):
#	$(MKDIR) $(BIN_D)
#
#$(TEST_D):
#	$(MKDIR) $(TEST_D)

$(LIB_D):
	$(MKDIR) $(LIB_D)

$(INCO_D): $(INC_D)
	$(MKDIR) $(INCO_D)

$(INC_D):
	$(MKDIR) $(INC_D)

headers: $(HEADER) $(EXHEADER)
	@

lib: $(LIBS_DEP)

exe: $(T_EXE) $(BIN_D)\$(E_EXE).exe

install:
	$(MKDIR) $(INSTALLTOP)
	$(MKDIR) $(INSTALLTOP)\bin
	$(MKDIR) $(INSTALLTOP)\include
	$(MKDIR) $(INSTALLTOP)\include\openssl
	$(MKDIR) $(INSTALLTOP)\lib
	$(CP) $(INCO_D)\*.[ch] $(INSTALLTOP)\include\openssl
	$(CP) $(BIN_D)\$(E_EXE).exe $(INSTALLTOP)\bin
	$(CP) $(O_SSL) $(INSTALLTOP)\lib
	$(CP) $(O_CRYPTO) $(INSTALLTOP)\lib

clean:
	$(RM) $(TMP_D)\*.*

vclean:
	$(RM) $(TMP_D)\*.*
	$(RM) $(OUT_D)\*.*

$(INCL_D)\e_os.h: $(SRC_D)\.\e_os.h
	$(CP) $(SRC_D)\.\e_os.h $(INCL_D)\e_os.h

$(INCL_D)\cryptlib.h: $(SRC_D)\crypto\cryptlib.h
	$(CP) $(SRC_D)\crypto\cryptlib.h $(INCL_D)\cryptlib.h

$(INCL_D)\buildinf.h: $(SRC_D)\crypto\buildinf.h
	$(CP) $(SRC_D)\crypto\buildinf.h $(INCL_D)\buildinf.h

$(INCL_D)\md32_common.h: $(SRC_D)\crypto\md32_common.h
	$(CP) $(SRC_D)\crypto\md32_common.h $(INCL_D)\md32_common.h

$(INCL_D)\o_time.h: $(SRC_D)\crypto\o_time.h
	$(CP) $(SRC_D)\crypto\o_time.h $(INCL_D)\o_time.h

$(INCL_D)\o_str.h: $(SRC_D)\crypto\o_str.h
	$(CP) $(SRC_D)\crypto\o_str.h $(INCL_D)\o_str.h

$(INCL_D)\md4_locl.h: $(SRC_D)\crypto\md4\md4_locl.h
	$(CP) $(SRC_D)\crypto\md4\md4_locl.h $(INCL_D)\md4_locl.h

$(INCL_D)\md5_locl.h: $(SRC_D)\crypto\md5\md5_locl.h
	$(CP) $(SRC_D)\crypto\md5\md5_locl.h $(INCL_D)\md5_locl.h

$(INCL_D)\sha_locl.h: $(SRC_D)\crypto\sha\sha_locl.h
	$(CP) $(SRC_D)\crypto\sha\sha_locl.h $(INCL_D)\sha_locl.h

$(INCL_D)\rmd_locl.h: $(SRC_D)\crypto\ripemd\rmd_locl.h
	$(CP) $(SRC_D)\crypto\ripemd\rmd_locl.h $(INCL_D)\rmd_locl.h

$(INCL_D)\rmdconst.h: $(SRC_D)\crypto\ripemd\rmdconst.h
	$(CP) $(SRC_D)\crypto\ripemd\rmdconst.h $(INCL_D)\rmdconst.h

$(INCL_D)\des_locl.h: $(SRC_D)\crypto\des\des_locl.h
	$(CP) $(SRC_D)\crypto\des\des_locl.h $(INCL_D)\des_locl.h

$(INCL_D)\rpc_des.h: $(SRC_D)\crypto\des\rpc_des.h
	$(CP) $(SRC_D)\crypto\des\rpc_des.h $(INCL_D)\rpc_des.h

$(INCL_D)\spr.h: $(SRC_D)\crypto\des\spr.h
	$(CP) $(SRC_D)\crypto\des\spr.h $(INCL_D)\spr.h

$(INCL_D)\des_ver.h: $(SRC_D)\crypto\des\des_ver.h
	$(CP) $(SRC_D)\crypto\des\des_ver.h $(INCL_D)\des_ver.h

$(INCL_D)\rc2_locl.h: $(SRC_D)\crypto\rc2\rc2_locl.h
	$(CP) $(SRC_D)\crypto\rc2\rc2_locl.h $(INCL_D)\rc2_locl.h

$(INCL_D)\rc4_locl.h: $(SRC_D)\crypto\rc4\rc4_locl.h
	$(CP) $(SRC_D)\crypto\rc4\rc4_locl.h $(INCL_D)\rc4_locl.h

$(INCL_D)\rc5_locl.h: $(SRC_D)\crypto\rc5\rc5_locl.h
	$(CP) $(SRC_D)\crypto\rc5\rc5_locl.h $(INCL_D)\rc5_locl.h

$(INCL_D)\idea_lcl.h: $(SRC_D)\crypto\idea\idea_lcl.h
	$(CP) $(SRC_D)\crypto\idea\idea_lcl.h $(INCL_D)\idea_lcl.h

$(INCL_D)\bf_pi.h: $(SRC_D)\crypto\bf\bf_pi.h
	$(CP) $(SRC_D)\crypto\bf\bf_pi.h $(INCL_D)\bf_pi.h

$(INCL_D)\bf_locl.h: $(SRC_D)\crypto\bf\bf_locl.h
	$(CP) $(SRC_D)\crypto\bf\bf_locl.h $(INCL_D)\bf_locl.h

$(INCL_D)\cast_s.h: $(SRC_D)\crypto\cast\cast_s.h
	$(CP) $(SRC_D)\crypto\cast\cast_s.h $(INCL_D)\cast_s.h

$(INCL_D)\cast_lcl.h: $(SRC_D)\crypto\cast\cast_lcl.h
	$(CP) $(SRC_D)\crypto\cast\cast_lcl.h $(INCL_D)\cast_lcl.h

$(INCL_D)\aes_locl.h: $(SRC_D)\crypto\aes\aes_locl.h
	$(CP) $(SRC_D)\crypto\aes\aes_locl.h $(INCL_D)\aes_locl.h

$(INCL_D)\bn_lcl.h: $(SRC_D)\crypto\bn\bn_lcl.h
	$(CP) $(SRC_D)\crypto\bn\bn_lcl.h $(INCL_D)\bn_lcl.h

$(INCL_D)\bn_prime.h: $(SRC_D)\crypto\bn\bn_prime.h
	$(CP) $(SRC_D)\crypto\bn\bn_prime.h $(INCL_D)\bn_prime.h

$(INCL_D)\ec_lcl.h: $(SRC_D)\crypto\ec\ec_lcl.h
	$(CP) $(SRC_D)\crypto\ec\ec_lcl.h $(INCL_D)\ec_lcl.h

$(INCL_D)\bss_file.c: $(SRC_D)\crypto\bio\bss_file.c
	$(CP) $(SRC_D)\crypto\bio\bss_file.c $(INCL_D)\bss_file.c

$(INCL_D)\obj_dat.h: $(SRC_D)\crypto\objects\obj_dat.h
	$(CP) $(SRC_D)\crypto\objects\obj_dat.h $(INCL_D)\obj_dat.h

$(INCL_D)\conf_def.h: $(SRC_D)\crypto\conf\conf_def.h
	$(CP) $(SRC_D)\crypto\conf\conf_def.h $(INCL_D)\conf_def.h

$(INCL_D)\ui_locl.h: $(SRC_D)\crypto\ui\ui_locl.h
	$(CP) $(SRC_D)\crypto\ui\ui_locl.h $(INCL_D)\ui_locl.h

$(INCL_D)\fips_err.h: $(SRC_D)\fips\fips_err.h
	$(CP) $(SRC_D)\fips\fips_err.h $(INCL_D)\fips_err.h

$(INCL_D)\fips_aes_locl.h: $(SRC_D)\fips\aes\fips_aes_locl.h
	$(CP) $(SRC_D)\fips\aes\fips_aes_locl.h $(INCL_D)\fips_aes_locl.h

$(INCL_D)\fips_des_locl.h: $(SRC_D)\fips\des\fips_des_locl.h
	$(CP) $(SRC_D)\fips\des\fips_des_locl.h $(INCL_D)\fips_des_locl.h

$(INCL_D)\fips_sha_locl.h: $(SRC_D)\fips\sha\fips_sha_locl.h
	$(CP) $(SRC_D)\fips\sha\fips_sha_locl.h $(INCL_D)\fips_sha_locl.h

$(INCL_D)\fips_md32_common.h: $(SRC_D)\fips\sha\fips_md32_common.h
	$(CP) $(SRC_D)\fips\sha\fips_md32_common.h $(INCL_D)\fips_md32_common.h

$(INCL_D)\ssl_locl.h: $(SRC_D)\ssl\ssl_locl.h
	$(CP) $(SRC_D)\ssl\ssl_locl.h $(INCL_D)\ssl_locl.h

$(INCL_D)\kssl_lcl.h: $(SRC_D)\ssl\kssl_lcl.h
	$(CP) $(SRC_D)\ssl\kssl_lcl.h $(INCL_D)\kssl_lcl.h

$(INCL_D)\apps.h: $(SRC_D)\apps\apps.h
	$(CP) $(SRC_D)\apps\apps.h $(INCL_D)\apps.h

$(INCL_D)\progs.h: $(SRC_D)\apps\progs.h
	$(CP) $(SRC_D)\apps\progs.h $(INCL_D)\progs.h

$(INCL_D)\s_apps.h: $(SRC_D)\apps\s_apps.h
	$(CP) $(SRC_D)\apps\s_apps.h $(INCL_D)\s_apps.h

$(INCL_D)\testdsa.h: $(SRC_D)\apps\testdsa.h
	$(CP) $(SRC_D)\apps\testdsa.h $(INCL_D)\testdsa.h

$(INCL_D)\testrsa.h: $(SRC_D)\apps\testrsa.h
	$(CP) $(SRC_D)\apps\testrsa.h $(INCL_D)\testrsa.h

$(INCO_D)\e_os2.h: $(SRC_D)\.\e_os2.h
	$(CP) $(SRC_D)\.\e_os2.h $(INCO_D)\e_os2.h

$(INCO_D)\crypto.h: $(SRC_D)\crypto\crypto.h
	$(CP) $(SRC_D)\crypto\crypto.h $(INCO_D)\crypto.h

$(INCO_D)\tmdiff.h: $(SRC_D)\crypto\tmdiff.h
	$(CP) $(SRC_D)\crypto\tmdiff.h $(INCO_D)\tmdiff.h

$(INCO_D)\opensslv.h: $(SRC_D)\crypto\opensslv.h
	$(CP) $(SRC_D)\crypto\opensslv.h $(INCO_D)\opensslv.h

$(INCO_D)\opensslconf.h: $(SRC_D)\crypto\opensslconf.h
	$(CP) $(SRC_D)\crypto\opensslconf.h $(INCO_D)\opensslconf.h

$(INCO_D)\ebcdic.h: $(SRC_D)\crypto\ebcdic.h
	$(CP) $(SRC_D)\crypto\ebcdic.h $(INCO_D)\ebcdic.h

$(INCO_D)\symhacks.h: $(SRC_D)\crypto\symhacks.h
	$(CP) $(SRC_D)\crypto\symhacks.h $(INCO_D)\symhacks.h

$(INCO_D)\ossl_typ.h: $(SRC_D)\crypto\ossl_typ.h
	$(CP) $(SRC_D)\crypto\ossl_typ.h $(INCO_D)\ossl_typ.h

$(INCO_D)\md2.h: $(SRC_D)\crypto\md2\md2.h
	$(CP) $(SRC_D)\crypto\md2\md2.h $(INCO_D)\md2.h

$(INCO_D)\md4.h: $(SRC_D)\crypto\md4\md4.h
	$(CP) $(SRC_D)\crypto\md4\md4.h $(INCO_D)\md4.h

$(INCO_D)\md5.h: $(SRC_D)\crypto\md5\md5.h
	$(CP) $(SRC_D)\crypto\md5\md5.h $(INCO_D)\md5.h

$(INCO_D)\sha.h: $(SRC_D)\crypto\sha\sha.h
	$(CP) $(SRC_D)\crypto\sha\sha.h $(INCO_D)\sha.h

$(INCO_D)\mdc2.h: $(SRC_D)\crypto\mdc2\mdc2.h
	$(CP) $(SRC_D)\crypto\mdc2\mdc2.h $(INCO_D)\mdc2.h

$(INCO_D)\hmac.h: $(SRC_D)\crypto\hmac\hmac.h
	$(CP) $(SRC_D)\crypto\hmac\hmac.h $(INCO_D)\hmac.h

$(INCO_D)\ripemd.h: $(SRC_D)\crypto\ripemd\ripemd.h
	$(CP) $(SRC_D)\crypto\ripemd\ripemd.h $(INCO_D)\ripemd.h

$(INCO_D)\des.h: $(SRC_D)\crypto\des\des.h
	$(CP) $(SRC_D)\crypto\des\des.h $(INCO_D)\des.h

$(INCO_D)\des_old.h: $(SRC_D)\crypto\des\des_old.h
	$(CP) $(SRC_D)\crypto\des\des_old.h $(INCO_D)\des_old.h

$(INCO_D)\rc2.h: $(SRC_D)\crypto\rc2\rc2.h
	$(CP) $(SRC_D)\crypto\rc2\rc2.h $(INCO_D)\rc2.h

$(INCO_D)\rc4.h: $(SRC_D)\crypto\rc4\rc4.h
	$(CP) $(SRC_D)\crypto\rc4\rc4.h $(INCO_D)\rc4.h

$(INCO_D)\rc5.h: $(SRC_D)\crypto\rc5\rc5.h
	$(CP) $(SRC_D)\crypto\rc5\rc5.h $(INCO_D)\rc5.h

$(INCO_D)\idea.h: $(SRC_D)\crypto\idea\idea.h
	$(CP) $(SRC_D)\crypto\idea\idea.h $(INCO_D)\idea.h

$(INCO_D)\blowfish.h: $(SRC_D)\crypto\bf\blowfish.h
	$(CP) $(SRC_D)\crypto\bf\blowfish.h $(INCO_D)\blowfish.h

$(INCO_D)\cast.h: $(SRC_D)\crypto\cast\cast.h
	$(CP) $(SRC_D)\crypto\cast\cast.h $(INCO_D)\cast.h

$(INCO_D)\aes.h: $(SRC_D)\crypto\aes\aes.h
	$(CP) $(SRC_D)\crypto\aes\aes.h $(INCO_D)\aes.h

$(INCO_D)\bn.h: $(SRC_D)\crypto\bn\bn.h
	$(CP) $(SRC_D)\crypto\bn\bn.h $(INCO_D)\bn.h

$(INCO_D)\rsa.h: $(SRC_D)\crypto\rsa\rsa.h
	$(CP) $(SRC_D)\crypto\rsa\rsa.h $(INCO_D)\rsa.h

$(INCO_D)\dsa.h: $(SRC_D)\crypto\dsa\dsa.h
	$(CP) $(SRC_D)\crypto\dsa\dsa.h $(INCO_D)\dsa.h

$(INCO_D)\dso.h: $(SRC_D)\crypto\dso\dso.h
	$(CP) $(SRC_D)\crypto\dso\dso.h $(INCO_D)\dso.h

$(INCO_D)\dh.h: $(SRC_D)\crypto\dh\dh.h
	$(CP) $(SRC_D)\crypto\dh\dh.h $(INCO_D)\dh.h

$(INCO_D)\ec.h: $(SRC_D)\crypto\ec\ec.h
	$(CP) $(SRC_D)\crypto\ec\ec.h $(INCO_D)\ec.h

$(INCO_D)\buffer.h: $(SRC_D)\crypto\buffer\buffer.h
	$(CP) $(SRC_D)\crypto\buffer\buffer.h $(INCO_D)\buffer.h

$(INCO_D)\bio.h: $(SRC_D)\crypto\bio\bio.h
	$(CP) $(SRC_D)\crypto\bio\bio.h $(INCO_D)\bio.h

$(INCO_D)\stack.h: $(SRC_D)\crypto\stack\stack.h
	$(CP) $(SRC_D)\crypto\stack\stack.h $(INCO_D)\stack.h

$(INCO_D)\safestack.h: $(SRC_D)\crypto\stack\safestack.h
	$(CP) $(SRC_D)\crypto\stack\safestack.h $(INCO_D)\safestack.h

$(INCO_D)\lhash.h: $(SRC_D)\crypto\lhash\lhash.h
	$(CP) $(SRC_D)\crypto\lhash\lhash.h $(INCO_D)\lhash.h

$(INCO_D)\rand.h: $(SRC_D)\crypto\rand\rand.h
	$(CP) $(SRC_D)\crypto\rand\rand.h $(INCO_D)\rand.h

$(INCO_D)\err.h: $(SRC_D)\crypto\err\err.h
	$(CP) $(SRC_D)\crypto\err\err.h $(INCO_D)\err.h

$(INCO_D)\objects.h: $(SRC_D)\crypto\objects\objects.h
	$(CP) $(SRC_D)\crypto\objects\objects.h $(INCO_D)\objects.h

$(INCO_D)\obj_mac.h: $(SRC_D)\crypto\objects\obj_mac.h
	$(CP) $(SRC_D)\crypto\objects\obj_mac.h $(INCO_D)\obj_mac.h

$(INCO_D)\evp.h: $(SRC_D)\crypto\evp\evp.h
	$(CP) $(SRC_D)\crypto\evp\evp.h $(INCO_D)\evp.h

$(INCO_D)\asn1.h: $(SRC_D)\crypto\asn1\asn1.h
	$(CP) $(SRC_D)\crypto\asn1\asn1.h $(INCO_D)\asn1.h

$(INCO_D)\asn1_mac.h: $(SRC_D)\crypto\asn1\asn1_mac.h
	$(CP) $(SRC_D)\crypto\asn1\asn1_mac.h $(INCO_D)\asn1_mac.h

$(INCO_D)\asn1t.h: $(SRC_D)\crypto\asn1\asn1t.h
	$(CP) $(SRC_D)\crypto\asn1\asn1t.h $(INCO_D)\asn1t.h

$(INCO_D)\pem.h: $(SRC_D)\crypto\pem\pem.h
	$(CP) $(SRC_D)\crypto\pem\pem.h $(INCO_D)\pem.h

$(INCO_D)\pem2.h: $(SRC_D)\crypto\pem\pem2.h
	$(CP) $(SRC_D)\crypto\pem\pem2.h $(INCO_D)\pem2.h

$(INCO_D)\x509.h: $(SRC_D)\crypto\x509\x509.h
	$(CP) $(SRC_D)\crypto\x509\x509.h $(INCO_D)\x509.h

$(INCO_D)\x509_vfy.h: $(SRC_D)\crypto\x509\x509_vfy.h
	$(CP) $(SRC_D)\crypto\x509\x509_vfy.h $(INCO_D)\x509_vfy.h

$(INCO_D)\x509v3.h: $(SRC_D)\crypto\x509v3\x509v3.h
	$(CP) $(SRC_D)\crypto\x509v3\x509v3.h $(INCO_D)\x509v3.h

$(INCO_D)\conf.h: $(SRC_D)\crypto\conf\conf.h
	$(CP) $(SRC_D)\crypto\conf\conf.h $(INCO_D)\conf.h

$(INCO_D)\conf_api.h: $(SRC_D)\crypto\conf\conf_api.h
	$(CP) $(SRC_D)\crypto\conf\conf_api.h $(INCO_D)\conf_api.h

$(INCO_D)\txt_db.h: $(SRC_D)\crypto\txt_db\txt_db.h
	$(CP) $(SRC_D)\crypto\txt_db\txt_db.h $(INCO_D)\txt_db.h

$(INCO_D)\pkcs7.h: $(SRC_D)\crypto\pkcs7\pkcs7.h
	$(CP) $(SRC_D)\crypto\pkcs7\pkcs7.h $(INCO_D)\pkcs7.h

$(INCO_D)\pkcs12.h: $(SRC_D)\crypto\pkcs12\pkcs12.h
	$(CP) $(SRC_D)\crypto\pkcs12\pkcs12.h $(INCO_D)\pkcs12.h

$(INCO_D)\comp.h: $(SRC_D)\crypto\comp\comp.h
	$(CP) $(SRC_D)\crypto\comp\comp.h $(INCO_D)\comp.h

$(INCO_D)\engine.h: $(SRC_D)\crypto\engine\engine.h
	$(CP) $(SRC_D)\crypto\engine\engine.h $(INCO_D)\engine.h

$(INCO_D)\ocsp.h: $(SRC_D)\crypto\ocsp\ocsp.h
	$(CP) $(SRC_D)\crypto\ocsp\ocsp.h $(INCO_D)\ocsp.h

$(INCO_D)\ui.h: $(SRC_D)\crypto\ui\ui.h
	$(CP) $(SRC_D)\crypto\ui\ui.h $(INCO_D)\ui.h

$(INCO_D)\ui_compat.h: $(SRC_D)\crypto\ui\ui_compat.h
	$(CP) $(SRC_D)\crypto\ui\ui_compat.h $(INCO_D)\ui_compat.h

$(INCO_D)\krb5_asn.h: $(SRC_D)\crypto\krb5\krb5_asn.h
	$(CP) $(SRC_D)\crypto\krb5\krb5_asn.h $(INCO_D)\krb5_asn.h

$(INCO_D)\fips.h: $(SRC_D)\fips\fips.h
	$(CP) $(SRC_D)\fips\fips.h $(INCO_D)\fips.h

$(INCO_D)\fips_rand.h: $(SRC_D)\fips\rand\fips_rand.h
	$(CP) $(SRC_D)\fips\rand\fips_rand.h $(INCO_D)\fips_rand.h

$(INCO_D)\fips_sha.h: $(SRC_D)\fips\sha\fips_sha.h
	$(CP) $(SRC_D)\fips\sha\fips_sha.h $(INCO_D)\fips_sha.h

$(INCO_D)\ssl.h: $(SRC_D)\ssl\ssl.h
	$(CP) $(SRC_D)\ssl\ssl.h $(INCO_D)\ssl.h

$(INCO_D)\ssl2.h: $(SRC_D)\ssl\ssl2.h
	$(CP) $(SRC_D)\ssl\ssl2.h $(INCO_D)\ssl2.h

$(INCO_D)\ssl3.h: $(SRC_D)\ssl\ssl3.h
	$(CP) $(SRC_D)\ssl\ssl3.h $(INCO_D)\ssl3.h

$(INCO_D)\ssl23.h: $(SRC_D)\ssl\ssl23.h
	$(CP) $(SRC_D)\ssl\ssl23.h $(INCO_D)\ssl23.h

$(INCO_D)\tls1.h: $(SRC_D)\ssl\tls1.h
	$(CP) $(SRC_D)\ssl\tls1.h $(INCO_D)\tls1.h

$(INCO_D)\kssl.h: $(SRC_D)\ssl\kssl.h
	$(CP) $(SRC_D)\ssl\kssl.h $(INCO_D)\kssl.h

$(OBJ_D)\md2test.obj: $(SRC_D)\crypto\md2\md2test.c
	$(CC) /Fo$(OBJ_D)\md2test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\md2\md2test.c

$(OBJ_D)\md4test.obj: $(SRC_D)\crypto\md4\md4test.c
	$(CC) /Fo$(OBJ_D)\md4test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\md4\md4test.c

$(OBJ_D)\md5test.obj: $(SRC_D)\crypto\md5\md5test.c
	$(CC) /Fo$(OBJ_D)\md5test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\md5\md5test.c

$(OBJ_D)\shatest.obj: $(SRC_D)\crypto\sha\shatest.c
	$(CC) /Fo$(OBJ_D)\shatest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\sha\shatest.c

$(OBJ_D)\sha1test.obj: $(SRC_D)\crypto\sha\sha1test.c
	$(CC) /Fo$(OBJ_D)\sha1test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\sha\sha1test.c

$(OBJ_D)\mdc2test.obj: $(SRC_D)\crypto\mdc2\mdc2test.c
	$(CC) /Fo$(OBJ_D)\mdc2test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\mdc2\mdc2test.c

$(OBJ_D)\hmactest.obj: $(SRC_D)\crypto\hmac\hmactest.c
	$(CC) /Fo$(OBJ_D)\hmactest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\hmac\hmactest.c

$(OBJ_D)\rmdtest.obj: $(SRC_D)\crypto\ripemd\rmdtest.c
	$(CC) /Fo$(OBJ_D)\rmdtest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\ripemd\rmdtest.c

$(OBJ_D)\destest.obj: $(SRC_D)\crypto\des\destest.c
	$(CC) /Fo$(OBJ_D)\destest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\des\destest.c

$(OBJ_D)\rc2test.obj: $(SRC_D)\crypto\rc2\rc2test.c
	$(CC) /Fo$(OBJ_D)\rc2test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rc2\rc2test.c

$(OBJ_D)\rc4test.obj: $(SRC_D)\crypto\rc4\rc4test.c
	$(CC) /Fo$(OBJ_D)\rc4test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rc4\rc4test.c

$(OBJ_D)\rc5test.obj: $(SRC_D)\crypto\rc5\rc5test.c
	$(CC) /Fo$(OBJ_D)\rc5test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rc5\rc5test.c

$(OBJ_D)\ideatest.obj: $(SRC_D)\crypto\idea\ideatest.c
	$(CC) /Fo$(OBJ_D)\ideatest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\idea\ideatest.c

$(OBJ_D)\bftest.obj: $(SRC_D)\crypto\bf\bftest.c
	$(CC) /Fo$(OBJ_D)\bftest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\bf\bftest.c

$(OBJ_D)\casttest.obj: $(SRC_D)\crypto\cast\casttest.c
	$(CC) /Fo$(OBJ_D)\casttest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\cast\casttest.c

$(OBJ_D)\bntest.obj: $(SRC_D)\crypto\bn\bntest.c
	$(CC) /Fo$(OBJ_D)\bntest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\bn\bntest.c

$(OBJ_D)\exptest.obj: $(SRC_D)\crypto\bn\exptest.c
	$(CC) /Fo$(OBJ_D)\exptest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\bn\exptest.c

$(OBJ_D)\rsa_test.obj: $(SRC_D)\crypto\rsa\rsa_test.c
	$(CC) /Fo$(OBJ_D)\rsa_test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rsa\rsa_test.c

$(OBJ_D)\dsatest.obj: $(SRC_D)\crypto\dsa\dsatest.c
	$(CC) /Fo$(OBJ_D)\dsatest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\dsa\dsatest.c

$(OBJ_D)\dhtest.obj: $(SRC_D)\crypto\dh\dhtest.c
	$(CC) /Fo$(OBJ_D)\dhtest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\dh\dhtest.c

$(OBJ_D)\ectest.obj: $(SRC_D)\crypto\ec\ectest.c
	$(CC) /Fo$(OBJ_D)\ectest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\ec\ectest.c

$(OBJ_D)\randtest.obj: $(SRC_D)\crypto\rand\randtest.c
	$(CC) /Fo$(OBJ_D)\randtest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\rand\randtest.c

$(OBJ_D)\evp_test.obj: $(SRC_D)\crypto\evp\evp_test.c
	$(CC) /Fo$(OBJ_D)\evp_test.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\evp\evp_test.c

$(OBJ_D)\enginetest.obj: $(SRC_D)\crypto\engine\enginetest.c
	$(CC) /Fo$(OBJ_D)\enginetest.obj $(APP_CFLAGS) -c $(SRC_D)\crypto\engine\enginetest.c

$(OBJ_D)\fips_test_suite.obj: $(SRC_D)\fips\fips_test_suite.c
	$(CC) /Fo$(OBJ_D)\fips_test_suite.obj $(APP_CFLAGS) -c $(SRC_D)\fips\fips_test_suite.c

$(OBJ_D)\fips_aesavs.obj: $(SRC_D)\fips\aes\fips_aesavs.c
	$(CC) /Fo$(OBJ_D)\fips_aesavs.obj $(APP_CFLAGS) -c $(SRC_D)\fips\aes\fips_aesavs.c

$(OBJ_D)\fips_desmovs.obj: $(SRC_D)\fips\des\fips_desmovs.c
	$(CC) /Fo$(OBJ_D)\fips_desmovs.obj $(APP_CFLAGS) -c $(SRC_D)\fips\des\fips_desmovs.c

$(OBJ_D)\fips_dsatest.obj: $(SRC_D)\fips\dsa\fips_dsatest.c
	$(CC) /Fo$(OBJ_D)\fips_dsatest.obj $(APP_CFLAGS) -c $(SRC_D)\fips\dsa\fips_dsatest.c

$(OBJ_D)\fips_dssvs.obj: $(SRC_D)\fips\dsa\fips_dssvs.c
	$(CC) /Fo$(OBJ_D)\fips_dssvs.obj $(APP_CFLAGS) -c $(SRC_D)\fips\dsa\fips_dssvs.c

$(OBJ_D)\fips_hmactest.obj: $(SRC_D)\fips\hmac\fips_hmactest.c
	$(CC) /Fo$(OBJ_D)\fips_hmactest.obj $(APP_CFLAGS) -c $(SRC_D)\fips\hmac\fips_hmactest.c

$(OBJ_D)\fips_randtest.obj: $(SRC_D)\fips\rand\fips_randtest.c
	$(CC) /Fo$(OBJ_D)\fips_randtest.obj $(APP_CFLAGS) -c $(SRC_D)\fips\rand\fips_randtest.c

$(OBJ_D)\fips_rngvs.obj: $(SRC_D)\fips\rand\fips_rngvs.c
	$(CC) /Fo$(OBJ_D)\fips_rngvs.obj $(APP_CFLAGS) -c $(SRC_D)\fips\rand\fips_rngvs.c

$(OBJ_D)\fips_rsavtest.obj: $(SRC_D)\fips\rsa\fips_rsavtest.c
	$(CC) /Fo$(OBJ_D)\fips_rsavtest.obj $(APP_CFLAGS) -c $(SRC_D)\fips\rsa\fips_rsavtest.c

$(OBJ_D)\fips_rsastest.obj: $(SRC_D)\fips\rsa\fips_rsastest.c
	$(CC) /Fo$(OBJ_D)\fips_rsastest.obj $(APP_CFLAGS) -c $(SRC_D)\fips\rsa\fips_rsastest.c

$(OBJ_D)\fips_rsagtest.obj: $(SRC_D)\fips\rsa\fips_rsagtest.c
	$(CC) /Fo$(OBJ_D)\fips_rsagtest.obj $(APP_CFLAGS) -c $(SRC_D)\fips\rsa\fips_rsagtest.c

$(OBJ_D)\fips_shatest.obj: $(SRC_D)\fips\sha\fips_shatest.c
	$(CC) /Fo$(OBJ_D)\fips_shatest.obj $(APP_CFLAGS) -c $(SRC_D)\fips\sha\fips_shatest.c

$(OBJ_D)\ssltest.obj: $(SRC_D)\ssl\ssltest.c
	$(CC) /Fo$(OBJ_D)\ssltest.obj $(APP_CFLAGS) -c $(SRC_D)\ssl\ssltest.c

$(OBJ_D)\verify.obj: $(SRC_D)\apps\verify.c
	$(CC) /Fo$(OBJ_D)\verify.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\verify.c

$(OBJ_D)\asn1pars.obj: $(SRC_D)\apps\asn1pars.c
	$(CC) /Fo$(OBJ_D)\asn1pars.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\asn1pars.c

$(OBJ_D)\req.obj: $(SRC_D)\apps\req.c
	$(CC) /Fo$(OBJ_D)\req.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\req.c

$(OBJ_D)\dgst.obj: $(SRC_D)\apps\dgst.c
	$(CC) /Fo$(OBJ_D)\dgst.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\dgst.c

$(OBJ_D)\dh.obj: $(SRC_D)\apps\dh.c
	$(CC) /Fo$(OBJ_D)\dh.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\dh.c

$(OBJ_D)\dhparam.obj: $(SRC_D)\apps\dhparam.c
	$(CC) /Fo$(OBJ_D)\dhparam.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\dhparam.c

$(OBJ_D)\enc.obj: $(SRC_D)\apps\enc.c
	$(CC) /Fo$(OBJ_D)\enc.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\enc.c

$(OBJ_D)\passwd.obj: $(SRC_D)\apps\passwd.c
	$(CC) /Fo$(OBJ_D)\passwd.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\passwd.c

$(OBJ_D)\gendh.obj: $(SRC_D)\apps\gendh.c
	$(CC) /Fo$(OBJ_D)\gendh.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\gendh.c

$(OBJ_D)\errstr.obj: $(SRC_D)\apps\errstr.c
	$(CC) /Fo$(OBJ_D)\errstr.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\errstr.c

$(OBJ_D)\ca.obj: $(SRC_D)\apps\ca.c
	$(CC) /Fo$(OBJ_D)\ca.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\ca.c

$(OBJ_D)\pkcs7.obj: $(SRC_D)\apps\pkcs7.c
	$(CC) /Fo$(OBJ_D)\pkcs7.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\pkcs7.c

$(OBJ_D)\crl2p7.obj: $(SRC_D)\apps\crl2p7.c
	$(CC) /Fo$(OBJ_D)\crl2p7.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\crl2p7.c

$(OBJ_D)\crl.obj: $(SRC_D)\apps\crl.c
	$(CC) /Fo$(OBJ_D)\crl.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\crl.c

$(OBJ_D)\rsa.obj: $(SRC_D)\apps\rsa.c
	$(CC) /Fo$(OBJ_D)\rsa.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\rsa.c

$(OBJ_D)\rsautl.obj: $(SRC_D)\apps\rsautl.c
	$(CC) /Fo$(OBJ_D)\rsautl.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\rsautl.c

$(OBJ_D)\dsa.obj: $(SRC_D)\apps\dsa.c
	$(CC) /Fo$(OBJ_D)\dsa.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\dsa.c

$(OBJ_D)\dsaparam.obj: $(SRC_D)\apps\dsaparam.c
	$(CC) /Fo$(OBJ_D)\dsaparam.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\dsaparam.c

$(OBJ_D)\x509.obj: $(SRC_D)\apps\x509.c
	$(CC) /Fo$(OBJ_D)\x509.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\x509.c

$(OBJ_D)\genrsa.obj: $(SRC_D)\apps\genrsa.c
	$(CC) /Fo$(OBJ_D)\genrsa.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\genrsa.c

$(OBJ_D)\gendsa.obj: $(SRC_D)\apps\gendsa.c
	$(CC) /Fo$(OBJ_D)\gendsa.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\gendsa.c

$(OBJ_D)\s_server.obj: $(SRC_D)\apps\s_server.c
	$(CC) /Fo$(OBJ_D)\s_server.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\s_server.c

$(OBJ_D)\s_client.obj: $(SRC_D)\apps\s_client.c
	$(CC) /Fo$(OBJ_D)\s_client.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\s_client.c

$(OBJ_D)\speed.obj: $(SRC_D)\apps\speed.c
	$(CC) /Fo$(OBJ_D)\speed.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\speed.c

$(OBJ_D)\s_time.obj: $(SRC_D)\apps\s_time.c
	$(CC) /Fo$(OBJ_D)\s_time.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\s_time.c

$(OBJ_D)\apps.obj: $(SRC_D)\apps\apps.c
	$(CC) /Fo$(OBJ_D)\apps.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\apps.c

$(OBJ_D)\s_cb.obj: $(SRC_D)\apps\s_cb.c
	$(CC) /Fo$(OBJ_D)\s_cb.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\s_cb.c

$(OBJ_D)\s_socket.obj: $(SRC_D)\apps\s_socket.c
	$(CC) /Fo$(OBJ_D)\s_socket.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\s_socket.c

$(OBJ_D)\app_rand.obj: $(SRC_D)\apps\app_rand.c
	$(CC) /Fo$(OBJ_D)\app_rand.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\app_rand.c

$(OBJ_D)\version.obj: $(SRC_D)\apps\version.c
	$(CC) /Fo$(OBJ_D)\version.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\version.c

$(OBJ_D)\sess_id.obj: $(SRC_D)\apps\sess_id.c
	$(CC) /Fo$(OBJ_D)\sess_id.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\sess_id.c

$(OBJ_D)\ciphers.obj: $(SRC_D)\apps\ciphers.c
	$(CC) /Fo$(OBJ_D)\ciphers.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\ciphers.c

$(OBJ_D)\nseq.obj: $(SRC_D)\apps\nseq.c
	$(CC) /Fo$(OBJ_D)\nseq.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\nseq.c

$(OBJ_D)\pkcs12.obj: $(SRC_D)\apps\pkcs12.c
	$(CC) /Fo$(OBJ_D)\pkcs12.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\pkcs12.c

$(OBJ_D)\pkcs8.obj: $(SRC_D)\apps\pkcs8.c
	$(CC) /Fo$(OBJ_D)\pkcs8.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\pkcs8.c

$(OBJ_D)\spkac.obj: $(SRC_D)\apps\spkac.c
	$(CC) /Fo$(OBJ_D)\spkac.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\spkac.c

$(OBJ_D)\smime.obj: $(SRC_D)\apps\smime.c
	$(CC) /Fo$(OBJ_D)\smime.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\smime.c

$(OBJ_D)\rand.obj: $(SRC_D)\apps\rand.c
	$(CC) /Fo$(OBJ_D)\rand.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\rand.c

$(OBJ_D)\engine.obj: $(SRC_D)\apps\engine.c
	$(CC) /Fo$(OBJ_D)\engine.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\engine.c

$(OBJ_D)\ocsp.obj: $(SRC_D)\apps\ocsp.c
	$(CC) /Fo$(OBJ_D)\ocsp.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\ocsp.c

$(OBJ_D)\prime.obj: $(SRC_D)\apps\prime.c
	$(CC) /Fo$(OBJ_D)\prime.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\prime.c

$(OBJ_D)\openssl.obj: $(SRC_D)\apps\openssl.c
	$(CC) /Fo$(OBJ_D)\openssl.obj -DMONOLITH $(APP_CFLAGS) -c $(SRC_D)\apps\openssl.c

$(OBJ_D)\s2_meth.obj: $(SRC_D)\ssl\s2_meth.c
	$(CC) /Fo$(OBJ_D)\s2_meth.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s2_meth.c

$(OBJ_D)\s2_srvr.obj: $(SRC_D)\ssl\s2_srvr.c
	$(CC) /Fo$(OBJ_D)\s2_srvr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s2_srvr.c

$(OBJ_D)\s2_clnt.obj: $(SRC_D)\ssl\s2_clnt.c
	$(CC) /Fo$(OBJ_D)\s2_clnt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s2_clnt.c

$(OBJ_D)\s2_lib.obj: $(SRC_D)\ssl\s2_lib.c
	$(CC) /Fo$(OBJ_D)\s2_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s2_lib.c

$(OBJ_D)\s2_enc.obj: $(SRC_D)\ssl\s2_enc.c
	$(CC) /Fo$(OBJ_D)\s2_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s2_enc.c

$(OBJ_D)\s2_pkt.obj: $(SRC_D)\ssl\s2_pkt.c
	$(CC) /Fo$(OBJ_D)\s2_pkt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s2_pkt.c

$(OBJ_D)\s3_meth.obj: $(SRC_D)\ssl\s3_meth.c
	$(CC) /Fo$(OBJ_D)\s3_meth.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s3_meth.c

$(OBJ_D)\s3_srvr.obj: $(SRC_D)\ssl\s3_srvr.c
	$(CC) /Fo$(OBJ_D)\s3_srvr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s3_srvr.c

$(OBJ_D)\s3_clnt.obj: $(SRC_D)\ssl\s3_clnt.c
	$(CC) /Fo$(OBJ_D)\s3_clnt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s3_clnt.c

$(OBJ_D)\s3_lib.obj: $(SRC_D)\ssl\s3_lib.c
	$(CC) /Fo$(OBJ_D)\s3_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s3_lib.c

$(OBJ_D)\s3_enc.obj: $(SRC_D)\ssl\s3_enc.c
	$(CC) /Fo$(OBJ_D)\s3_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s3_enc.c

$(OBJ_D)\s3_pkt.obj: $(SRC_D)\ssl\s3_pkt.c
	$(CC) /Fo$(OBJ_D)\s3_pkt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s3_pkt.c

$(OBJ_D)\s3_both.obj: $(SRC_D)\ssl\s3_both.c
	$(CC) /Fo$(OBJ_D)\s3_both.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s3_both.c

$(OBJ_D)\s23_meth.obj: $(SRC_D)\ssl\s23_meth.c
	$(CC) /Fo$(OBJ_D)\s23_meth.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s23_meth.c

$(OBJ_D)\s23_srvr.obj: $(SRC_D)\ssl\s23_srvr.c
	$(CC) /Fo$(OBJ_D)\s23_srvr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s23_srvr.c

$(OBJ_D)\s23_clnt.obj: $(SRC_D)\ssl\s23_clnt.c
	$(CC) /Fo$(OBJ_D)\s23_clnt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s23_clnt.c

$(OBJ_D)\s23_lib.obj: $(SRC_D)\ssl\s23_lib.c
	$(CC) /Fo$(OBJ_D)\s23_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s23_lib.c

$(OBJ_D)\s23_pkt.obj: $(SRC_D)\ssl\s23_pkt.c
	$(CC) /Fo$(OBJ_D)\s23_pkt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\s23_pkt.c

$(OBJ_D)\t1_meth.obj: $(SRC_D)\ssl\t1_meth.c
	$(CC) /Fo$(OBJ_D)\t1_meth.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\t1_meth.c

$(OBJ_D)\t1_srvr.obj: $(SRC_D)\ssl\t1_srvr.c
	$(CC) /Fo$(OBJ_D)\t1_srvr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\t1_srvr.c

$(OBJ_D)\t1_clnt.obj: $(SRC_D)\ssl\t1_clnt.c
	$(CC) /Fo$(OBJ_D)\t1_clnt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\t1_clnt.c

$(OBJ_D)\t1_lib.obj: $(SRC_D)\ssl\t1_lib.c
	$(CC) /Fo$(OBJ_D)\t1_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\t1_lib.c

$(OBJ_D)\t1_enc.obj: $(SRC_D)\ssl\t1_enc.c
	$(CC) /Fo$(OBJ_D)\t1_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\t1_enc.c

$(OBJ_D)\ssl_lib.obj: $(SRC_D)\ssl\ssl_lib.c
	$(CC) /Fo$(OBJ_D)\ssl_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_lib.c

$(OBJ_D)\ssl_err2.obj: $(SRC_D)\ssl\ssl_err2.c
	$(CC) /Fo$(OBJ_D)\ssl_err2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_err2.c

$(OBJ_D)\ssl_cert.obj: $(SRC_D)\ssl\ssl_cert.c
	$(CC) /Fo$(OBJ_D)\ssl_cert.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_cert.c

$(OBJ_D)\ssl_sess.obj: $(SRC_D)\ssl\ssl_sess.c
	$(CC) /Fo$(OBJ_D)\ssl_sess.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_sess.c

$(OBJ_D)\ssl_ciph.obj: $(SRC_D)\ssl\ssl_ciph.c
	$(CC) /Fo$(OBJ_D)\ssl_ciph.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_ciph.c

$(OBJ_D)\ssl_stat.obj: $(SRC_D)\ssl\ssl_stat.c
	$(CC) /Fo$(OBJ_D)\ssl_stat.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_stat.c

$(OBJ_D)\ssl_rsa.obj: $(SRC_D)\ssl\ssl_rsa.c
	$(CC) /Fo$(OBJ_D)\ssl_rsa.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_rsa.c

$(OBJ_D)\ssl_asn1.obj: $(SRC_D)\ssl\ssl_asn1.c
	$(CC) /Fo$(OBJ_D)\ssl_asn1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_asn1.c

$(OBJ_D)\ssl_txt.obj: $(SRC_D)\ssl\ssl_txt.c
	$(CC) /Fo$(OBJ_D)\ssl_txt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_txt.c

$(OBJ_D)\ssl_algs.obj: $(SRC_D)\ssl\ssl_algs.c
	$(CC) /Fo$(OBJ_D)\ssl_algs.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_algs.c

$(OBJ_D)\bio_ssl.obj: $(SRC_D)\ssl\bio_ssl.c
	$(CC) /Fo$(OBJ_D)\bio_ssl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\bio_ssl.c

$(OBJ_D)\ssl_err.obj: $(SRC_D)\ssl\ssl_err.c
	$(CC) /Fo$(OBJ_D)\ssl_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\ssl_err.c

$(OBJ_D)\kssl.obj: $(SRC_D)\ssl\kssl.c
	$(CC) /Fo$(OBJ_D)\kssl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBSSL -c $(SRC_D)\ssl\kssl.c

crypto\bn\asm\x86w32.obj: crypto\bn\asm\x86w32.asm
	$(ASM) /Focrypto\bn\asm\x86w32.obj $(SRC_D)\crypto\bn\asm\x86w32.asm

$(OBJ_D)\cryptlib.obj: $(SRC_D)\crypto\cryptlib.c
	$(CC) /Fo$(OBJ_D)\cryptlib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\cryptlib.c

$(OBJ_D)\mem.obj: $(SRC_D)\crypto\mem.c
	$(CC) /Fo$(OBJ_D)\mem.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\mem.c

$(OBJ_D)\mem_clr.obj: $(SRC_D)\crypto\mem_clr.c
	$(CC) /Fo$(OBJ_D)\mem_clr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\mem_clr.c

$(OBJ_D)\mem_dbg.obj: $(SRC_D)\crypto\mem_dbg.c
	$(CC) /Fo$(OBJ_D)\mem_dbg.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\mem_dbg.c

$(OBJ_D)\cversion.obj: $(SRC_D)\crypto\cversion.c
	$(CC) /Fo$(OBJ_D)\cversion.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -DMK1MF_BUILD -DMK1MF_PLATFORM_VC_W31_32 -c $(SRC_D)\crypto\cversion.c

$(OBJ_D)\ex_data.obj: $(SRC_D)\crypto\ex_data.c
	$(CC) /Fo$(OBJ_D)\ex_data.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ex_data.c

$(OBJ_D)\tmdiff.obj: $(SRC_D)\crypto\tmdiff.c
	$(CC) /Fo$(OBJ_D)\tmdiff.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\tmdiff.c

$(OBJ_D)\cpt_err.obj: $(SRC_D)\crypto\cpt_err.c
	$(CC) /Fo$(OBJ_D)\cpt_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\cpt_err.c

$(OBJ_D)\ebcdic.obj: $(SRC_D)\crypto\ebcdic.c
	$(CC) /Fo$(OBJ_D)\ebcdic.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ebcdic.c

$(OBJ_D)\uid.obj: $(SRC_D)\crypto\uid.c
	$(CC) /Fo$(OBJ_D)\uid.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\uid.c

$(OBJ_D)\o_time.obj: $(SRC_D)\crypto\o_time.c
	$(CC) /Fo$(OBJ_D)\o_time.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\o_time.c

$(OBJ_D)\o_str.obj: $(SRC_D)\crypto\o_str.c
	$(CC) /Fo$(OBJ_D)\o_str.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\o_str.c

$(OBJ_D)\md2_dgst.obj: $(SRC_D)\crypto\md2\md2_dgst.c
	$(CC) /Fo$(OBJ_D)\md2_dgst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\md2\md2_dgst.c

$(OBJ_D)\md2_one.obj: $(SRC_D)\crypto\md2\md2_one.c
	$(CC) /Fo$(OBJ_D)\md2_one.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\md2\md2_one.c

$(OBJ_D)\md4_dgst.obj: $(SRC_D)\crypto\md4\md4_dgst.c
	$(CC) /Fo$(OBJ_D)\md4_dgst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\md4\md4_dgst.c

$(OBJ_D)\md4_one.obj: $(SRC_D)\crypto\md4\md4_one.c
	$(CC) /Fo$(OBJ_D)\md4_one.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\md4\md4_one.c

$(OBJ_D)\md5_dgst.obj: $(SRC_D)\crypto\md5\md5_dgst.c
	$(CC) /Fo$(OBJ_D)\md5_dgst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\md5\md5_dgst.c

$(OBJ_D)\md5_one.obj: $(SRC_D)\crypto\md5\md5_one.c
	$(CC) /Fo$(OBJ_D)\md5_one.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\md5\md5_one.c

$(OBJ_D)\sha_dgst.obj: $(SRC_D)\crypto\sha\sha_dgst.c
	$(CC) /Fo$(OBJ_D)\sha_dgst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\sha\sha_dgst.c

$(OBJ_D)\sha1dgst.obj: $(SRC_D)\crypto\sha\sha1dgst.c
	$(CC) /Fo$(OBJ_D)\sha1dgst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\sha\sha1dgst.c

$(OBJ_D)\sha_one.obj: $(SRC_D)\crypto\sha\sha_one.c
	$(CC) /Fo$(OBJ_D)\sha_one.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\sha\sha_one.c

$(OBJ_D)\sha1_one.obj: $(SRC_D)\crypto\sha\sha1_one.c
	$(CC) /Fo$(OBJ_D)\sha1_one.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\sha\sha1_one.c

$(OBJ_D)\mdc2dgst.obj: $(SRC_D)\crypto\mdc2\mdc2dgst.c
	$(CC) /Fo$(OBJ_D)\mdc2dgst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\mdc2\mdc2dgst.c

$(OBJ_D)\mdc2_one.obj: $(SRC_D)\crypto\mdc2\mdc2_one.c
	$(CC) /Fo$(OBJ_D)\mdc2_one.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\mdc2\mdc2_one.c

$(OBJ_D)\hmac.obj: $(SRC_D)\crypto\hmac\hmac.c
	$(CC) /Fo$(OBJ_D)\hmac.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\hmac\hmac.c

$(OBJ_D)\rmd_dgst.obj: $(SRC_D)\crypto\ripemd\rmd_dgst.c
	$(CC) /Fo$(OBJ_D)\rmd_dgst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ripemd\rmd_dgst.c

$(OBJ_D)\rmd_one.obj: $(SRC_D)\crypto\ripemd\rmd_one.c
	$(CC) /Fo$(OBJ_D)\rmd_one.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ripemd\rmd_one.c

$(OBJ_D)\set_key.obj: $(SRC_D)\crypto\des\set_key.c
	$(CC) /Fo$(OBJ_D)\set_key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\set_key.c

$(OBJ_D)\ecb_enc.obj: $(SRC_D)\crypto\des\ecb_enc.c
	$(CC) /Fo$(OBJ_D)\ecb_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\ecb_enc.c

$(OBJ_D)\cbc_enc.obj: $(SRC_D)\crypto\des\cbc_enc.c
	$(CC) /Fo$(OBJ_D)\cbc_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\cbc_enc.c

$(OBJ_D)\ecb3_enc.obj: $(SRC_D)\crypto\des\ecb3_enc.c
	$(CC) /Fo$(OBJ_D)\ecb3_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\ecb3_enc.c

$(OBJ_D)\cfb64enc.obj: $(SRC_D)\crypto\des\cfb64enc.c
	$(CC) /Fo$(OBJ_D)\cfb64enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\cfb64enc.c

$(OBJ_D)\cfb64ede.obj: $(SRC_D)\crypto\des\cfb64ede.c
	$(CC) /Fo$(OBJ_D)\cfb64ede.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\cfb64ede.c

$(OBJ_D)\cfb_enc.obj: $(SRC_D)\crypto\des\cfb_enc.c
	$(CC) /Fo$(OBJ_D)\cfb_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\cfb_enc.c

$(OBJ_D)\ofb64ede.obj: $(SRC_D)\crypto\des\ofb64ede.c
	$(CC) /Fo$(OBJ_D)\ofb64ede.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\ofb64ede.c

$(OBJ_D)\enc_read.obj: $(SRC_D)\crypto\des\enc_read.c
	$(CC) /Fo$(OBJ_D)\enc_read.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\enc_read.c

$(OBJ_D)\enc_writ.obj: $(SRC_D)\crypto\des\enc_writ.c
	$(CC) /Fo$(OBJ_D)\enc_writ.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\enc_writ.c

$(OBJ_D)\ofb64enc.obj: $(SRC_D)\crypto\des\ofb64enc.c
	$(CC) /Fo$(OBJ_D)\ofb64enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\ofb64enc.c

$(OBJ_D)\ofb_enc.obj: $(SRC_D)\crypto\des\ofb_enc.c
	$(CC) /Fo$(OBJ_D)\ofb_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\ofb_enc.c

$(OBJ_D)\str2key.obj: $(SRC_D)\crypto\des\str2key.c
	$(CC) /Fo$(OBJ_D)\str2key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\str2key.c

$(OBJ_D)\pcbc_enc.obj: $(SRC_D)\crypto\des\pcbc_enc.c
	$(CC) /Fo$(OBJ_D)\pcbc_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\pcbc_enc.c

$(OBJ_D)\qud_cksm.obj: $(SRC_D)\crypto\des\qud_cksm.c
	$(CC) /Fo$(OBJ_D)\qud_cksm.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\qud_cksm.c

$(OBJ_D)\rand_key.obj: $(SRC_D)\crypto\des\rand_key.c
	$(CC) /Fo$(OBJ_D)\rand_key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\rand_key.c

$(OBJ_D)\des_enc.obj: $(SRC_D)\crypto\des\des_enc.c
	$(CC) /Fo$(OBJ_D)\des_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\des_enc.c

$(OBJ_D)\fcrypt_b.obj: $(SRC_D)\crypto\des\fcrypt_b.c
	$(CC) /Fo$(OBJ_D)\fcrypt_b.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\fcrypt_b.c

$(OBJ_D)\fcrypt.obj: $(SRC_D)\crypto\des\fcrypt.c
	$(CC) /Fo$(OBJ_D)\fcrypt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\fcrypt.c

$(OBJ_D)\xcbc_enc.obj: $(SRC_D)\crypto\des\xcbc_enc.c
	$(CC) /Fo$(OBJ_D)\xcbc_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\xcbc_enc.c

$(OBJ_D)\rpc_enc.obj: $(SRC_D)\crypto\des\rpc_enc.c
	$(CC) /Fo$(OBJ_D)\rpc_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\rpc_enc.c

$(OBJ_D)\cbc_cksm.obj: $(SRC_D)\crypto\des\cbc_cksm.c
	$(CC) /Fo$(OBJ_D)\cbc_cksm.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\cbc_cksm.c

$(OBJ_D)\ede_cbcm_enc.obj: $(SRC_D)\crypto\des\ede_cbcm_enc.c
	$(CC) /Fo$(OBJ_D)\ede_cbcm_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\ede_cbcm_enc.c

$(OBJ_D)\des_old.obj: $(SRC_D)\crypto\des\des_old.c
	$(CC) /Fo$(OBJ_D)\des_old.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\des_old.c

$(OBJ_D)\des_old2.obj: $(SRC_D)\crypto\des\des_old2.c
	$(CC) /Fo$(OBJ_D)\des_old2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\des_old2.c

$(OBJ_D)\read2pwd.obj: $(SRC_D)\crypto\des\read2pwd.c
	$(CC) /Fo$(OBJ_D)\read2pwd.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\des\read2pwd.c

$(OBJ_D)\rc2_ecb.obj: $(SRC_D)\crypto\rc2\rc2_ecb.c
	$(CC) /Fo$(OBJ_D)\rc2_ecb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc2\rc2_ecb.c

$(OBJ_D)\rc2_skey.obj: $(SRC_D)\crypto\rc2\rc2_skey.c
	$(CC) /Fo$(OBJ_D)\rc2_skey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc2\rc2_skey.c

$(OBJ_D)\rc2_cbc.obj: $(SRC_D)\crypto\rc2\rc2_cbc.c
	$(CC) /Fo$(OBJ_D)\rc2_cbc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc2\rc2_cbc.c

$(OBJ_D)\rc2cfb64.obj: $(SRC_D)\crypto\rc2\rc2cfb64.c
	$(CC) /Fo$(OBJ_D)\rc2cfb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc2\rc2cfb64.c

$(OBJ_D)\rc2ofb64.obj: $(SRC_D)\crypto\rc2\rc2ofb64.c
	$(CC) /Fo$(OBJ_D)\rc2ofb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc2\rc2ofb64.c

$(OBJ_D)\rc4_skey.obj: $(SRC_D)\crypto\rc4\rc4_skey.c
	$(CC) /Fo$(OBJ_D)\rc4_skey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc4\rc4_skey.c

$(OBJ_D)\rc4_enc.obj: $(SRC_D)\crypto\rc4\rc4_enc.c
	$(CC) /Fo$(OBJ_D)\rc4_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc4\rc4_enc.c

$(OBJ_D)\rc5_skey.obj: $(SRC_D)\crypto\rc5\rc5_skey.c
	$(CC) /Fo$(OBJ_D)\rc5_skey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc5\rc5_skey.c

$(OBJ_D)\rc5_ecb.obj: $(SRC_D)\crypto\rc5\rc5_ecb.c
	$(CC) /Fo$(OBJ_D)\rc5_ecb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc5\rc5_ecb.c

$(OBJ_D)\rc5_enc.obj: $(SRC_D)\crypto\rc5\rc5_enc.c
	$(CC) /Fo$(OBJ_D)\rc5_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc5\rc5_enc.c

$(OBJ_D)\rc5cfb64.obj: $(SRC_D)\crypto\rc5\rc5cfb64.c
	$(CC) /Fo$(OBJ_D)\rc5cfb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc5\rc5cfb64.c

$(OBJ_D)\rc5ofb64.obj: $(SRC_D)\crypto\rc5\rc5ofb64.c
	$(CC) /Fo$(OBJ_D)\rc5ofb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rc5\rc5ofb64.c

$(OBJ_D)\i_cbc.obj: $(SRC_D)\crypto\idea\i_cbc.c
	$(CC) /Fo$(OBJ_D)\i_cbc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\idea\i_cbc.c

$(OBJ_D)\i_cfb64.obj: $(SRC_D)\crypto\idea\i_cfb64.c
	$(CC) /Fo$(OBJ_D)\i_cfb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\idea\i_cfb64.c

$(OBJ_D)\i_ofb64.obj: $(SRC_D)\crypto\idea\i_ofb64.c
	$(CC) /Fo$(OBJ_D)\i_ofb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\idea\i_ofb64.c

$(OBJ_D)\i_ecb.obj: $(SRC_D)\crypto\idea\i_ecb.c
	$(CC) /Fo$(OBJ_D)\i_ecb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\idea\i_ecb.c

$(OBJ_D)\i_skey.obj: $(SRC_D)\crypto\idea\i_skey.c
	$(CC) /Fo$(OBJ_D)\i_skey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\idea\i_skey.c

$(OBJ_D)\bf_skey.obj: $(SRC_D)\crypto\bf\bf_skey.c
	$(CC) /Fo$(OBJ_D)\bf_skey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bf\bf_skey.c

$(OBJ_D)\bf_ecb.obj: $(SRC_D)\crypto\bf\bf_ecb.c
	$(CC) /Fo$(OBJ_D)\bf_ecb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bf\bf_ecb.c

$(OBJ_D)\bf_enc.obj: $(SRC_D)\crypto\bf\bf_enc.c
	$(CC) /Fo$(OBJ_D)\bf_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bf\bf_enc.c

$(OBJ_D)\bf_cfb64.obj: $(SRC_D)\crypto\bf\bf_cfb64.c
	$(CC) /Fo$(OBJ_D)\bf_cfb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bf\bf_cfb64.c

$(OBJ_D)\bf_ofb64.obj: $(SRC_D)\crypto\bf\bf_ofb64.c
	$(CC) /Fo$(OBJ_D)\bf_ofb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bf\bf_ofb64.c

$(OBJ_D)\c_skey.obj: $(SRC_D)\crypto\cast\c_skey.c
	$(CC) /Fo$(OBJ_D)\c_skey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\cast\c_skey.c

$(OBJ_D)\c_ecb.obj: $(SRC_D)\crypto\cast\c_ecb.c
	$(CC) /Fo$(OBJ_D)\c_ecb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\cast\c_ecb.c

$(OBJ_D)\c_enc.obj: $(SRC_D)\crypto\cast\c_enc.c
	$(CC) /Fo$(OBJ_D)\c_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\cast\c_enc.c

$(OBJ_D)\c_cfb64.obj: $(SRC_D)\crypto\cast\c_cfb64.c
	$(CC) /Fo$(OBJ_D)\c_cfb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\cast\c_cfb64.c

$(OBJ_D)\c_ofb64.obj: $(SRC_D)\crypto\cast\c_ofb64.c
	$(CC) /Fo$(OBJ_D)\c_ofb64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\cast\c_ofb64.c

$(OBJ_D)\aes_core.obj: $(SRC_D)\crypto\aes\aes_core.c
	$(CC) /Fo$(OBJ_D)\aes_core.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\aes\aes_core.c

$(OBJ_D)\aes_misc.obj: $(SRC_D)\crypto\aes\aes_misc.c
	$(CC) /Fo$(OBJ_D)\aes_misc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\aes\aes_misc.c

$(OBJ_D)\aes_ecb.obj: $(SRC_D)\crypto\aes\aes_ecb.c
	$(CC) /Fo$(OBJ_D)\aes_ecb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\aes\aes_ecb.c

$(OBJ_D)\aes_cbc.obj: $(SRC_D)\crypto\aes\aes_cbc.c
	$(CC) /Fo$(OBJ_D)\aes_cbc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\aes\aes_cbc.c

$(OBJ_D)\aes_cfb.obj: $(SRC_D)\crypto\aes\aes_cfb.c
	$(CC) /Fo$(OBJ_D)\aes_cfb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\aes\aes_cfb.c

$(OBJ_D)\aes_ofb.obj: $(SRC_D)\crypto\aes\aes_ofb.c
	$(CC) /Fo$(OBJ_D)\aes_ofb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\aes\aes_ofb.c

$(OBJ_D)\aes_ctr.obj: $(SRC_D)\crypto\aes\aes_ctr.c
	$(CC) /Fo$(OBJ_D)\aes_ctr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\aes\aes_ctr.c

$(OBJ_D)\bn_add.obj: $(SRC_D)\crypto\bn\bn_add.c
	$(CC) /Fo$(OBJ_D)\bn_add.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_add.c

$(OBJ_D)\bn_div.obj: $(SRC_D)\crypto\bn\bn_div.c
	$(CC) /Fo$(OBJ_D)\bn_div.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_div.c

$(OBJ_D)\bn_exp.obj: $(SRC_D)\crypto\bn\bn_exp.c
	$(CC) /Fo$(OBJ_D)\bn_exp.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_exp.c

$(OBJ_D)\bn_lib.obj: $(SRC_D)\crypto\bn\bn_lib.c
	$(CC) /Fo$(OBJ_D)\bn_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_lib.c

$(OBJ_D)\bn_ctx.obj: $(SRC_D)\crypto\bn\bn_ctx.c
	$(CC) /Fo$(OBJ_D)\bn_ctx.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_ctx.c

$(OBJ_D)\bn_mul.obj: $(SRC_D)\crypto\bn\bn_mul.c
	$(CC) /Fo$(OBJ_D)\bn_mul.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_mul.c

$(OBJ_D)\bn_mod.obj: $(SRC_D)\crypto\bn\bn_mod.c
	$(CC) /Fo$(OBJ_D)\bn_mod.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_mod.c

$(OBJ_D)\bn_print.obj: $(SRC_D)\crypto\bn\bn_print.c
	$(CC) /Fo$(OBJ_D)\bn_print.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_print.c

$(OBJ_D)\bn_rand.obj: $(SRC_D)\crypto\bn\bn_rand.c
	$(CC) /Fo$(OBJ_D)\bn_rand.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_rand.c

$(OBJ_D)\bn_shift.obj: $(SRC_D)\crypto\bn\bn_shift.c
	$(CC) /Fo$(OBJ_D)\bn_shift.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_shift.c

$(OBJ_D)\bn_word.obj: $(SRC_D)\crypto\bn\bn_word.c
	$(CC) /Fo$(OBJ_D)\bn_word.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_word.c

$(OBJ_D)\bn_blind.obj: $(SRC_D)\crypto\bn\bn_blind.c
	$(CC) /Fo$(OBJ_D)\bn_blind.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_blind.c

$(OBJ_D)\bn_kron.obj: $(SRC_D)\crypto\bn\bn_kron.c
	$(CC) /Fo$(OBJ_D)\bn_kron.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_kron.c

$(OBJ_D)\bn_sqrt.obj: $(SRC_D)\crypto\bn\bn_sqrt.c
	$(CC) /Fo$(OBJ_D)\bn_sqrt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_sqrt.c

$(OBJ_D)\bn_gcd.obj: $(SRC_D)\crypto\bn\bn_gcd.c
	$(CC) /Fo$(OBJ_D)\bn_gcd.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_gcd.c

$(OBJ_D)\bn_prime.obj: $(SRC_D)\crypto\bn\bn_prime.c
	$(CC) /Fo$(OBJ_D)\bn_prime.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_prime.c

$(OBJ_D)\bn_err.obj: $(SRC_D)\crypto\bn\bn_err.c
	$(CC) /Fo$(OBJ_D)\bn_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_err.c

$(OBJ_D)\bn_sqr.obj: $(SRC_D)\crypto\bn\bn_sqr.c
	$(CC) /Fo$(OBJ_D)\bn_sqr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_sqr.c

$(OBJ_D)\bn_asm.obj: $(SRC_D)\crypto\bn\bn_asm.c
	$(CC) /Fo$(OBJ_D)\bn_asm.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_asm.c

$(OBJ_D)\bn_recp.obj: $(SRC_D)\crypto\bn\bn_recp.c
	$(CC) /Fo$(OBJ_D)\bn_recp.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_recp.c

$(OBJ_D)\bn_mont.obj: $(SRC_D)\crypto\bn\bn_mont.c
	$(CC) /Fo$(OBJ_D)\bn_mont.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_mont.c

$(OBJ_D)\bn_mpi.obj: $(SRC_D)\crypto\bn\bn_mpi.c
	$(CC) /Fo$(OBJ_D)\bn_mpi.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_mpi.c

$(OBJ_D)\bn_exp2.obj: $(SRC_D)\crypto\bn\bn_exp2.c
	$(CC) /Fo$(OBJ_D)\bn_exp2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_exp2.c

$(OBJ_D)\bn_x931p.obj: $(SRC_D)\crypto\bn\bn_x931p.c
	$(CC) /Fo$(OBJ_D)\bn_x931p.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bn\bn_x931p.c

$(OBJ_D)\rsa_eay.obj: $(SRC_D)\crypto\rsa\rsa_eay.c
	$(CC) /Fo$(OBJ_D)\rsa_eay.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_eay.c

$(OBJ_D)\rsa_gen.obj: $(SRC_D)\crypto\rsa\rsa_gen.c
	$(CC) /Fo$(OBJ_D)\rsa_gen.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_gen.c

$(OBJ_D)\rsa_lib.obj: $(SRC_D)\crypto\rsa\rsa_lib.c
	$(CC) /Fo$(OBJ_D)\rsa_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_lib.c

$(OBJ_D)\rsa_sign.obj: $(SRC_D)\crypto\rsa\rsa_sign.c
	$(CC) /Fo$(OBJ_D)\rsa_sign.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_sign.c

$(OBJ_D)\rsa_saos.obj: $(SRC_D)\crypto\rsa\rsa_saos.c
	$(CC) /Fo$(OBJ_D)\rsa_saos.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_saos.c

$(OBJ_D)\rsa_err.obj: $(SRC_D)\crypto\rsa\rsa_err.c
	$(CC) /Fo$(OBJ_D)\rsa_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_err.c

$(OBJ_D)\rsa_pk1.obj: $(SRC_D)\crypto\rsa\rsa_pk1.c
	$(CC) /Fo$(OBJ_D)\rsa_pk1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_pk1.c

$(OBJ_D)\rsa_ssl.obj: $(SRC_D)\crypto\rsa\rsa_ssl.c
	$(CC) /Fo$(OBJ_D)\rsa_ssl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_ssl.c

$(OBJ_D)\rsa_none.obj: $(SRC_D)\crypto\rsa\rsa_none.c
	$(CC) /Fo$(OBJ_D)\rsa_none.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_none.c

$(OBJ_D)\rsa_oaep.obj: $(SRC_D)\crypto\rsa\rsa_oaep.c
	$(CC) /Fo$(OBJ_D)\rsa_oaep.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_oaep.c

$(OBJ_D)\rsa_chk.obj: $(SRC_D)\crypto\rsa\rsa_chk.c
	$(CC) /Fo$(OBJ_D)\rsa_chk.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_chk.c

$(OBJ_D)\rsa_null.obj: $(SRC_D)\crypto\rsa\rsa_null.c
	$(CC) /Fo$(OBJ_D)\rsa_null.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_null.c

$(OBJ_D)\rsa_pss.obj: $(SRC_D)\crypto\rsa\rsa_pss.c
	$(CC) /Fo$(OBJ_D)\rsa_pss.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_pss.c

$(OBJ_D)\rsa_x931.obj: $(SRC_D)\crypto\rsa\rsa_x931.c
	$(CC) /Fo$(OBJ_D)\rsa_x931.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_x931.c

$(OBJ_D)\rsa_asn1.obj: $(SRC_D)\crypto\rsa\rsa_asn1.c
	$(CC) /Fo$(OBJ_D)\rsa_asn1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rsa\rsa_asn1.c

$(OBJ_D)\dsa_gen.obj: $(SRC_D)\crypto\dsa\dsa_gen.c
	$(CC) /Fo$(OBJ_D)\dsa_gen.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dsa\dsa_gen.c

$(OBJ_D)\dsa_key.obj: $(SRC_D)\crypto\dsa\dsa_key.c
	$(CC) /Fo$(OBJ_D)\dsa_key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dsa\dsa_key.c

$(OBJ_D)\dsa_lib.obj: $(SRC_D)\crypto\dsa\dsa_lib.c
	$(CC) /Fo$(OBJ_D)\dsa_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dsa\dsa_lib.c

$(OBJ_D)\dsa_asn1.obj: $(SRC_D)\crypto\dsa\dsa_asn1.c
	$(CC) /Fo$(OBJ_D)\dsa_asn1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dsa\dsa_asn1.c

$(OBJ_D)\dsa_vrf.obj: $(SRC_D)\crypto\dsa\dsa_vrf.c
	$(CC) /Fo$(OBJ_D)\dsa_vrf.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dsa\dsa_vrf.c

$(OBJ_D)\dsa_sign.obj: $(SRC_D)\crypto\dsa\dsa_sign.c
	$(CC) /Fo$(OBJ_D)\dsa_sign.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dsa\dsa_sign.c

$(OBJ_D)\dsa_err.obj: $(SRC_D)\crypto\dsa\dsa_err.c
	$(CC) /Fo$(OBJ_D)\dsa_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dsa\dsa_err.c

$(OBJ_D)\dsa_ossl.obj: $(SRC_D)\crypto\dsa\dsa_ossl.c
	$(CC) /Fo$(OBJ_D)\dsa_ossl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dsa\dsa_ossl.c

$(OBJ_D)\dso_dl.obj: $(SRC_D)\crypto\dso\dso_dl.c
	$(CC) /Fo$(OBJ_D)\dso_dl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dso\dso_dl.c

$(OBJ_D)\dso_dlfcn.obj: $(SRC_D)\crypto\dso\dso_dlfcn.c
	$(CC) /Fo$(OBJ_D)\dso_dlfcn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dso\dso_dlfcn.c

$(OBJ_D)\dso_err.obj: $(SRC_D)\crypto\dso\dso_err.c
	$(CC) /Fo$(OBJ_D)\dso_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dso\dso_err.c

$(OBJ_D)\dso_lib.obj: $(SRC_D)\crypto\dso\dso_lib.c
	$(CC) /Fo$(OBJ_D)\dso_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dso\dso_lib.c

$(OBJ_D)\dso_null.obj: $(SRC_D)\crypto\dso\dso_null.c
	$(CC) /Fo$(OBJ_D)\dso_null.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dso\dso_null.c

$(OBJ_D)\dso_openssl.obj: $(SRC_D)\crypto\dso\dso_openssl.c
	$(CC) /Fo$(OBJ_D)\dso_openssl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dso\dso_openssl.c

$(OBJ_D)\dso_win32.obj: $(SRC_D)\crypto\dso\dso_win32.c
	$(CC) /Fo$(OBJ_D)\dso_win32.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dso\dso_win32.c

$(OBJ_D)\dso_vms.obj: $(SRC_D)\crypto\dso\dso_vms.c
	$(CC) /Fo$(OBJ_D)\dso_vms.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dso\dso_vms.c

$(OBJ_D)\dh_asn1.obj: $(SRC_D)\crypto\dh\dh_asn1.c
	$(CC) /Fo$(OBJ_D)\dh_asn1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dh\dh_asn1.c

$(OBJ_D)\dh_gen.obj: $(SRC_D)\crypto\dh\dh_gen.c
	$(CC) /Fo$(OBJ_D)\dh_gen.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dh\dh_gen.c

$(OBJ_D)\dh_key.obj: $(SRC_D)\crypto\dh\dh_key.c
	$(CC) /Fo$(OBJ_D)\dh_key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dh\dh_key.c

$(OBJ_D)\dh_lib.obj: $(SRC_D)\crypto\dh\dh_lib.c
	$(CC) /Fo$(OBJ_D)\dh_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dh\dh_lib.c

$(OBJ_D)\dh_check.obj: $(SRC_D)\crypto\dh\dh_check.c
	$(CC) /Fo$(OBJ_D)\dh_check.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dh\dh_check.c

$(OBJ_D)\dh_err.obj: $(SRC_D)\crypto\dh\dh_err.c
	$(CC) /Fo$(OBJ_D)\dh_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\dh\dh_err.c

$(OBJ_D)\ec_lib.obj: $(SRC_D)\crypto\ec\ec_lib.c
	$(CC) /Fo$(OBJ_D)\ec_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ec\ec_lib.c

$(OBJ_D)\ecp_smpl.obj: $(SRC_D)\crypto\ec\ecp_smpl.c
	$(CC) /Fo$(OBJ_D)\ecp_smpl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ec\ecp_smpl.c

$(OBJ_D)\ecp_mont.obj: $(SRC_D)\crypto\ec\ecp_mont.c
	$(CC) /Fo$(OBJ_D)\ecp_mont.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ec\ecp_mont.c

$(OBJ_D)\ecp_recp.obj: $(SRC_D)\crypto\ec\ecp_recp.c
	$(CC) /Fo$(OBJ_D)\ecp_recp.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ec\ecp_recp.c

$(OBJ_D)\ecp_nist.obj: $(SRC_D)\crypto\ec\ecp_nist.c
	$(CC) /Fo$(OBJ_D)\ecp_nist.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ec\ecp_nist.c

$(OBJ_D)\ec_cvt.obj: $(SRC_D)\crypto\ec\ec_cvt.c
	$(CC) /Fo$(OBJ_D)\ec_cvt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ec\ec_cvt.c

$(OBJ_D)\ec_mult.obj: $(SRC_D)\crypto\ec\ec_mult.c
	$(CC) /Fo$(OBJ_D)\ec_mult.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ec\ec_mult.c

$(OBJ_D)\ec_err.obj: $(SRC_D)\crypto\ec\ec_err.c
	$(CC) /Fo$(OBJ_D)\ec_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ec\ec_err.c

$(OBJ_D)\buffer.obj: $(SRC_D)\crypto\buffer\buffer.c
	$(CC) /Fo$(OBJ_D)\buffer.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\buffer\buffer.c

$(OBJ_D)\buf_err.obj: $(SRC_D)\crypto\buffer\buf_err.c
	$(CC) /Fo$(OBJ_D)\buf_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\buffer\buf_err.c

$(OBJ_D)\bio_lib.obj: $(SRC_D)\crypto\bio\bio_lib.c
	$(CC) /Fo$(OBJ_D)\bio_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bio_lib.c

$(OBJ_D)\bio_cb.obj: $(SRC_D)\crypto\bio\bio_cb.c
	$(CC) /Fo$(OBJ_D)\bio_cb.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bio_cb.c

$(OBJ_D)\bio_err.obj: $(SRC_D)\crypto\bio\bio_err.c
	$(CC) /Fo$(OBJ_D)\bio_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bio_err.c

$(OBJ_D)\bss_mem.obj: $(SRC_D)\crypto\bio\bss_mem.c
	$(CC) /Fo$(OBJ_D)\bss_mem.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_mem.c

$(OBJ_D)\bss_null.obj: $(SRC_D)\crypto\bio\bss_null.c
	$(CC) /Fo$(OBJ_D)\bss_null.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_null.c

$(OBJ_D)\bss_fd.obj: $(SRC_D)\crypto\bio\bss_fd.c
	$(CC) /Fo$(OBJ_D)\bss_fd.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_fd.c

$(OBJ_D)\bss_file.obj: $(SRC_D)\crypto\bio\bss_file.c
	$(CC) /Fo$(OBJ_D)\bss_file.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_file.c

$(OBJ_D)\bss_sock.obj: $(SRC_D)\crypto\bio\bss_sock.c
	$(CC) /Fo$(OBJ_D)\bss_sock.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_sock.c

$(OBJ_D)\bss_conn.obj: $(SRC_D)\crypto\bio\bss_conn.c
	$(CC) /Fo$(OBJ_D)\bss_conn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_conn.c

$(OBJ_D)\bf_null.obj: $(SRC_D)\crypto\bio\bf_null.c
	$(CC) /Fo$(OBJ_D)\bf_null.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bf_null.c

$(OBJ_D)\bf_buff.obj: $(SRC_D)\crypto\bio\bf_buff.c
	$(CC) /Fo$(OBJ_D)\bf_buff.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bf_buff.c

$(OBJ_D)\b_print.obj: $(SRC_D)\crypto\bio\b_print.c
	$(CC) /Fo$(OBJ_D)\b_print.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\b_print.c

$(OBJ_D)\b_dump.obj: $(SRC_D)\crypto\bio\b_dump.c
	$(CC) /Fo$(OBJ_D)\b_dump.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\b_dump.c

$(OBJ_D)\b_sock.obj: $(SRC_D)\crypto\bio\b_sock.c
	$(CC) /Fo$(OBJ_D)\b_sock.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\b_sock.c

$(OBJ_D)\bss_acpt.obj: $(SRC_D)\crypto\bio\bss_acpt.c
	$(CC) /Fo$(OBJ_D)\bss_acpt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_acpt.c

$(OBJ_D)\bf_nbio.obj: $(SRC_D)\crypto\bio\bf_nbio.c
	$(CC) /Fo$(OBJ_D)\bf_nbio.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bf_nbio.c

$(OBJ_D)\bss_log.obj: $(SRC_D)\crypto\bio\bss_log.c
	$(CC) /Fo$(OBJ_D)\bss_log.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_log.c

$(OBJ_D)\bss_bio.obj: $(SRC_D)\crypto\bio\bss_bio.c
	$(CC) /Fo$(OBJ_D)\bss_bio.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\bio\bss_bio.c

$(OBJ_D)\stack.obj: $(SRC_D)\crypto\stack\stack.c
	$(CC) /Fo$(OBJ_D)\stack.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\stack\stack.c

$(OBJ_D)\lhash.obj: $(SRC_D)\crypto\lhash\lhash.c
	$(CC) /Fo$(OBJ_D)\lhash.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\lhash\lhash.c

$(OBJ_D)\lh_stats.obj: $(SRC_D)\crypto\lhash\lh_stats.c
	$(CC) /Fo$(OBJ_D)\lh_stats.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\lhash\lh_stats.c

$(OBJ_D)\md_rand.obj: $(SRC_D)\crypto\rand\md_rand.c
	$(CC) /Fo$(OBJ_D)\md_rand.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rand\md_rand.c

$(OBJ_D)\randfile.obj: $(SRC_D)\crypto\rand\randfile.c
	$(CC) /Fo$(OBJ_D)\randfile.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rand\randfile.c

$(OBJ_D)\rand_lib.obj: $(SRC_D)\crypto\rand\rand_lib.c
	$(CC) /Fo$(OBJ_D)\rand_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rand\rand_lib.c

$(OBJ_D)\rand_err.obj: $(SRC_D)\crypto\rand\rand_err.c
	$(CC) /Fo$(OBJ_D)\rand_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rand\rand_err.c

$(OBJ_D)\rand_egd.obj: $(SRC_D)\crypto\rand\rand_egd.c
	$(CC) /Fo$(OBJ_D)\rand_egd.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rand\rand_egd.c

$(OBJ_D)\rand_win.obj: $(SRC_D)\crypto\rand\rand_win.c
	$(CC) /Fo$(OBJ_D)\rand_win.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rand\rand_win.c

$(OBJ_D)\rand_unix.obj: $(SRC_D)\crypto\rand\rand_unix.c
	$(CC) /Fo$(OBJ_D)\rand_unix.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rand\rand_unix.c

$(OBJ_D)\rand_os2.obj: $(SRC_D)\crypto\rand\rand_os2.c
	$(CC) /Fo$(OBJ_D)\rand_os2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\rand\rand_os2.c

$(OBJ_D)\err.obj: $(SRC_D)\crypto\err\err.c
	$(CC) /Fo$(OBJ_D)\err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\err\err.c

$(OBJ_D)\err_all.obj: $(SRC_D)\crypto\err\err_all.c
	$(CC) /Fo$(OBJ_D)\err_all.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\err\err_all.c

$(OBJ_D)\err_prn.obj: $(SRC_D)\crypto\err\err_prn.c
	$(CC) /Fo$(OBJ_D)\err_prn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\err\err_prn.c

$(OBJ_D)\o_names.obj: $(SRC_D)\crypto\objects\o_names.c
	$(CC) /Fo$(OBJ_D)\o_names.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\objects\o_names.c

$(OBJ_D)\obj_dat.obj: $(SRC_D)\crypto\objects\obj_dat.c
	$(CC) /Fo$(OBJ_D)\obj_dat.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\objects\obj_dat.c

$(OBJ_D)\obj_lib.obj: $(SRC_D)\crypto\objects\obj_lib.c
	$(CC) /Fo$(OBJ_D)\obj_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\objects\obj_lib.c

$(OBJ_D)\obj_err.obj: $(SRC_D)\crypto\objects\obj_err.c
	$(CC) /Fo$(OBJ_D)\obj_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\objects\obj_err.c

$(OBJ_D)\encode.obj: $(SRC_D)\crypto\evp\encode.c
	$(CC) /Fo$(OBJ_D)\encode.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\encode.c

$(OBJ_D)\digest.obj: $(SRC_D)\crypto\evp\digest.c
	$(CC) /Fo$(OBJ_D)\digest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\digest.c

$(OBJ_D)\evp_enc.obj: $(SRC_D)\crypto\evp\evp_enc.c
	$(CC) /Fo$(OBJ_D)\evp_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\evp_enc.c

$(OBJ_D)\evp_key.obj: $(SRC_D)\crypto\evp\evp_key.c
	$(CC) /Fo$(OBJ_D)\evp_key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\evp_key.c

$(OBJ_D)\evp_acnf.obj: $(SRC_D)\crypto\evp\evp_acnf.c
	$(CC) /Fo$(OBJ_D)\evp_acnf.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\evp_acnf.c

$(OBJ_D)\e_des.obj: $(SRC_D)\crypto\evp\e_des.c
	$(CC) /Fo$(OBJ_D)\e_des.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_des.c

$(OBJ_D)\e_bf.obj: $(SRC_D)\crypto\evp\e_bf.c
	$(CC) /Fo$(OBJ_D)\e_bf.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_bf.c

$(OBJ_D)\e_idea.obj: $(SRC_D)\crypto\evp\e_idea.c
	$(CC) /Fo$(OBJ_D)\e_idea.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_idea.c

$(OBJ_D)\e_des3.obj: $(SRC_D)\crypto\evp\e_des3.c
	$(CC) /Fo$(OBJ_D)\e_des3.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_des3.c

$(OBJ_D)\e_rc4.obj: $(SRC_D)\crypto\evp\e_rc4.c
	$(CC) /Fo$(OBJ_D)\e_rc4.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_rc4.c

$(OBJ_D)\e_aes.obj: $(SRC_D)\crypto\evp\e_aes.c
	$(CC) /Fo$(OBJ_D)\e_aes.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_aes.c

$(OBJ_D)\names.obj: $(SRC_D)\crypto\evp\names.c
	$(CC) /Fo$(OBJ_D)\names.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\names.c

$(OBJ_D)\e_xcbc_d.obj: $(SRC_D)\crypto\evp\e_xcbc_d.c
	$(CC) /Fo$(OBJ_D)\e_xcbc_d.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_xcbc_d.c

$(OBJ_D)\e_rc2.obj: $(SRC_D)\crypto\evp\e_rc2.c
	$(CC) /Fo$(OBJ_D)\e_rc2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_rc2.c

$(OBJ_D)\e_cast.obj: $(SRC_D)\crypto\evp\e_cast.c
	$(CC) /Fo$(OBJ_D)\e_cast.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_cast.c

$(OBJ_D)\e_rc5.obj: $(SRC_D)\crypto\evp\e_rc5.c
	$(CC) /Fo$(OBJ_D)\e_rc5.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_rc5.c

$(OBJ_D)\m_null.obj: $(SRC_D)\crypto\evp\m_null.c
	$(CC) /Fo$(OBJ_D)\m_null.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_null.c

$(OBJ_D)\m_md2.obj: $(SRC_D)\crypto\evp\m_md2.c
	$(CC) /Fo$(OBJ_D)\m_md2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_md2.c

$(OBJ_D)\m_md4.obj: $(SRC_D)\crypto\evp\m_md4.c
	$(CC) /Fo$(OBJ_D)\m_md4.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_md4.c

$(OBJ_D)\m_md5.obj: $(SRC_D)\crypto\evp\m_md5.c
	$(CC) /Fo$(OBJ_D)\m_md5.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_md5.c

$(OBJ_D)\m_sha.obj: $(SRC_D)\crypto\evp\m_sha.c
	$(CC) /Fo$(OBJ_D)\m_sha.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_sha.c

$(OBJ_D)\m_sha1.obj: $(SRC_D)\crypto\evp\m_sha1.c
	$(CC) /Fo$(OBJ_D)\m_sha1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_sha1.c

$(OBJ_D)\m_dss.obj: $(SRC_D)\crypto\evp\m_dss.c
	$(CC) /Fo$(OBJ_D)\m_dss.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_dss.c

$(OBJ_D)\m_dss1.obj: $(SRC_D)\crypto\evp\m_dss1.c
	$(CC) /Fo$(OBJ_D)\m_dss1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_dss1.c

$(OBJ_D)\m_mdc2.obj: $(SRC_D)\crypto\evp\m_mdc2.c
	$(CC) /Fo$(OBJ_D)\m_mdc2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_mdc2.c

$(OBJ_D)\m_ripemd.obj: $(SRC_D)\crypto\evp\m_ripemd.c
	$(CC) /Fo$(OBJ_D)\m_ripemd.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\m_ripemd.c

$(OBJ_D)\p_open.obj: $(SRC_D)\crypto\evp\p_open.c
	$(CC) /Fo$(OBJ_D)\p_open.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p_open.c

$(OBJ_D)\p_seal.obj: $(SRC_D)\crypto\evp\p_seal.c
	$(CC) /Fo$(OBJ_D)\p_seal.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p_seal.c

$(OBJ_D)\p_sign.obj: $(SRC_D)\crypto\evp\p_sign.c
	$(CC) /Fo$(OBJ_D)\p_sign.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p_sign.c

$(OBJ_D)\p_verify.obj: $(SRC_D)\crypto\evp\p_verify.c
	$(CC) /Fo$(OBJ_D)\p_verify.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p_verify.c

$(OBJ_D)\p_lib.obj: $(SRC_D)\crypto\evp\p_lib.c
	$(CC) /Fo$(OBJ_D)\p_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p_lib.c

$(OBJ_D)\p_enc.obj: $(SRC_D)\crypto\evp\p_enc.c
	$(CC) /Fo$(OBJ_D)\p_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p_enc.c

$(OBJ_D)\p_dec.obj: $(SRC_D)\crypto\evp\p_dec.c
	$(CC) /Fo$(OBJ_D)\p_dec.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p_dec.c

$(OBJ_D)\bio_md.obj: $(SRC_D)\crypto\evp\bio_md.c
	$(CC) /Fo$(OBJ_D)\bio_md.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\bio_md.c

$(OBJ_D)\bio_b64.obj: $(SRC_D)\crypto\evp\bio_b64.c
	$(CC) /Fo$(OBJ_D)\bio_b64.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\bio_b64.c

$(OBJ_D)\bio_enc.obj: $(SRC_D)\crypto\evp\bio_enc.c
	$(CC) /Fo$(OBJ_D)\bio_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\bio_enc.c

$(OBJ_D)\evp_err.obj: $(SRC_D)\crypto\evp\evp_err.c
	$(CC) /Fo$(OBJ_D)\evp_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\evp_err.c

$(OBJ_D)\e_null.obj: $(SRC_D)\crypto\evp\e_null.c
	$(CC) /Fo$(OBJ_D)\e_null.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_null.c

$(OBJ_D)\c_all.obj: $(SRC_D)\crypto\evp\c_all.c
	$(CC) /Fo$(OBJ_D)\c_all.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\c_all.c

$(OBJ_D)\c_allc.obj: $(SRC_D)\crypto\evp\c_allc.c
	$(CC) /Fo$(OBJ_D)\c_allc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\c_allc.c

$(OBJ_D)\c_alld.obj: $(SRC_D)\crypto\evp\c_alld.c
	$(CC) /Fo$(OBJ_D)\c_alld.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\c_alld.c

$(OBJ_D)\evp_lib.obj: $(SRC_D)\crypto\evp\evp_lib.c
	$(CC) /Fo$(OBJ_D)\evp_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\evp_lib.c

$(OBJ_D)\bio_ok.obj: $(SRC_D)\crypto\evp\bio_ok.c
	$(CC) /Fo$(OBJ_D)\bio_ok.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\bio_ok.c

$(OBJ_D)\evp_pkey.obj: $(SRC_D)\crypto\evp\evp_pkey.c
	$(CC) /Fo$(OBJ_D)\evp_pkey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\evp_pkey.c

$(OBJ_D)\evp_pbe.obj: $(SRC_D)\crypto\evp\evp_pbe.c
	$(CC) /Fo$(OBJ_D)\evp_pbe.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\evp_pbe.c

$(OBJ_D)\p5_crpt.obj: $(SRC_D)\crypto\evp\p5_crpt.c
	$(CC) /Fo$(OBJ_D)\p5_crpt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p5_crpt.c

$(OBJ_D)\p5_crpt2.obj: $(SRC_D)\crypto\evp\p5_crpt2.c
	$(CC) /Fo$(OBJ_D)\p5_crpt2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\p5_crpt2.c

$(OBJ_D)\e_old.obj: $(SRC_D)\crypto\evp\e_old.c
	$(CC) /Fo$(OBJ_D)\e_old.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\evp\e_old.c

$(OBJ_D)\a_object.obj: $(SRC_D)\crypto\asn1\a_object.c
	$(CC) /Fo$(OBJ_D)\a_object.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_object.c

$(OBJ_D)\a_bitstr.obj: $(SRC_D)\crypto\asn1\a_bitstr.c
	$(CC) /Fo$(OBJ_D)\a_bitstr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_bitstr.c

$(OBJ_D)\a_utctm.obj: $(SRC_D)\crypto\asn1\a_utctm.c
	$(CC) /Fo$(OBJ_D)\a_utctm.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_utctm.c

$(OBJ_D)\a_gentm.obj: $(SRC_D)\crypto\asn1\a_gentm.c
	$(CC) /Fo$(OBJ_D)\a_gentm.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_gentm.c

$(OBJ_D)\a_time.obj: $(SRC_D)\crypto\asn1\a_time.c
	$(CC) /Fo$(OBJ_D)\a_time.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_time.c

$(OBJ_D)\a_int.obj: $(SRC_D)\crypto\asn1\a_int.c
	$(CC) /Fo$(OBJ_D)\a_int.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_int.c

$(OBJ_D)\a_octet.obj: $(SRC_D)\crypto\asn1\a_octet.c
	$(CC) /Fo$(OBJ_D)\a_octet.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_octet.c

$(OBJ_D)\a_print.obj: $(SRC_D)\crypto\asn1\a_print.c
	$(CC) /Fo$(OBJ_D)\a_print.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_print.c

$(OBJ_D)\a_type.obj: $(SRC_D)\crypto\asn1\a_type.c
	$(CC) /Fo$(OBJ_D)\a_type.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_type.c

$(OBJ_D)\a_set.obj: $(SRC_D)\crypto\asn1\a_set.c
	$(CC) /Fo$(OBJ_D)\a_set.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_set.c

$(OBJ_D)\a_dup.obj: $(SRC_D)\crypto\asn1\a_dup.c
	$(CC) /Fo$(OBJ_D)\a_dup.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_dup.c

$(OBJ_D)\a_d2i_fp.obj: $(SRC_D)\crypto\asn1\a_d2i_fp.c
	$(CC) /Fo$(OBJ_D)\a_d2i_fp.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_d2i_fp.c

$(OBJ_D)\a_i2d_fp.obj: $(SRC_D)\crypto\asn1\a_i2d_fp.c
	$(CC) /Fo$(OBJ_D)\a_i2d_fp.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_i2d_fp.c

$(OBJ_D)\a_enum.obj: $(SRC_D)\crypto\asn1\a_enum.c
	$(CC) /Fo$(OBJ_D)\a_enum.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_enum.c

$(OBJ_D)\a_utf8.obj: $(SRC_D)\crypto\asn1\a_utf8.c
	$(CC) /Fo$(OBJ_D)\a_utf8.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_utf8.c

$(OBJ_D)\a_sign.obj: $(SRC_D)\crypto\asn1\a_sign.c
	$(CC) /Fo$(OBJ_D)\a_sign.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_sign.c

$(OBJ_D)\a_digest.obj: $(SRC_D)\crypto\asn1\a_digest.c
	$(CC) /Fo$(OBJ_D)\a_digest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_digest.c

$(OBJ_D)\a_verify.obj: $(SRC_D)\crypto\asn1\a_verify.c
	$(CC) /Fo$(OBJ_D)\a_verify.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_verify.c

$(OBJ_D)\a_mbstr.obj: $(SRC_D)\crypto\asn1\a_mbstr.c
	$(CC) /Fo$(OBJ_D)\a_mbstr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_mbstr.c

$(OBJ_D)\a_strex.obj: $(SRC_D)\crypto\asn1\a_strex.c
	$(CC) /Fo$(OBJ_D)\a_strex.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_strex.c

$(OBJ_D)\x_algor.obj: $(SRC_D)\crypto\asn1\x_algor.c
	$(CC) /Fo$(OBJ_D)\x_algor.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_algor.c

$(OBJ_D)\x_val.obj: $(SRC_D)\crypto\asn1\x_val.c
	$(CC) /Fo$(OBJ_D)\x_val.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_val.c

$(OBJ_D)\x_pubkey.obj: $(SRC_D)\crypto\asn1\x_pubkey.c
	$(CC) /Fo$(OBJ_D)\x_pubkey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_pubkey.c

$(OBJ_D)\x_sig.obj: $(SRC_D)\crypto\asn1\x_sig.c
	$(CC) /Fo$(OBJ_D)\x_sig.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_sig.c

$(OBJ_D)\x_req.obj: $(SRC_D)\crypto\asn1\x_req.c
	$(CC) /Fo$(OBJ_D)\x_req.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_req.c

$(OBJ_D)\x_attrib.obj: $(SRC_D)\crypto\asn1\x_attrib.c
	$(CC) /Fo$(OBJ_D)\x_attrib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_attrib.c

$(OBJ_D)\x_bignum.obj: $(SRC_D)\crypto\asn1\x_bignum.c
	$(CC) /Fo$(OBJ_D)\x_bignum.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_bignum.c

$(OBJ_D)\x_long.obj: $(SRC_D)\crypto\asn1\x_long.c
	$(CC) /Fo$(OBJ_D)\x_long.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_long.c

$(OBJ_D)\x_name.obj: $(SRC_D)\crypto\asn1\x_name.c
	$(CC) /Fo$(OBJ_D)\x_name.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_name.c

$(OBJ_D)\x_x509.obj: $(SRC_D)\crypto\asn1\x_x509.c
	$(CC) /Fo$(OBJ_D)\x_x509.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_x509.c

$(OBJ_D)\x_x509a.obj: $(SRC_D)\crypto\asn1\x_x509a.c
	$(CC) /Fo$(OBJ_D)\x_x509a.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_x509a.c

$(OBJ_D)\x_crl.obj: $(SRC_D)\crypto\asn1\x_crl.c
	$(CC) /Fo$(OBJ_D)\x_crl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_crl.c

$(OBJ_D)\x_info.obj: $(SRC_D)\crypto\asn1\x_info.c
	$(CC) /Fo$(OBJ_D)\x_info.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_info.c

$(OBJ_D)\x_spki.obj: $(SRC_D)\crypto\asn1\x_spki.c
	$(CC) /Fo$(OBJ_D)\x_spki.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_spki.c

$(OBJ_D)\nsseq.obj: $(SRC_D)\crypto\asn1\nsseq.c
	$(CC) /Fo$(OBJ_D)\nsseq.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\nsseq.c

$(OBJ_D)\d2i_pu.obj: $(SRC_D)\crypto\asn1\d2i_pu.c
	$(CC) /Fo$(OBJ_D)\d2i_pu.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\d2i_pu.c

$(OBJ_D)\d2i_pr.obj: $(SRC_D)\crypto\asn1\d2i_pr.c
	$(CC) /Fo$(OBJ_D)\d2i_pr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\d2i_pr.c

$(OBJ_D)\i2d_pu.obj: $(SRC_D)\crypto\asn1\i2d_pu.c
	$(CC) /Fo$(OBJ_D)\i2d_pu.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\i2d_pu.c

$(OBJ_D)\i2d_pr.obj: $(SRC_D)\crypto\asn1\i2d_pr.c
	$(CC) /Fo$(OBJ_D)\i2d_pr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\i2d_pr.c

$(OBJ_D)\t_req.obj: $(SRC_D)\crypto\asn1\t_req.c
	$(CC) /Fo$(OBJ_D)\t_req.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\t_req.c

$(OBJ_D)\t_x509.obj: $(SRC_D)\crypto\asn1\t_x509.c
	$(CC) /Fo$(OBJ_D)\t_x509.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\t_x509.c

$(OBJ_D)\t_x509a.obj: $(SRC_D)\crypto\asn1\t_x509a.c
	$(CC) /Fo$(OBJ_D)\t_x509a.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\t_x509a.c

$(OBJ_D)\t_crl.obj: $(SRC_D)\crypto\asn1\t_crl.c
	$(CC) /Fo$(OBJ_D)\t_crl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\t_crl.c

$(OBJ_D)\t_pkey.obj: $(SRC_D)\crypto\asn1\t_pkey.c
	$(CC) /Fo$(OBJ_D)\t_pkey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\t_pkey.c

$(OBJ_D)\t_spki.obj: $(SRC_D)\crypto\asn1\t_spki.c
	$(CC) /Fo$(OBJ_D)\t_spki.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\t_spki.c

$(OBJ_D)\t_bitst.obj: $(SRC_D)\crypto\asn1\t_bitst.c
	$(CC) /Fo$(OBJ_D)\t_bitst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\t_bitst.c

$(OBJ_D)\tasn_new.obj: $(SRC_D)\crypto\asn1\tasn_new.c
	$(CC) /Fo$(OBJ_D)\tasn_new.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\tasn_new.c

$(OBJ_D)\tasn_fre.obj: $(SRC_D)\crypto\asn1\tasn_fre.c
	$(CC) /Fo$(OBJ_D)\tasn_fre.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\tasn_fre.c

$(OBJ_D)\tasn_enc.obj: $(SRC_D)\crypto\asn1\tasn_enc.c
	$(CC) /Fo$(OBJ_D)\tasn_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\tasn_enc.c

$(OBJ_D)\tasn_dec.obj: $(SRC_D)\crypto\asn1\tasn_dec.c
	$(CC) /Fo$(OBJ_D)\tasn_dec.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\tasn_dec.c

$(OBJ_D)\tasn_utl.obj: $(SRC_D)\crypto\asn1\tasn_utl.c
	$(CC) /Fo$(OBJ_D)\tasn_utl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\tasn_utl.c

$(OBJ_D)\tasn_typ.obj: $(SRC_D)\crypto\asn1\tasn_typ.c
	$(CC) /Fo$(OBJ_D)\tasn_typ.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\tasn_typ.c

$(OBJ_D)\f_int.obj: $(SRC_D)\crypto\asn1\f_int.c
	$(CC) /Fo$(OBJ_D)\f_int.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\f_int.c

$(OBJ_D)\f_string.obj: $(SRC_D)\crypto\asn1\f_string.c
	$(CC) /Fo$(OBJ_D)\f_string.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\f_string.c

$(OBJ_D)\n_pkey.obj: $(SRC_D)\crypto\asn1\n_pkey.c
	$(CC) /Fo$(OBJ_D)\n_pkey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\n_pkey.c

$(OBJ_D)\f_enum.obj: $(SRC_D)\crypto\asn1\f_enum.c
	$(CC) /Fo$(OBJ_D)\f_enum.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\f_enum.c

$(OBJ_D)\a_hdr.obj: $(SRC_D)\crypto\asn1\a_hdr.c
	$(CC) /Fo$(OBJ_D)\a_hdr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_hdr.c

$(OBJ_D)\x_pkey.obj: $(SRC_D)\crypto\asn1\x_pkey.c
	$(CC) /Fo$(OBJ_D)\x_pkey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_pkey.c

$(OBJ_D)\a_bool.obj: $(SRC_D)\crypto\asn1\a_bool.c
	$(CC) /Fo$(OBJ_D)\a_bool.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_bool.c

$(OBJ_D)\x_exten.obj: $(SRC_D)\crypto\asn1\x_exten.c
	$(CC) /Fo$(OBJ_D)\x_exten.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\x_exten.c

$(OBJ_D)\asn1_par.obj: $(SRC_D)\crypto\asn1\asn1_par.c
	$(CC) /Fo$(OBJ_D)\asn1_par.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\asn1_par.c

$(OBJ_D)\asn1_lib.obj: $(SRC_D)\crypto\asn1\asn1_lib.c
	$(CC) /Fo$(OBJ_D)\asn1_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\asn1_lib.c

$(OBJ_D)\asn1_err.obj: $(SRC_D)\crypto\asn1\asn1_err.c
	$(CC) /Fo$(OBJ_D)\asn1_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\asn1_err.c

$(OBJ_D)\a_meth.obj: $(SRC_D)\crypto\asn1\a_meth.c
	$(CC) /Fo$(OBJ_D)\a_meth.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_meth.c

$(OBJ_D)\a_bytes.obj: $(SRC_D)\crypto\asn1\a_bytes.c
	$(CC) /Fo$(OBJ_D)\a_bytes.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_bytes.c

$(OBJ_D)\a_strnid.obj: $(SRC_D)\crypto\asn1\a_strnid.c
	$(CC) /Fo$(OBJ_D)\a_strnid.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\a_strnid.c

$(OBJ_D)\evp_asn1.obj: $(SRC_D)\crypto\asn1\evp_asn1.c
	$(CC) /Fo$(OBJ_D)\evp_asn1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\evp_asn1.c

$(OBJ_D)\asn_pack.obj: $(SRC_D)\crypto\asn1\asn_pack.c
	$(CC) /Fo$(OBJ_D)\asn_pack.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\asn_pack.c

$(OBJ_D)\p5_pbe.obj: $(SRC_D)\crypto\asn1\p5_pbe.c
	$(CC) /Fo$(OBJ_D)\p5_pbe.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\p5_pbe.c

$(OBJ_D)\p5_pbev2.obj: $(SRC_D)\crypto\asn1\p5_pbev2.c
	$(CC) /Fo$(OBJ_D)\p5_pbev2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\p5_pbev2.c

$(OBJ_D)\p8_pkey.obj: $(SRC_D)\crypto\asn1\p8_pkey.c
	$(CC) /Fo$(OBJ_D)\p8_pkey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\p8_pkey.c

$(OBJ_D)\asn_moid.obj: $(SRC_D)\crypto\asn1\asn_moid.c
	$(CC) /Fo$(OBJ_D)\asn_moid.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\asn1\asn_moid.c

$(OBJ_D)\pem_sign.obj: $(SRC_D)\crypto\pem\pem_sign.c
	$(CC) /Fo$(OBJ_D)\pem_sign.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_sign.c

$(OBJ_D)\pem_seal.obj: $(SRC_D)\crypto\pem\pem_seal.c
	$(CC) /Fo$(OBJ_D)\pem_seal.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_seal.c

$(OBJ_D)\pem_info.obj: $(SRC_D)\crypto\pem\pem_info.c
	$(CC) /Fo$(OBJ_D)\pem_info.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_info.c

$(OBJ_D)\pem_lib.obj: $(SRC_D)\crypto\pem\pem_lib.c
	$(CC) /Fo$(OBJ_D)\pem_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_lib.c

$(OBJ_D)\pem_all.obj: $(SRC_D)\crypto\pem\pem_all.c
	$(CC) /Fo$(OBJ_D)\pem_all.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_all.c

$(OBJ_D)\pem_err.obj: $(SRC_D)\crypto\pem\pem_err.c
	$(CC) /Fo$(OBJ_D)\pem_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_err.c

$(OBJ_D)\pem_x509.obj: $(SRC_D)\crypto\pem\pem_x509.c
	$(CC) /Fo$(OBJ_D)\pem_x509.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_x509.c

$(OBJ_D)\pem_xaux.obj: $(SRC_D)\crypto\pem\pem_xaux.c
	$(CC) /Fo$(OBJ_D)\pem_xaux.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_xaux.c

$(OBJ_D)\pem_oth.obj: $(SRC_D)\crypto\pem\pem_oth.c
	$(CC) /Fo$(OBJ_D)\pem_oth.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_oth.c

$(OBJ_D)\pem_pk8.obj: $(SRC_D)\crypto\pem\pem_pk8.c
	$(CC) /Fo$(OBJ_D)\pem_pk8.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_pk8.c

$(OBJ_D)\pem_pkey.obj: $(SRC_D)\crypto\pem\pem_pkey.c
	$(CC) /Fo$(OBJ_D)\pem_pkey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pem\pem_pkey.c

$(OBJ_D)\x509_def.obj: $(SRC_D)\crypto\x509\x509_def.c
	$(CC) /Fo$(OBJ_D)\x509_def.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_def.c

$(OBJ_D)\x509_d2.obj: $(SRC_D)\crypto\x509\x509_d2.c
	$(CC) /Fo$(OBJ_D)\x509_d2.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_d2.c

$(OBJ_D)\x509_r2x.obj: $(SRC_D)\crypto\x509\x509_r2x.c
	$(CC) /Fo$(OBJ_D)\x509_r2x.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_r2x.c

$(OBJ_D)\x509_cmp.obj: $(SRC_D)\crypto\x509\x509_cmp.c
	$(CC) /Fo$(OBJ_D)\x509_cmp.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_cmp.c

$(OBJ_D)\x509_obj.obj: $(SRC_D)\crypto\x509\x509_obj.c
	$(CC) /Fo$(OBJ_D)\x509_obj.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_obj.c

$(OBJ_D)\x509_req.obj: $(SRC_D)\crypto\x509\x509_req.c
	$(CC) /Fo$(OBJ_D)\x509_req.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_req.c

$(OBJ_D)\x509spki.obj: $(SRC_D)\crypto\x509\x509spki.c
	$(CC) /Fo$(OBJ_D)\x509spki.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509spki.c

$(OBJ_D)\x509_vfy.obj: $(SRC_D)\crypto\x509\x509_vfy.c
	$(CC) /Fo$(OBJ_D)\x509_vfy.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_vfy.c

$(OBJ_D)\x509_set.obj: $(SRC_D)\crypto\x509\x509_set.c
	$(CC) /Fo$(OBJ_D)\x509_set.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_set.c

$(OBJ_D)\x509cset.obj: $(SRC_D)\crypto\x509\x509cset.c
	$(CC) /Fo$(OBJ_D)\x509cset.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509cset.c

$(OBJ_D)\x509rset.obj: $(SRC_D)\crypto\x509\x509rset.c
	$(CC) /Fo$(OBJ_D)\x509rset.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509rset.c

$(OBJ_D)\x509_err.obj: $(SRC_D)\crypto\x509\x509_err.c
	$(CC) /Fo$(OBJ_D)\x509_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_err.c

$(OBJ_D)\x509name.obj: $(SRC_D)\crypto\x509\x509name.c
	$(CC) /Fo$(OBJ_D)\x509name.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509name.c

$(OBJ_D)\x509_v3.obj: $(SRC_D)\crypto\x509\x509_v3.c
	$(CC) /Fo$(OBJ_D)\x509_v3.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_v3.c

$(OBJ_D)\x509_ext.obj: $(SRC_D)\crypto\x509\x509_ext.c
	$(CC) /Fo$(OBJ_D)\x509_ext.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_ext.c

$(OBJ_D)\x509_att.obj: $(SRC_D)\crypto\x509\x509_att.c
	$(CC) /Fo$(OBJ_D)\x509_att.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_att.c

$(OBJ_D)\x509type.obj: $(SRC_D)\crypto\x509\x509type.c
	$(CC) /Fo$(OBJ_D)\x509type.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509type.c

$(OBJ_D)\x509_lu.obj: $(SRC_D)\crypto\x509\x509_lu.c
	$(CC) /Fo$(OBJ_D)\x509_lu.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_lu.c

$(OBJ_D)\x_all.obj: $(SRC_D)\crypto\x509\x_all.c
	$(CC) /Fo$(OBJ_D)\x_all.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x_all.c

$(OBJ_D)\x509_txt.obj: $(SRC_D)\crypto\x509\x509_txt.c
	$(CC) /Fo$(OBJ_D)\x509_txt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_txt.c

$(OBJ_D)\x509_trs.obj: $(SRC_D)\crypto\x509\x509_trs.c
	$(CC) /Fo$(OBJ_D)\x509_trs.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\x509_trs.c

$(OBJ_D)\by_file.obj: $(SRC_D)\crypto\x509\by_file.c
	$(CC) /Fo$(OBJ_D)\by_file.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\by_file.c

$(OBJ_D)\by_dir.obj: $(SRC_D)\crypto\x509\by_dir.c
	$(CC) /Fo$(OBJ_D)\by_dir.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509\by_dir.c

$(OBJ_D)\v3_bcons.obj: $(SRC_D)\crypto\x509v3\v3_bcons.c
	$(CC) /Fo$(OBJ_D)\v3_bcons.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_bcons.c

$(OBJ_D)\v3_bitst.obj: $(SRC_D)\crypto\x509v3\v3_bitst.c
	$(CC) /Fo$(OBJ_D)\v3_bitst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_bitst.c

$(OBJ_D)\v3_conf.obj: $(SRC_D)\crypto\x509v3\v3_conf.c
	$(CC) /Fo$(OBJ_D)\v3_conf.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_conf.c

$(OBJ_D)\v3_extku.obj: $(SRC_D)\crypto\x509v3\v3_extku.c
	$(CC) /Fo$(OBJ_D)\v3_extku.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_extku.c

$(OBJ_D)\v3_ia5.obj: $(SRC_D)\crypto\x509v3\v3_ia5.c
	$(CC) /Fo$(OBJ_D)\v3_ia5.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_ia5.c

$(OBJ_D)\v3_lib.obj: $(SRC_D)\crypto\x509v3\v3_lib.c
	$(CC) /Fo$(OBJ_D)\v3_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_lib.c

$(OBJ_D)\v3_prn.obj: $(SRC_D)\crypto\x509v3\v3_prn.c
	$(CC) /Fo$(OBJ_D)\v3_prn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_prn.c

$(OBJ_D)\v3_utl.obj: $(SRC_D)\crypto\x509v3\v3_utl.c
	$(CC) /Fo$(OBJ_D)\v3_utl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_utl.c

$(OBJ_D)\v3err.obj: $(SRC_D)\crypto\x509v3\v3err.c
	$(CC) /Fo$(OBJ_D)\v3err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3err.c

$(OBJ_D)\v3_genn.obj: $(SRC_D)\crypto\x509v3\v3_genn.c
	$(CC) /Fo$(OBJ_D)\v3_genn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_genn.c

$(OBJ_D)\v3_alt.obj: $(SRC_D)\crypto\x509v3\v3_alt.c
	$(CC) /Fo$(OBJ_D)\v3_alt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_alt.c

$(OBJ_D)\v3_skey.obj: $(SRC_D)\crypto\x509v3\v3_skey.c
	$(CC) /Fo$(OBJ_D)\v3_skey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_skey.c

$(OBJ_D)\v3_akey.obj: $(SRC_D)\crypto\x509v3\v3_akey.c
	$(CC) /Fo$(OBJ_D)\v3_akey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_akey.c

$(OBJ_D)\v3_pku.obj: $(SRC_D)\crypto\x509v3\v3_pku.c
	$(CC) /Fo$(OBJ_D)\v3_pku.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_pku.c

$(OBJ_D)\v3_int.obj: $(SRC_D)\crypto\x509v3\v3_int.c
	$(CC) /Fo$(OBJ_D)\v3_int.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_int.c

$(OBJ_D)\v3_enum.obj: $(SRC_D)\crypto\x509v3\v3_enum.c
	$(CC) /Fo$(OBJ_D)\v3_enum.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_enum.c

$(OBJ_D)\v3_sxnet.obj: $(SRC_D)\crypto\x509v3\v3_sxnet.c
	$(CC) /Fo$(OBJ_D)\v3_sxnet.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_sxnet.c

$(OBJ_D)\v3_cpols.obj: $(SRC_D)\crypto\x509v3\v3_cpols.c
	$(CC) /Fo$(OBJ_D)\v3_cpols.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_cpols.c

$(OBJ_D)\v3_crld.obj: $(SRC_D)\crypto\x509v3\v3_crld.c
	$(CC) /Fo$(OBJ_D)\v3_crld.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_crld.c

$(OBJ_D)\v3_purp.obj: $(SRC_D)\crypto\x509v3\v3_purp.c
	$(CC) /Fo$(OBJ_D)\v3_purp.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_purp.c

$(OBJ_D)\v3_info.obj: $(SRC_D)\crypto\x509v3\v3_info.c
	$(CC) /Fo$(OBJ_D)\v3_info.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_info.c

$(OBJ_D)\v3_ocsp.obj: $(SRC_D)\crypto\x509v3\v3_ocsp.c
	$(CC) /Fo$(OBJ_D)\v3_ocsp.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_ocsp.c

$(OBJ_D)\v3_akeya.obj: $(SRC_D)\crypto\x509v3\v3_akeya.c
	$(CC) /Fo$(OBJ_D)\v3_akeya.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_akeya.c

$(OBJ_D)\v3_pcia.obj: $(SRC_D)\crypto\x509v3\v3_pcia.c
	$(CC) /Fo$(OBJ_D)\v3_pcia.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_pcia.c

$(OBJ_D)\v3_pci.obj: $(SRC_D)\crypto\x509v3\v3_pci.c
	$(CC) /Fo$(OBJ_D)\v3_pci.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\x509v3\v3_pci.c

$(OBJ_D)\conf_err.obj: $(SRC_D)\crypto\conf\conf_err.c
	$(CC) /Fo$(OBJ_D)\conf_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\conf\conf_err.c

$(OBJ_D)\conf_lib.obj: $(SRC_D)\crypto\conf\conf_lib.c
	$(CC) /Fo$(OBJ_D)\conf_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\conf\conf_lib.c

$(OBJ_D)\conf_api.obj: $(SRC_D)\crypto\conf\conf_api.c
	$(CC) /Fo$(OBJ_D)\conf_api.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\conf\conf_api.c

$(OBJ_D)\conf_def.obj: $(SRC_D)\crypto\conf\conf_def.c
	$(CC) /Fo$(OBJ_D)\conf_def.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\conf\conf_def.c

$(OBJ_D)\conf_mod.obj: $(SRC_D)\crypto\conf\conf_mod.c
	$(CC) /Fo$(OBJ_D)\conf_mod.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\conf\conf_mod.c

$(OBJ_D)\conf_mall.obj: $(SRC_D)\crypto\conf\conf_mall.c
	$(CC) /Fo$(OBJ_D)\conf_mall.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\conf\conf_mall.c

$(OBJ_D)\conf_sap.obj: $(SRC_D)\crypto\conf\conf_sap.c
	$(CC) /Fo$(OBJ_D)\conf_sap.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\conf\conf_sap.c

$(OBJ_D)\txt_db.obj: $(SRC_D)\crypto\txt_db\txt_db.c
	$(CC) /Fo$(OBJ_D)\txt_db.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\txt_db\txt_db.c

$(OBJ_D)\pk7_asn1.obj: $(SRC_D)\crypto\pkcs7\pk7_asn1.c
	$(CC) /Fo$(OBJ_D)\pk7_asn1.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs7\pk7_asn1.c

$(OBJ_D)\pk7_lib.obj: $(SRC_D)\crypto\pkcs7\pk7_lib.c
	$(CC) /Fo$(OBJ_D)\pk7_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs7\pk7_lib.c

$(OBJ_D)\pkcs7err.obj: $(SRC_D)\crypto\pkcs7\pkcs7err.c
	$(CC) /Fo$(OBJ_D)\pkcs7err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs7\pkcs7err.c

$(OBJ_D)\pk7_doit.obj: $(SRC_D)\crypto\pkcs7\pk7_doit.c
	$(CC) /Fo$(OBJ_D)\pk7_doit.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs7\pk7_doit.c

$(OBJ_D)\pk7_smime.obj: $(SRC_D)\crypto\pkcs7\pk7_smime.c
	$(CC) /Fo$(OBJ_D)\pk7_smime.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs7\pk7_smime.c

$(OBJ_D)\pk7_attr.obj: $(SRC_D)\crypto\pkcs7\pk7_attr.c
	$(CC) /Fo$(OBJ_D)\pk7_attr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs7\pk7_attr.c

$(OBJ_D)\pk7_mime.obj: $(SRC_D)\crypto\pkcs7\pk7_mime.c
	$(CC) /Fo$(OBJ_D)\pk7_mime.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs7\pk7_mime.c

$(OBJ_D)\p12_add.obj: $(SRC_D)\crypto\pkcs12\p12_add.c
	$(CC) /Fo$(OBJ_D)\p12_add.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_add.c

$(OBJ_D)\p12_asn.obj: $(SRC_D)\crypto\pkcs12\p12_asn.c
	$(CC) /Fo$(OBJ_D)\p12_asn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_asn.c

$(OBJ_D)\p12_attr.obj: $(SRC_D)\crypto\pkcs12\p12_attr.c
	$(CC) /Fo$(OBJ_D)\p12_attr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_attr.c

$(OBJ_D)\p12_crpt.obj: $(SRC_D)\crypto\pkcs12\p12_crpt.c
	$(CC) /Fo$(OBJ_D)\p12_crpt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_crpt.c

$(OBJ_D)\p12_crt.obj: $(SRC_D)\crypto\pkcs12\p12_crt.c
	$(CC) /Fo$(OBJ_D)\p12_crt.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_crt.c

$(OBJ_D)\p12_decr.obj: $(SRC_D)\crypto\pkcs12\p12_decr.c
	$(CC) /Fo$(OBJ_D)\p12_decr.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_decr.c

$(OBJ_D)\p12_init.obj: $(SRC_D)\crypto\pkcs12\p12_init.c
	$(CC) /Fo$(OBJ_D)\p12_init.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_init.c

$(OBJ_D)\p12_key.obj: $(SRC_D)\crypto\pkcs12\p12_key.c
	$(CC) /Fo$(OBJ_D)\p12_key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_key.c

$(OBJ_D)\p12_kiss.obj: $(SRC_D)\crypto\pkcs12\p12_kiss.c
	$(CC) /Fo$(OBJ_D)\p12_kiss.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_kiss.c

$(OBJ_D)\p12_mutl.obj: $(SRC_D)\crypto\pkcs12\p12_mutl.c
	$(CC) /Fo$(OBJ_D)\p12_mutl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_mutl.c

$(OBJ_D)\p12_utl.obj: $(SRC_D)\crypto\pkcs12\p12_utl.c
	$(CC) /Fo$(OBJ_D)\p12_utl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_utl.c

$(OBJ_D)\p12_npas.obj: $(SRC_D)\crypto\pkcs12\p12_npas.c
	$(CC) /Fo$(OBJ_D)\p12_npas.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_npas.c

$(OBJ_D)\pk12err.obj: $(SRC_D)\crypto\pkcs12\pk12err.c
	$(CC) /Fo$(OBJ_D)\pk12err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\pk12err.c

$(OBJ_D)\p12_p8d.obj: $(SRC_D)\crypto\pkcs12\p12_p8d.c
	$(CC) /Fo$(OBJ_D)\p12_p8d.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_p8d.c

$(OBJ_D)\p12_p8e.obj: $(SRC_D)\crypto\pkcs12\p12_p8e.c
	$(CC) /Fo$(OBJ_D)\p12_p8e.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\pkcs12\p12_p8e.c

$(OBJ_D)\comp_lib.obj: $(SRC_D)\crypto\comp\comp_lib.c
	$(CC) /Fo$(OBJ_D)\comp_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\comp\comp_lib.c

$(OBJ_D)\comp_err.obj: $(SRC_D)\crypto\comp\comp_err.c
	$(CC) /Fo$(OBJ_D)\comp_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\comp\comp_err.c

$(OBJ_D)\c_rle.obj: $(SRC_D)\crypto\comp\c_rle.c
	$(CC) /Fo$(OBJ_D)\c_rle.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\comp\c_rle.c

$(OBJ_D)\c_zlib.obj: $(SRC_D)\crypto\comp\c_zlib.c
	$(CC) /Fo$(OBJ_D)\c_zlib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\comp\c_zlib.c

$(OBJ_D)\eng_err.obj: $(SRC_D)\crypto\engine\eng_err.c
	$(CC) /Fo$(OBJ_D)\eng_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_err.c

$(OBJ_D)\eng_lib.obj: $(SRC_D)\crypto\engine\eng_lib.c
	$(CC) /Fo$(OBJ_D)\eng_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_lib.c

$(OBJ_D)\eng_list.obj: $(SRC_D)\crypto\engine\eng_list.c
	$(CC) /Fo$(OBJ_D)\eng_list.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_list.c

$(OBJ_D)\eng_init.obj: $(SRC_D)\crypto\engine\eng_init.c
	$(CC) /Fo$(OBJ_D)\eng_init.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_init.c

$(OBJ_D)\eng_ctrl.obj: $(SRC_D)\crypto\engine\eng_ctrl.c
	$(CC) /Fo$(OBJ_D)\eng_ctrl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_ctrl.c

$(OBJ_D)\eng_table.obj: $(SRC_D)\crypto\engine\eng_table.c
	$(CC) /Fo$(OBJ_D)\eng_table.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_table.c

$(OBJ_D)\eng_pkey.obj: $(SRC_D)\crypto\engine\eng_pkey.c
	$(CC) /Fo$(OBJ_D)\eng_pkey.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_pkey.c

$(OBJ_D)\eng_fat.obj: $(SRC_D)\crypto\engine\eng_fat.c
	$(CC) /Fo$(OBJ_D)\eng_fat.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_fat.c

$(OBJ_D)\eng_all.obj: $(SRC_D)\crypto\engine\eng_all.c
	$(CC) /Fo$(OBJ_D)\eng_all.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_all.c

$(OBJ_D)\tb_rsa.obj: $(SRC_D)\crypto\engine\tb_rsa.c
	$(CC) /Fo$(OBJ_D)\tb_rsa.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\tb_rsa.c

$(OBJ_D)\tb_dsa.obj: $(SRC_D)\crypto\engine\tb_dsa.c
	$(CC) /Fo$(OBJ_D)\tb_dsa.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\tb_dsa.c

$(OBJ_D)\tb_dh.obj: $(SRC_D)\crypto\engine\tb_dh.c
	$(CC) /Fo$(OBJ_D)\tb_dh.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\tb_dh.c

$(OBJ_D)\tb_rand.obj: $(SRC_D)\crypto\engine\tb_rand.c
	$(CC) /Fo$(OBJ_D)\tb_rand.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\tb_rand.c

$(OBJ_D)\tb_cipher.obj: $(SRC_D)\crypto\engine\tb_cipher.c
	$(CC) /Fo$(OBJ_D)\tb_cipher.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\tb_cipher.c

$(OBJ_D)\tb_digest.obj: $(SRC_D)\crypto\engine\tb_digest.c
	$(CC) /Fo$(OBJ_D)\tb_digest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\tb_digest.c

$(OBJ_D)\eng_openssl.obj: $(SRC_D)\crypto\engine\eng_openssl.c
	$(CC) /Fo$(OBJ_D)\eng_openssl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_openssl.c

$(OBJ_D)\eng_dyn.obj: $(SRC_D)\crypto\engine\eng_dyn.c
	$(CC) /Fo$(OBJ_D)\eng_dyn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_dyn.c

$(OBJ_D)\eng_cnf.obj: $(SRC_D)\crypto\engine\eng_cnf.c
	$(CC) /Fo$(OBJ_D)\eng_cnf.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\eng_cnf.c

$(OBJ_D)\hw_atalla.obj: $(SRC_D)\crypto\engine\hw_atalla.c
	$(CC) /Fo$(OBJ_D)\hw_atalla.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_atalla.c

$(OBJ_D)\hw_cswift.obj: $(SRC_D)\crypto\engine\hw_cswift.c
	$(CC) /Fo$(OBJ_D)\hw_cswift.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_cswift.c

$(OBJ_D)\hw_ncipher.obj: $(SRC_D)\crypto\engine\hw_ncipher.c
	$(CC) /Fo$(OBJ_D)\hw_ncipher.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_ncipher.c

$(OBJ_D)\hw_nuron.obj: $(SRC_D)\crypto\engine\hw_nuron.c
	$(CC) /Fo$(OBJ_D)\hw_nuron.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_nuron.c

$(OBJ_D)\hw_ubsec.obj: $(SRC_D)\crypto\engine\hw_ubsec.c
	$(CC) /Fo$(OBJ_D)\hw_ubsec.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_ubsec.c

$(OBJ_D)\hw_cryptodev.obj: $(SRC_D)\crypto\engine\hw_cryptodev.c
	$(CC) /Fo$(OBJ_D)\hw_cryptodev.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_cryptodev.c

$(OBJ_D)\hw_aep.obj: $(SRC_D)\crypto\engine\hw_aep.c
	$(CC) /Fo$(OBJ_D)\hw_aep.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_aep.c

$(OBJ_D)\hw_sureware.obj: $(SRC_D)\crypto\engine\hw_sureware.c
	$(CC) /Fo$(OBJ_D)\hw_sureware.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_sureware.c

$(OBJ_D)\hw_4758_cca.obj: $(SRC_D)\crypto\engine\hw_4758_cca.c
	$(CC) /Fo$(OBJ_D)\hw_4758_cca.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\engine\hw_4758_cca.c

$(OBJ_D)\ocsp_asn.obj: $(SRC_D)\crypto\ocsp\ocsp_asn.c
	$(CC) /Fo$(OBJ_D)\ocsp_asn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_asn.c

$(OBJ_D)\ocsp_ext.obj: $(SRC_D)\crypto\ocsp\ocsp_ext.c
	$(CC) /Fo$(OBJ_D)\ocsp_ext.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_ext.c

$(OBJ_D)\ocsp_ht.obj: $(SRC_D)\crypto\ocsp\ocsp_ht.c
	$(CC) /Fo$(OBJ_D)\ocsp_ht.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_ht.c

$(OBJ_D)\ocsp_lib.obj: $(SRC_D)\crypto\ocsp\ocsp_lib.c
	$(CC) /Fo$(OBJ_D)\ocsp_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_lib.c

$(OBJ_D)\ocsp_cl.obj: $(SRC_D)\crypto\ocsp\ocsp_cl.c
	$(CC) /Fo$(OBJ_D)\ocsp_cl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_cl.c

$(OBJ_D)\ocsp_srv.obj: $(SRC_D)\crypto\ocsp\ocsp_srv.c
	$(CC) /Fo$(OBJ_D)\ocsp_srv.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_srv.c

$(OBJ_D)\ocsp_prn.obj: $(SRC_D)\crypto\ocsp\ocsp_prn.c
	$(CC) /Fo$(OBJ_D)\ocsp_prn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_prn.c

$(OBJ_D)\ocsp_vfy.obj: $(SRC_D)\crypto\ocsp\ocsp_vfy.c
	$(CC) /Fo$(OBJ_D)\ocsp_vfy.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_vfy.c

$(OBJ_D)\ocsp_err.obj: $(SRC_D)\crypto\ocsp\ocsp_err.c
	$(CC) /Fo$(OBJ_D)\ocsp_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ocsp\ocsp_err.c

$(OBJ_D)\ui_err.obj: $(SRC_D)\crypto\ui\ui_err.c
	$(CC) /Fo$(OBJ_D)\ui_err.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ui\ui_err.c

$(OBJ_D)\ui_lib.obj: $(SRC_D)\crypto\ui\ui_lib.c
	$(CC) /Fo$(OBJ_D)\ui_lib.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ui\ui_lib.c

$(OBJ_D)\ui_openssl.obj: $(SRC_D)\crypto\ui\ui_openssl.c
	$(CC) /Fo$(OBJ_D)\ui_openssl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ui\ui_openssl.c

$(OBJ_D)\ui_util.obj: $(SRC_D)\crypto\ui\ui_util.c
	$(CC) /Fo$(OBJ_D)\ui_util.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ui\ui_util.c

$(OBJ_D)\ui_compat.obj: $(SRC_D)\crypto\ui\ui_compat.c
	$(CC) /Fo$(OBJ_D)\ui_compat.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\ui\ui_compat.c

$(OBJ_D)\krb5_asn.obj: $(SRC_D)\crypto\krb5\krb5_asn.c
	$(CC) /Fo$(OBJ_D)\krb5_asn.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\crypto\krb5\krb5_asn.c

$(OBJ_D)\fips.obj: $(SRC_D)\fips\fips.c
	$(CC) /Fo$(OBJ_D)\fips.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\fips.c

$(OBJ_D)\fips_err_wrapper.obj: $(SRC_D)\fips\fips_err_wrapper.c
	$(CC) /Fo$(OBJ_D)\fips_err_wrapper.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\fips_err_wrapper.c

$(OBJ_D)\fips_aes_core.obj: $(SRC_D)\fips\aes\fips_aes_core.c
	$(CC) /Fo$(OBJ_D)\fips_aes_core.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\aes\fips_aes_core.c

$(OBJ_D)\fips_aes_selftest.obj: $(SRC_D)\fips\aes\fips_aes_selftest.c
	$(CC) /Fo$(OBJ_D)\fips_aes_selftest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\aes\fips_aes_selftest.c

$(OBJ_D)\fips_des_enc.obj: $(SRC_D)\fips\des\fips_des_enc.c
	$(CC) /Fo$(OBJ_D)\fips_des_enc.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\des\fips_des_enc.c

$(OBJ_D)\fips_des_selftest.obj: $(SRC_D)\fips\des\fips_des_selftest.c
	$(CC) /Fo$(OBJ_D)\fips_des_selftest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\des\fips_des_selftest.c

$(OBJ_D)\fips_set_key.obj: $(SRC_D)\fips\des\fips_set_key.c
	$(CC) /Fo$(OBJ_D)\fips_set_key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\des\fips_set_key.c

$(OBJ_D)\fips_dsa_ossl.obj: $(SRC_D)\fips\dsa\fips_dsa_ossl.c
	$(CC) /Fo$(OBJ_D)\fips_dsa_ossl.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\dsa\fips_dsa_ossl.c

$(OBJ_D)\fips_dsa_gen.obj: $(SRC_D)\fips\dsa\fips_dsa_gen.c
	$(CC) /Fo$(OBJ_D)\fips_dsa_gen.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\dsa\fips_dsa_gen.c

$(OBJ_D)\fips_dsa_selftest.obj: $(SRC_D)\fips\dsa\fips_dsa_selftest.c
	$(CC) /Fo$(OBJ_D)\fips_dsa_selftest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\dsa\fips_dsa_selftest.c

$(OBJ_D)\fips_dh_check.obj: $(SRC_D)\fips\dh\fips_dh_check.c
	$(CC) /Fo$(OBJ_D)\fips_dh_check.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\dh\fips_dh_check.c

$(OBJ_D)\fips_dh_gen.obj: $(SRC_D)\fips\dh\fips_dh_gen.c
	$(CC) /Fo$(OBJ_D)\fips_dh_gen.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\dh\fips_dh_gen.c

$(OBJ_D)\fips_dh_key.obj: $(SRC_D)\fips\dh\fips_dh_key.c
	$(CC) /Fo$(OBJ_D)\fips_dh_key.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\dh\fips_dh_key.c

$(OBJ_D)\fips_hmac.obj: $(SRC_D)\fips\hmac\fips_hmac.c
	$(CC) /Fo$(OBJ_D)\fips_hmac.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\hmac\fips_hmac.c

$(OBJ_D)\fips_hmac_selftest.obj: $(SRC_D)\fips\hmac\fips_hmac_selftest.c
	$(CC) /Fo$(OBJ_D)\fips_hmac_selftest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\hmac\fips_hmac_selftest.c

$(OBJ_D)\fips_rand.obj: $(SRC_D)\fips\rand\fips_rand.c
	$(CC) /Fo$(OBJ_D)\fips_rand.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\rand\fips_rand.c

$(OBJ_D)\fips_rand_selftest.obj: $(SRC_D)\fips\rand\fips_rand_selftest.c
	$(CC) /Fo$(OBJ_D)\fips_rand_selftest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\rand\fips_rand_selftest.c

$(OBJ_D)\fips_rsa_eay.obj: $(SRC_D)\fips\rsa\fips_rsa_eay.c
	$(CC) /Fo$(OBJ_D)\fips_rsa_eay.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\rsa\fips_rsa_eay.c

$(OBJ_D)\fips_rsa_gen.obj: $(SRC_D)\fips\rsa\fips_rsa_gen.c
	$(CC) /Fo$(OBJ_D)\fips_rsa_gen.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\rsa\fips_rsa_gen.c

$(OBJ_D)\fips_rsa_selftest.obj: $(SRC_D)\fips\rsa\fips_rsa_selftest.c
	$(CC) /Fo$(OBJ_D)\fips_rsa_selftest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\rsa\fips_rsa_selftest.c

$(OBJ_D)\fips_rsa_x931g.obj: $(SRC_D)\fips\rsa\fips_rsa_x931g.c
	$(CC) /Fo$(OBJ_D)\fips_rsa_x931g.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\rsa\fips_rsa_x931g.c

$(OBJ_D)\fips_sha1dgst.obj: $(SRC_D)\fips\sha\fips_sha1dgst.c
	$(CC) /Fo$(OBJ_D)\fips_sha1dgst.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\sha\fips_sha1dgst.c

$(OBJ_D)\fips_sha1_selftest.obj: $(SRC_D)\fips\sha\fips_sha1_selftest.c
	$(CC) /Fo$(OBJ_D)\fips_sha1_selftest.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\sha\fips_sha1_selftest.c

$(OBJ_D)\fips_sha256.obj: $(SRC_D)\fips\sha\fips_sha256.c
	$(CC) /Fo$(OBJ_D)\fips_sha256.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\sha\fips_sha256.c

$(OBJ_D)\fips_sha512.obj: $(SRC_D)\fips\sha\fips_sha512.c
	$(CC) /Fo$(OBJ_D)\fips_sha512.obj  $(SHLIB_CFLAGS) -DOPENSSL_BUILD_SHLIBCRYPTO -c $(SRC_D)\fips\sha\fips_sha512.c

$(TEST_D)\md2test.exe: $(OBJ_D)\md2test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\md2test.obj
  $(TEST_D)\md2test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\md4test.exe: $(OBJ_D)\md4test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\md4test.obj
  $(TEST_D)\md4test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\md5test.exe: $(OBJ_D)\md5test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\md5test.obj
  $(TEST_D)\md5test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\shatest.exe: $(OBJ_D)\shatest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\shatest.obj
  $(TEST_D)\shatest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\sha1test.exe: $(OBJ_D)\sha1test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\sha1test.obj
  $(TEST_D)\sha1test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\mdc2test.exe: $(OBJ_D)\mdc2test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\mdc2test.obj
  $(TEST_D)\mdc2test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\hmactest.exe: $(OBJ_D)\hmactest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\hmactest.obj
  $(TEST_D)\hmactest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\rmdtest.exe: $(OBJ_D)\rmdtest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\rmdtest.obj
  $(TEST_D)\rmdtest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\destest.exe: $(OBJ_D)\destest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\destest.obj
  $(TEST_D)\destest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\rc2test.exe: $(OBJ_D)\rc2test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\rc2test.obj
  $(TEST_D)\rc2test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\rc4test.exe: $(OBJ_D)\rc4test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\rc4test.obj
  $(TEST_D)\rc4test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\rc5test.exe: $(OBJ_D)\rc5test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\rc5test.obj
  $(TEST_D)\rc5test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\ideatest.exe: $(OBJ_D)\ideatest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\ideatest.obj
  $(TEST_D)\ideatest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\bftest.exe: $(OBJ_D)\bftest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\bftest.obj
  $(TEST_D)\bftest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\casttest.exe: $(OBJ_D)\casttest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\casttest.obj
  $(TEST_D)\casttest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\bntest.exe: $(OBJ_D)\bntest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\bntest.obj
  $(TEST_D)\bntest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\exptest.exe: $(OBJ_D)\exptest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\exptest.obj
  $(TEST_D)\exptest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\rsa_test.exe: $(OBJ_D)\rsa_test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\rsa_test.obj
  $(TEST_D)\rsa_test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\dsatest.exe: $(OBJ_D)\dsatest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\dsatest.obj
  $(TEST_D)\dsatest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\dhtest.exe: $(OBJ_D)\dhtest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\dhtest.obj
  $(TEST_D)\dhtest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\ectest.exe: $(OBJ_D)\ectest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\ectest.obj
  $(TEST_D)\ectest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\randtest.exe: $(OBJ_D)\randtest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\randtest.obj
  $(TEST_D)\randtest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\evp_test.exe: $(OBJ_D)\evp_test.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\evp_test.obj
  $(TEST_D)\evp_test.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\enginetest.exe: $(OBJ_D)\enginetest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\enginetest.obj
  $(TEST_D)\enginetest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_test_suite.exe: $(OBJ_D)\fips_test_suite.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_test_suite.obj
  $(TEST_D)\fips_test_suite.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_aesavs.exe: $(OBJ_D)\fips_aesavs.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_aesavs.obj
  $(TEST_D)\fips_aesavs.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_desmovs.exe: $(OBJ_D)\fips_desmovs.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_desmovs.obj
  $(TEST_D)\fips_desmovs.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_dsatest.exe: $(OBJ_D)\fips_dsatest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_dsatest.obj
  $(TEST_D)\fips_dsatest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_dssvs.exe: $(OBJ_D)\fips_dssvs.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_dssvs.obj
  $(TEST_D)\fips_dssvs.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_hmactest.exe: $(OBJ_D)\fips_hmactest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_hmactest.obj
  $(TEST_D)\fips_hmactest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_randtest.exe: $(OBJ_D)\fips_randtest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_randtest.obj
  $(TEST_D)\fips_randtest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_rngvs.exe: $(OBJ_D)\fips_rngvs.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_rngvs.obj
  $(TEST_D)\fips_rngvs.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_rsavtest.exe: $(OBJ_D)\fips_rsavtest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_rsavtest.obj
  $(TEST_D)\fips_rsavtest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_rsastest.exe: $(OBJ_D)\fips_rsastest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_rsastest.obj
  $(TEST_D)\fips_rsastest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_rsagtest.exe: $(OBJ_D)\fips_rsagtest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_rsagtest.obj
  $(TEST_D)\fips_rsagtest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\fips_shatest.exe: $(OBJ_D)\fips_shatest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\fips_shatest.obj
  $(TEST_D)\fips_shatest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(TEST_D)\ssltest.exe: $(OBJ_D)\ssltest.obj $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) $(OBJ_D)\ssltest.obj
  $(TEST_D)\ssltest.exe

  $(L_LIBS) $(EX_LIBS)

<<

$(O_SSL): $(SSLOBJ)
	$(LINK) $(MLFLAGS) @<<
  $(SHLIB_EX_OBJ) +
  $(OBJ_D)\bio_ssl.obj +
  $(OBJ_D)\kssl.obj +
  $(OBJ_D)\s23_clnt.obj +
  $(OBJ_D)\s23_lib.obj +
  $(OBJ_D)\s23_meth.obj +
  $(OBJ_D)\s23_pkt.obj +
  $(OBJ_D)\s23_srvr.obj +
  $(OBJ_D)\s2_clnt.obj +
  $(OBJ_D)\s2_enc.obj +
  $(OBJ_D)\s2_lib.obj +
  $(OBJ_D)\s2_meth.obj +
  $(OBJ_D)\s2_pkt.obj +
  $(OBJ_D)\s2_srvr.obj +
  $(OBJ_D)\s3_both.obj +
  $(OBJ_D)\s3_clnt.obj +
  $(OBJ_D)\s3_enc.obj +
  $(OBJ_D)\s3_lib.obj +
  $(OBJ_D)\s3_meth.obj +
  $(OBJ_D)\s3_pkt.obj +
  $(OBJ_D)\s3_srvr.obj +
  $(OBJ_D)\ssl_algs.obj +
  $(OBJ_D)\ssl_asn1.obj +
  $(OBJ_D)\ssl_cert.obj +
  $(OBJ_D)\ssl_ciph.obj +
  $(OBJ_D)\ssl_err.obj +
  $(OBJ_D)\ssl_err2.obj +
  $(OBJ_D)\ssl_lib.obj +
  $(OBJ_D)\ssl_rsa.obj +
  $(OBJ_D)\ssl_sess.obj +
  $(OBJ_D)\ssl_stat.obj +
  $(OBJ_D)\ssl_txt.obj +
  $(OBJ_D)\t1_clnt.obj +
  $(OBJ_D)\t1_enc.obj +
  $(OBJ_D)\t1_lib.obj +
  $(OBJ_D)\t1_meth.obj +
  $(OBJ_D)\t1_srvr.obj +

  $(O_SSL)

  $(L_CRYPTO) winsock oldnames ldllcew libw
ms\ssleay16.def;
<<
	implib /noignorecase /nowep $(L_SSL) $(O_SSL)

$(O_CRYPTO): $(CRYPTOOBJ)
	$(LINK) $(MLFLAGS) @<<
  $(SHLIB_EX_OBJ) +
  $(BN_ASM_OBJ) +
  $(OBJ_D)\a_bitstr.obj +
  $(OBJ_D)\a_bool.obj +
  $(OBJ_D)\a_bytes.obj +
  $(OBJ_D)\a_d2i_fp.obj +
  $(OBJ_D)\a_digest.obj +
  $(OBJ_D)\a_dup.obj +
  $(OBJ_D)\a_enum.obj +
  $(OBJ_D)\a_gentm.obj +
  $(OBJ_D)\a_hdr.obj +
  $(OBJ_D)\a_i2d_fp.obj +
  $(OBJ_D)\a_int.obj +
  $(OBJ_D)\a_mbstr.obj +
  $(OBJ_D)\a_meth.obj +
  $(OBJ_D)\a_object.obj +
  $(OBJ_D)\a_octet.obj +
  $(OBJ_D)\a_print.obj +
  $(OBJ_D)\a_set.obj +
  $(OBJ_D)\a_sign.obj +
  $(OBJ_D)\a_strex.obj +
  $(OBJ_D)\a_strnid.obj +
  $(OBJ_D)\a_time.obj +
  $(OBJ_D)\a_type.obj +
  $(OBJ_D)\a_utctm.obj +
  $(OBJ_D)\a_utf8.obj +
  $(OBJ_D)\a_verify.obj +
  $(OBJ_D)\aes_cbc.obj +
  $(OBJ_D)\aes_cfb.obj +
  $(OBJ_D)\aes_core.obj +
  $(OBJ_D)\aes_ctr.obj +
  $(OBJ_D)\aes_ecb.obj +
  $(OBJ_D)\aes_misc.obj +
  $(OBJ_D)\aes_ofb.obj +
  $(OBJ_D)\asn1_err.obj +
  $(OBJ_D)\asn1_lib.obj +
  $(OBJ_D)\asn1_par.obj +
  $(OBJ_D)\asn_moid.obj +
  $(OBJ_D)\asn_pack.obj +
  $(OBJ_D)\b_dump.obj +
  $(OBJ_D)\b_print.obj +
  $(OBJ_D)\b_sock.obj +
  $(OBJ_D)\bf_buff.obj +
  $(OBJ_D)\bf_cfb64.obj +
  $(OBJ_D)\bf_ecb.obj +
  $(OBJ_D)\bf_enc.obj +
  $(OBJ_D)\bf_nbio.obj +
  $(OBJ_D)\bf_null.obj +
  $(OBJ_D)\bf_ofb64.obj +
  $(OBJ_D)\bf_skey.obj +
  $(OBJ_D)\bio_b64.obj +
  $(OBJ_D)\bio_cb.obj +
  $(OBJ_D)\bio_enc.obj +
  $(OBJ_D)\bio_err.obj +
  $(OBJ_D)\bio_lib.obj +
  $(OBJ_D)\bio_md.obj +
  $(OBJ_D)\bio_ok.obj +
  $(OBJ_D)\bn_add.obj +
  $(OBJ_D)\bn_blind.obj +
  $(OBJ_D)\bn_ctx.obj +
  $(OBJ_D)\bn_div.obj +
  $(OBJ_D)\bn_err.obj +
  $(OBJ_D)\bn_exp.obj +
  $(OBJ_D)\bn_exp2.obj +
  $(OBJ_D)\bn_gcd.obj +
  $(OBJ_D)\bn_kron.obj +
  $(OBJ_D)\bn_lib.obj +
  $(OBJ_D)\bn_mod.obj +
  $(OBJ_D)\bn_mont.obj +
  $(OBJ_D)\bn_mpi.obj +
  $(OBJ_D)\bn_mul.obj +
  $(OBJ_D)\bn_prime.obj +
  $(OBJ_D)\bn_print.obj +
  $(OBJ_D)\bn_rand.obj +
  $(OBJ_D)\bn_recp.obj +
  $(OBJ_D)\bn_shift.obj +
  $(OBJ_D)\bn_sqr.obj +
  $(OBJ_D)\bn_sqrt.obj +
  $(OBJ_D)\bn_word.obj +
  $(OBJ_D)\bn_x931p.obj +
  $(OBJ_D)\bss_acpt.obj +
  $(OBJ_D)\bss_bio.obj +
  $(OBJ_D)\bss_conn.obj +
  $(OBJ_D)\bss_fd.obj +
  $(OBJ_D)\bss_file.obj +
  $(OBJ_D)\bss_log.obj +
  $(OBJ_D)\bss_mem.obj +
  $(OBJ_D)\bss_null.obj +
  $(OBJ_D)\bss_sock.obj +
  $(OBJ_D)\buf_err.obj +
  $(OBJ_D)\buffer.obj +
  $(OBJ_D)\by_dir.obj +
  $(OBJ_D)\by_file.obj +
  $(OBJ_D)\c_all.obj +
  $(OBJ_D)\c_allc.obj +
  $(OBJ_D)\c_alld.obj +
  $(OBJ_D)\c_cfb64.obj +
  $(OBJ_D)\c_ecb.obj +
  $(OBJ_D)\c_enc.obj +
  $(OBJ_D)\c_ofb64.obj +
  $(OBJ_D)\c_rle.obj +
  $(OBJ_D)\c_skey.obj +
  $(OBJ_D)\c_zlib.obj +
  $(OBJ_D)\cbc_cksm.obj +
  $(OBJ_D)\cbc_enc.obj +
  $(OBJ_D)\cfb64ede.obj +
  $(OBJ_D)\cfb64enc.obj +
  $(OBJ_D)\cfb_enc.obj +
  $(OBJ_D)\comp_err.obj +
  $(OBJ_D)\comp_lib.obj +
  $(OBJ_D)\conf_api.obj +
  $(OBJ_D)\conf_def.obj +
  $(OBJ_D)\conf_err.obj +
  $(OBJ_D)\conf_lib.obj +
  $(OBJ_D)\conf_mall.obj +
  $(OBJ_D)\conf_mod.obj +
  $(OBJ_D)\conf_sap.obj +
  $(OBJ_D)\cpt_err.obj +
  $(OBJ_D)\cryptlib.obj +
  $(OBJ_D)\cversion.obj +
  $(OBJ_D)\d2i_pr.obj +
  $(OBJ_D)\d2i_pu.obj +
  $(OBJ_D)\des_enc.obj +
  $(OBJ_D)\des_old.obj +
  $(OBJ_D)\des_old2.obj +
  $(OBJ_D)\dh_asn1.obj +
  $(OBJ_D)\dh_check.obj +
  $(OBJ_D)\dh_err.obj +
  $(OBJ_D)\dh_gen.obj +
  $(OBJ_D)\dh_key.obj +
  $(OBJ_D)\dh_lib.obj +
  $(OBJ_D)\digest.obj +
  $(OBJ_D)\dsa_asn1.obj +
  $(OBJ_D)\dsa_err.obj +
  $(OBJ_D)\dsa_gen.obj +
  $(OBJ_D)\dsa_key.obj +
  $(OBJ_D)\dsa_lib.obj +
  $(OBJ_D)\dsa_ossl.obj +
  $(OBJ_D)\dsa_sign.obj +
  $(OBJ_D)\dsa_vrf.obj +
  $(OBJ_D)\dso_dl.obj +
  $(OBJ_D)\dso_dlfcn.obj +
  $(OBJ_D)\dso_err.obj +
  $(OBJ_D)\dso_lib.obj +
  $(OBJ_D)\dso_null.obj +
  $(OBJ_D)\dso_openssl.obj +
  $(OBJ_D)\dso_vms.obj +
  $(OBJ_D)\dso_win32.obj +
  $(OBJ_D)\e_aes.obj +
  $(OBJ_D)\e_bf.obj +
  $(OBJ_D)\e_cast.obj +
  $(OBJ_D)\e_des.obj +
  $(OBJ_D)\e_des3.obj +
  $(OBJ_D)\e_idea.obj +
  $(OBJ_D)\e_null.obj +
  $(OBJ_D)\e_old.obj +
  $(OBJ_D)\e_rc2.obj +
  $(OBJ_D)\e_rc4.obj +
  $(OBJ_D)\e_rc5.obj +
  $(OBJ_D)\e_xcbc_d.obj +
  $(OBJ_D)\ebcdic.obj +
  $(OBJ_D)\ec_cvt.obj +
  $(OBJ_D)\ec_err.obj +
  $(OBJ_D)\ec_lib.obj +
  $(OBJ_D)\ec_mult.obj +
  $(OBJ_D)\ecb3_enc.obj +
  $(OBJ_D)\ecb_enc.obj +
  $(OBJ_D)\ecp_mont.obj +
  $(OBJ_D)\ecp_nist.obj +
  $(OBJ_D)\ecp_recp.obj +
  $(OBJ_D)\ecp_smpl.obj +
  $(OBJ_D)\ede_cbcm_enc.obj +
  $(OBJ_D)\enc_read.obj +
  $(OBJ_D)\enc_writ.obj +
  $(OBJ_D)\encode.obj +
  $(OBJ_D)\eng_all.obj +
  $(OBJ_D)\eng_cnf.obj +
  $(OBJ_D)\eng_ctrl.obj +
  $(OBJ_D)\eng_dyn.obj +
  $(OBJ_D)\eng_err.obj +
  $(OBJ_D)\eng_fat.obj +
  $(OBJ_D)\eng_init.obj +
  $(OBJ_D)\eng_lib.obj +
  $(OBJ_D)\eng_list.obj +
  $(OBJ_D)\eng_openssl.obj +
  $(OBJ_D)\eng_pkey.obj +
  $(OBJ_D)\eng_table.obj +
  $(OBJ_D)\err.obj +
  $(OBJ_D)\err_all.obj +
  $(OBJ_D)\err_prn.obj +
  $(OBJ_D)\evp_acnf.obj +
  $(OBJ_D)\evp_asn1.obj +
  $(OBJ_D)\evp_enc.obj +
  $(OBJ_D)\evp_err.obj +
  $(OBJ_D)\evp_key.obj +
  $(OBJ_D)\evp_lib.obj +
  $(OBJ_D)\evp_pbe.obj +
  $(OBJ_D)\evp_pkey.obj +
  $(OBJ_D)\ex_data.obj +
  $(OBJ_D)\f_enum.obj +
  $(OBJ_D)\f_int.obj +
  $(OBJ_D)\f_string.obj +
  $(OBJ_D)\fcrypt.obj +
  $(OBJ_D)\fcrypt_b.obj +
  $(OBJ_D)\fips.obj +
  $(OBJ_D)\fips_aes_core.obj +
  $(OBJ_D)\fips_aes_selftest.obj +
  $(OBJ_D)\fips_des_enc.obj +
  $(OBJ_D)\fips_des_selftest.obj +
  $(OBJ_D)\fips_dh_check.obj +
  $(OBJ_D)\fips_dh_gen.obj +
  $(OBJ_D)\fips_dh_key.obj +
  $(OBJ_D)\fips_dsa_gen.obj +
  $(OBJ_D)\fips_dsa_ossl.obj +
  $(OBJ_D)\fips_dsa_selftest.obj +
  $(OBJ_D)\fips_err_wrapper.obj +
  $(OBJ_D)\fips_hmac.obj +
  $(OBJ_D)\fips_hmac_selftest.obj +
  $(OBJ_D)\fips_rand.obj +
  $(OBJ_D)\fips_rand_selftest.obj +
  $(OBJ_D)\fips_rsa_eay.obj +
  $(OBJ_D)\fips_rsa_gen.obj +
  $(OBJ_D)\fips_rsa_selftest.obj +
  $(OBJ_D)\fips_rsa_x931g.obj +
  $(OBJ_D)\fips_set_key.obj +
  $(OBJ_D)\fips_sha1_selftest.obj +
  $(OBJ_D)\fips_sha1dgst.obj +
  $(OBJ_D)\fips_sha256.obj +
  $(OBJ_D)\fips_sha512.obj +
  $(OBJ_D)\hmac.obj +
  $(OBJ_D)\hw_4758_cca.obj +
  $(OBJ_D)\hw_aep.obj +
  $(OBJ_D)\hw_atalla.obj +
  $(OBJ_D)\hw_cryptodev.obj +
  $(OBJ_D)\hw_cswift.obj +
  $(OBJ_D)\hw_ncipher.obj +
  $(OBJ_D)\hw_nuron.obj +
  $(OBJ_D)\hw_sureware.obj +
  $(OBJ_D)\hw_ubsec.obj +
  $(OBJ_D)\i2d_pr.obj +
  $(OBJ_D)\i2d_pu.obj +
  $(OBJ_D)\i_cbc.obj +
  $(OBJ_D)\i_cfb64.obj +
  $(OBJ_D)\i_ecb.obj +
  $(OBJ_D)\i_ofb64.obj +
  $(OBJ_D)\i_skey.obj +
  $(OBJ_D)\krb5_asn.obj +
  $(OBJ_D)\lh_stats.obj +
  $(OBJ_D)\lhash.obj +
  $(OBJ_D)\m_dss.obj +
  $(OBJ_D)\m_dss1.obj +
  $(OBJ_D)\m_md2.obj +
  $(OBJ_D)\m_md4.obj +
  $(OBJ_D)\m_md5.obj +
  $(OBJ_D)\m_mdc2.obj +
  $(OBJ_D)\m_null.obj +
  $(OBJ_D)\m_ripemd.obj +
  $(OBJ_D)\m_sha.obj +
  $(OBJ_D)\m_sha1.obj +
  $(OBJ_D)\md2_dgst.obj +
  $(OBJ_D)\md2_one.obj +
  $(OBJ_D)\md4_dgst.obj +
  $(OBJ_D)\md4_one.obj +
  $(OBJ_D)\md5_dgst.obj +
  $(OBJ_D)\md5_one.obj +
  $(OBJ_D)\md_rand.obj +
  $(OBJ_D)\mdc2_one.obj +
  $(OBJ_D)\mdc2dgst.obj +
  $(OBJ_D)\mem.obj +
  $(OBJ_D)\mem_clr.obj +
  $(OBJ_D)\mem_dbg.obj +
  $(OBJ_D)\n_pkey.obj +
  $(OBJ_D)\names.obj +
  $(OBJ_D)\nsseq.obj +
  $(OBJ_D)\o_names.obj +
  $(OBJ_D)\o_str.obj +
  $(OBJ_D)\o_time.obj +
  $(OBJ_D)\obj_dat.obj +
  $(OBJ_D)\obj_err.obj +
  $(OBJ_D)\obj_lib.obj +
  $(OBJ_D)\ocsp_asn.obj +
  $(OBJ_D)\ocsp_cl.obj +
  $(OBJ_D)\ocsp_err.obj +
  $(OBJ_D)\ocsp_ext.obj +
  $(OBJ_D)\ocsp_ht.obj +
  $(OBJ_D)\ocsp_lib.obj +
  $(OBJ_D)\ocsp_prn.obj +
  $(OBJ_D)\ocsp_srv.obj +
  $(OBJ_D)\ocsp_vfy.obj +
  $(OBJ_D)\ofb64ede.obj +
  $(OBJ_D)\ofb64enc.obj +
  $(OBJ_D)\ofb_enc.obj +
  $(OBJ_D)\p12_add.obj +
  $(OBJ_D)\p12_asn.obj +
  $(OBJ_D)\p12_attr.obj +
  $(OBJ_D)\p12_crpt.obj +
  $(OBJ_D)\p12_crt.obj +
  $(OBJ_D)\p12_decr.obj +
  $(OBJ_D)\p12_init.obj +
  $(OBJ_D)\p12_key.obj +
  $(OBJ_D)\p12_kiss.obj +
  $(OBJ_D)\p12_mutl.obj +
  $(OBJ_D)\p12_npas.obj +
  $(OBJ_D)\p12_p8d.obj +
  $(OBJ_D)\p12_p8e.obj +
  $(OBJ_D)\p12_utl.obj +
  $(OBJ_D)\p5_crpt.obj +
  $(OBJ_D)\p5_crpt2.obj +
  $(OBJ_D)\p5_pbe.obj +
  $(OBJ_D)\p5_pbev2.obj +
  $(OBJ_D)\p8_pkey.obj +
  $(OBJ_D)\p_dec.obj +
  $(OBJ_D)\p_enc.obj +
  $(OBJ_D)\p_lib.obj +
  $(OBJ_D)\p_open.obj +
  $(OBJ_D)\p_seal.obj +
  $(OBJ_D)\p_sign.obj +
  $(OBJ_D)\p_verify.obj +
  $(OBJ_D)\pcbc_enc.obj +
  $(OBJ_D)\pem_all.obj +
  $(OBJ_D)\pem_err.obj +
  $(OBJ_D)\pem_info.obj +
  $(OBJ_D)\pem_lib.obj +
  $(OBJ_D)\pem_oth.obj +
  $(OBJ_D)\pem_pk8.obj +
  $(OBJ_D)\pem_pkey.obj +
  $(OBJ_D)\pem_seal.obj +
  $(OBJ_D)\pem_sign.obj +
  $(OBJ_D)\pem_x509.obj +
  $(OBJ_D)\pem_xaux.obj +
  $(OBJ_D)\pk12err.obj +
  $(OBJ_D)\pk7_asn1.obj +
  $(OBJ_D)\pk7_attr.obj +
  $(OBJ_D)\pk7_doit.obj +
  $(OBJ_D)\pk7_lib.obj +
  $(OBJ_D)\pk7_mime.obj +
  $(OBJ_D)\pk7_smime.obj +
  $(OBJ_D)\pkcs7err.obj +
  $(OBJ_D)\qud_cksm.obj +
  $(OBJ_D)\rand_egd.obj +
  $(OBJ_D)\rand_err.obj +
  $(OBJ_D)\rand_key.obj +
  $(OBJ_D)\rand_lib.obj +
  $(OBJ_D)\rand_os2.obj +
  $(OBJ_D)\rand_unix.obj +
  $(OBJ_D)\rand_win.obj +
  $(OBJ_D)\randfile.obj +
  $(OBJ_D)\rc2_cbc.obj +
  $(OBJ_D)\rc2_ecb.obj +
  $(OBJ_D)\rc2_skey.obj +
  $(OBJ_D)\rc2cfb64.obj +
  $(OBJ_D)\rc2ofb64.obj +
  $(OBJ_D)\rc4_enc.obj +
  $(OBJ_D)\rc4_skey.obj +
  $(OBJ_D)\rc5_ecb.obj +
  $(OBJ_D)\rc5_enc.obj +
  $(OBJ_D)\rc5_skey.obj +
  $(OBJ_D)\rc5cfb64.obj +
  $(OBJ_D)\rc5ofb64.obj +
  $(OBJ_D)\read2pwd.obj +
  $(OBJ_D)\rmd_dgst.obj +
  $(OBJ_D)\rmd_one.obj +
  $(OBJ_D)\rpc_enc.obj +
  $(OBJ_D)\rsa_asn1.obj +
  $(OBJ_D)\rsa_chk.obj +
  $(OBJ_D)\rsa_eay.obj +
  $(OBJ_D)\rsa_err.obj +
  $(OBJ_D)\rsa_gen.obj +
  $(OBJ_D)\rsa_lib.obj +
  $(OBJ_D)\rsa_none.obj +
  $(OBJ_D)\rsa_null.obj +
  $(OBJ_D)\rsa_oaep.obj +
  $(OBJ_D)\rsa_pk1.obj +
  $(OBJ_D)\rsa_pss.obj +
  $(OBJ_D)\rsa_saos.obj +
  $(OBJ_D)\rsa_sign.obj +
  $(OBJ_D)\rsa_ssl.obj +
  $(OBJ_D)\rsa_x931.obj +
  $(OBJ_D)\set_key.obj +
  $(OBJ_D)\sha1_one.obj +
  $(OBJ_D)\sha1dgst.obj +
  $(OBJ_D)\sha_dgst.obj +
  $(OBJ_D)\sha_one.obj +
  $(OBJ_D)\stack.obj +
  $(OBJ_D)\str2key.obj +
  $(OBJ_D)\t_bitst.obj +
  $(OBJ_D)\t_crl.obj +
  $(OBJ_D)\t_pkey.obj +
  $(OBJ_D)\t_req.obj +
  $(OBJ_D)\t_spki.obj +
  $(OBJ_D)\t_x509.obj +
  $(OBJ_D)\t_x509a.obj +
  $(OBJ_D)\tasn_dec.obj +
  $(OBJ_D)\tasn_enc.obj +
  $(OBJ_D)\tasn_fre.obj +
  $(OBJ_D)\tasn_new.obj +
  $(OBJ_D)\tasn_typ.obj +
  $(OBJ_D)\tasn_utl.obj +
  $(OBJ_D)\tb_cipher.obj +
  $(OBJ_D)\tb_dh.obj +
  $(OBJ_D)\tb_digest.obj +
  $(OBJ_D)\tb_dsa.obj +
  $(OBJ_D)\tb_rand.obj +
  $(OBJ_D)\tb_rsa.obj +
  $(OBJ_D)\tmdiff.obj +
  $(OBJ_D)\txt_db.obj +
  $(OBJ_D)\ui_compat.obj +
  $(OBJ_D)\ui_err.obj +
  $(OBJ_D)\ui_lib.obj +
  $(OBJ_D)\ui_openssl.obj +
  $(OBJ_D)\ui_util.obj +
  $(OBJ_D)\uid.obj +
  $(OBJ_D)\v3_akey.obj +
  $(OBJ_D)\v3_akeya.obj +
  $(OBJ_D)\v3_alt.obj +
  $(OBJ_D)\v3_bcons.obj +
  $(OBJ_D)\v3_bitst.obj +
  $(OBJ_D)\v3_conf.obj +
  $(OBJ_D)\v3_cpols.obj +
  $(OBJ_D)\v3_crld.obj +
  $(OBJ_D)\v3_enum.obj +
  $(OBJ_D)\v3_extku.obj +
  $(OBJ_D)\v3_genn.obj +
  $(OBJ_D)\v3_ia5.obj +
  $(OBJ_D)\v3_info.obj +
  $(OBJ_D)\v3_int.obj +
  $(OBJ_D)\v3_lib.obj +
  $(OBJ_D)\v3_ocsp.obj +
  $(OBJ_D)\v3_pci.obj +
  $(OBJ_D)\v3_pcia.obj +
  $(OBJ_D)\v3_pku.obj +
  $(OBJ_D)\v3_prn.obj +
  $(OBJ_D)\v3_purp.obj +
  $(OBJ_D)\v3_skey.obj +
  $(OBJ_D)\v3_sxnet.obj +
  $(OBJ_D)\v3_utl.obj +
  $(OBJ_D)\v3err.obj +
  $(OBJ_D)\x509_att.obj +
  $(OBJ_D)\x509_cmp.obj +
  $(OBJ_D)\x509_d2.obj +
  $(OBJ_D)\x509_def.obj +
  $(OBJ_D)\x509_err.obj +
  $(OBJ_D)\x509_ext.obj +
  $(OBJ_D)\x509_lu.obj +
  $(OBJ_D)\x509_obj.obj +
  $(OBJ_D)\x509_r2x.obj +
  $(OBJ_D)\x509_req.obj +
  $(OBJ_D)\x509_set.obj +
  $(OBJ_D)\x509_trs.obj +
  $(OBJ_D)\x509_txt.obj +
  $(OBJ_D)\x509_v3.obj +
  $(OBJ_D)\x509_vfy.obj +
  $(OBJ_D)\x509cset.obj +
  $(OBJ_D)\x509name.obj +
  $(OBJ_D)\x509rset.obj +
  $(OBJ_D)\x509spki.obj +
  $(OBJ_D)\x509type.obj +
  $(OBJ_D)\x_algor.obj +
  $(OBJ_D)\x_all.obj +
  $(OBJ_D)\x_attrib.obj +
  $(OBJ_D)\x_bignum.obj +
  $(OBJ_D)\x_crl.obj +
  $(OBJ_D)\x_exten.obj +
  $(OBJ_D)\x_info.obj +
  $(OBJ_D)\x_long.obj +
  $(OBJ_D)\x_name.obj +
  $(OBJ_D)\x_pkey.obj +
  $(OBJ_D)\x_pubkey.obj +
  $(OBJ_D)\x_req.obj +
  $(OBJ_D)\x_sig.obj +
  $(OBJ_D)\x_spki.obj +
  $(OBJ_D)\x_val.obj +
  $(OBJ_D)\x_x509.obj +
  $(OBJ_D)\x_x509a.obj +
  $(OBJ_D)\xcbc_enc.obj +

  $(O_CRYPTO)

   winsock oldnames ldllcew libw
ms\libeay16.def;
<<
	implib /noignorecase /nowep $(L_CRYPTO) $(O_CRYPTO)

$(BIN_D)\$(E_EXE).exe: $(E_OBJ) $(LIBS_DEP)
  $(LINK) $(LFLAGS) @<<
  $(APP_EX_OBJ) +
  $(OBJ_D)\app_rand.obj +
  $(OBJ_D)\apps.obj +
  $(OBJ_D)\asn1pars.obj +
  $(OBJ_D)\ca.obj +
  $(OBJ_D)\ciphers.obj +
  $(OBJ_D)\crl.obj +
  $(OBJ_D)\crl2p7.obj +
  $(OBJ_D)\dgst.obj +
  $(OBJ_D)\dh.obj +
  $(OBJ_D)\dhparam.obj +
  $(OBJ_D)\dsa.obj +
  $(OBJ_D)\dsaparam.obj +
  $(OBJ_D)\enc.obj +
  $(OBJ_D)\engine.obj +
  $(OBJ_D)\errstr.obj +
  $(OBJ_D)\gendh.obj +
  $(OBJ_D)\gendsa.obj +
  $(OBJ_D)\genrsa.obj +
  $(OBJ_D)\nseq.obj +
  $(OBJ_D)\ocsp.obj +
  $(OBJ_D)\openssl.obj +
  $(OBJ_D)\passwd.obj +
  $(OBJ_D)\pkcs12.obj +
  $(OBJ_D)\pkcs7.obj +
  $(OBJ_D)\pkcs8.obj +
  $(OBJ_D)\prime.obj +
  $(OBJ_D)\rand.obj +
  $(OBJ_D)\req.obj +
  $(OBJ_D)\rsa.obj +
  $(OBJ_D)\rsautl.obj +
  $(OBJ_D)\s_cb.obj +
  $(OBJ_D)\s_client.obj +
  $(OBJ_D)\s_server.obj +
  $(OBJ_D)\s_socket.obj +
  $(OBJ_D)\s_time.obj +
  $(OBJ_D)\sess_id.obj +
  $(OBJ_D)\smime.obj +
  $(OBJ_D)\speed.obj +
  $(OBJ_D)\spkac.obj +
  $(OBJ_D)\verify.obj +
  $(OBJ_D)\version.obj +
  $(OBJ_D)\x509.obj +

  $(BIN_D)\$(E_EXE).exe

  $(L_LIBS) $(EX_LIBS)

<<

